//.b 	
//	Copyright 2001 [MEAN].BOT
//	
//	File: MA_Bot.cpp
//	
//	[MEAN] Interface Wrapper for the Bots.
//
//.e	

#include "MB_Includes.h"	
#include "MG_Lib.h"
#include "MA_Bot.h"
#include "MA_EngDLLCmd.h"
#include "MI_Sound.h"
#include "MI_player.h"
#include "MA_GlobalVars.h"
#include "MI_Hud.h"
#include "MA_BotControl.h"

// Create instance of bot wrapper object.
	tclBot vclBot; 

	// ===========================================================
	// Event Functions
	// ===========================================================

	void fvoMA_BOT_Event_fvoDisplayBotTeam( tclArgList& pclArgList )
	{
		string vtxMsg = ctxMsgPrefix;

		int vinBotTeam = vclBot.finGetBotTeam( );

		if ( vinBotTeam == cinTeam_TE )
			vtxMsg += "Bot team is terrorist. ";
		else
		if ( vinBotTeam == cinTeam_CT )
			vtxMsg += "Bot team is counter-terrorist. ";
		else
			vtxMsg += "Bot team is not specified. ";

		if ( vclBot.vboEnforceBotTeam == false )
			vtxMsg += "Enforcement is not enabled.";
		else
			vtxMsg += "Enforcement is enabled.";

		vclHUD.fvoStatusSay( vtxMsg );

		int vinCount = pclArgList.finGetArg_Short( 0 );
		int vinDelay = pclArgList.finGetArg_Short( 1 );
		
		if ( --vinCount <= 0 )
			return;

		if ( vclEventSched.fboCreateEvent( ) )
		{
			vclEventSched.fvoSetEventFunc( fvoMA_BOT_Event_fvoDisplayBotTeam );
			vclEventSched.fboCreateArgList( 2 );
			vclEventSched.fvoSetArg_Short( 0, vinCount );
			vclEventSched.fvoSetArg_Short( 1, vinDelay );
			vclEventSched.fvoSetDelayInSecs( vinDelay );
			vclEventSched.fboSendEvent( );
		}

	} // fvoMA_BOT_Event_fvoDisplayBotTeam

	void fvoMA_BOT_Event_fvoRandomBotSpeak( tclArgList& pclArgList )
	{
		short vinMaxDelay = pclArgList.finGetArg_Short( 0 );
		short vinNextSpeak = finRandom( 1, vinMaxDelay );
		vclBot.fboBotSpeak( );

		if ( vclEventSched.fboCreateEvent( ) )
		{
			vclEventSched.fvoSetEventFunc( fvoMA_BOT_Event_fvoRandomBotSpeak );
			vclEventSched.fboCreateArgList( 1 );
			vclEventSched.fvoSetArg_Short( 0, vinMaxDelay );
			vclEventSched.fvoSetDelayInSecs( vinNextSpeak );
			vclEventSched.fboSendEvent( );
		}

	} // fvoMA_BOT_Event_fvoRandomBotSpeak

	void fvoMA_Bot_Event_AutoKillBots( tclArgList& pclArgList )
	{

//		vclDebugTrace.fvoWriteEventInfo( "DEBUG (fvoMA_Bot_Event_AutoKillBots) Event Trigger" );
//		vclDebugTrace.fvoWriteEventInfo( "DEBUG (fvoMA_Bot_Event_AutoKillBots) fboAutoKillAllBots: " + ftxBoolToString( vclBot.fboAutoKillAllBotsIsOn( ) ) );
//		vclDebugTrace.fvoWriteEventInfo( "DEBUG (fvoMA_Bot_Event_AutoKillBots) fboGameFullyLoaded: " + ftxBoolToString( vclInterfaceL1.fboGameIsFullyLoaded( ) ) );
//		vclDebugTrace.fvoWriteEventInfo( "DEBUG (fvoMA_Bot_Event_AutoKillBots) vboBotsInGame     : " + ftxBoolToString( vclBot.vboBotsInGame ) );

		if (  vclBot.fboAutoKillAllBotsIsOn( ) 
					&& 
			   vclInterfaceL1.fboGameIsFullyLoaded( ) 
					&& 
			   vclBot.fboBotsInGame( )
					&&
			   !vclBot.fboBombWasPlanted( )
					&&
			   !vclBot.fboHostagesAreBeingRescued( ) )
		{

			int vinAliveBots_TE;
			int vinAliveBots_CT;
			int vinDeadHumans;
			int vinAliveHumans;

			vclPlayer.fvoCountAliveDead(	
				vinAliveBots_TE, vinAliveBots_CT, vinDeadHumans, vinAliveHumans );

//			vclDebugTrace.fvoWriteEventInfo( "DEBUG (fvoMA_Bot_Event_AutoKillBots) vinAliveBots_TE   : " + ftxIntToString( vinAliveBots_TE ) );
//			vclDebugTrace.fvoWriteEventInfo( "DEBUG (fvoMA_Bot_Event_AutoKillBots) vinAliveBots_CT   : " + ftxIntToString( vinAliveBots_CT ) );

			if ( ( vinAliveBots_TE > 0 ) && ( vinAliveBots_CT > 0 ) )
			{
//				vclDebugTrace.fvoWriteEventInfo( "DEBUG (fvoMA_Bot_Event_AutoKillBots) vinDeadHumans     : " + ftxIntToString( vinDeadHumans ) );
//				vclDebugTrace.fvoWriteEventInfo( "DEBUG (fvoMA_Bot_Event_AutoKillBots) vinAliveHumans    : " + ftxIntToString( vinAliveHumans ) );

				if ( ( vinDeadHumans > 0 ) && ( vinAliveHumans <= 0 ) )
				{
					if ( vinAliveBots_TE > vinAliveBots_CT )
						vclBot.finKillAllBots( cinTeam_CT, /* suicide = */ false );
					else
					if ( vinAliveBots_TE < vinAliveBots_CT )
						vclBot.finKillAllBots( cinTeam_TE, /* suicide = */ false );
					else
						vclBot.finKillAllBots( cinTeam_Any, /* suicide = */ false );
				}
			}
		}

		// repeat;
		vclEventSched.fboCreateEvent( ); 
		vclEventSched.fvoSetEventFunc( fvoMA_Bot_Event_AutoKillBots );
		// make delay random to offset other time consuming events;
		vclEventSched.fvoSetDelayInSecs( 5 + finRandom( 0, 3 ) );
		vclEventSched.fboSendEvent( );

	} // fvoMA_Bot_Event_AutoKillBots

	void fvoMA_Bot_Event_AutoKillBots_Start(  )
	{
		vclEventSched.fboCreateEvent( ); 
		vclEventSched.fvoSetEventFunc( fvoMA_Bot_Event_AutoKillBots );
		vclEventSched.fvoSetDelayInSecs( 5 );
		vclEventSched.fboSendEvent( );
	} // fvoMA_Bot_Event_AutoKillBots_Start

	void fvoMA_BOT_Event_fvoCheckStatsProtection( tclArgList& pclArgList )
	{
		//!!.begin - ONLY set here

		bool vboBotsInGame_Prev = vclBot.fboBotsInGame( );
		vclBot.fvoSetBotsInGame( vclPlayer.fboBotsInGame( ) );

		if ( ( vboBotsInGame_Prev == true ) && ( vclBot.fboBotsInGame( ) == false ) )
			fvoServerPrint_nl( ctxMsgPrefix + "All bots have left the game." );
		else
		if ( ( vboBotsInGame_Prev == false ) && ( vclBot.fboBotsInGame( ) == true ) )
			fvoServerPrint_nl( ctxMsgPrefix + "Bots have joined the game." );
 
		//!!.end - ONLY set here

		short vinDelay = pclArgList.finGetArg_Short( 0 );
		vclBot.fvoCheckStatsProtection( );

		if ( vclEventSched.fboCreateEvent( ) )
		{
			vclEventSched.fvoSetEventFunc( fvoMA_BOT_Event_fvoCheckStatsProtection );
			vclEventSched.fboCreateArgList( 1 );
			vclEventSched.fvoSetArg_Short( 0, vinDelay );
			vclEventSched.fvoSetDelayInSecs( vinDelay ); 
			vclEventSched.fboSendEvent( );
		}

		//.!! should not be in here

		vclBot.vboBotHitEffectIsOn = fboCVarGetBool( ctxCVar_BotDamageAffects );
		vclBot.vboBotHitSoundsIsOn = fboCVarGetBool( ctxCVar_BotsMakeDamageSounds );
		vclBot.vboBotHitSparksIsOn = fboCVarGetBool( ctxCVar_BotsThrowSparks );

	} // fvoMA_BOT_Event_fvoCheckStatsProtection

	void fvoMA_BOT_Event_fvoCheckPODBotFixProtection( tclArgList& pclArgList )
	{
		short vinDelay = pclArgList.finGetArg_Short( 0 );
		vclBot.fvoCheckPODBotFixProtection( );

		if ( vclEventSched.fboCreateEvent( ) )
		{
			vclEventSched.fvoSetEventFunc( fvoMA_BOT_Event_fvoCheckPODBotFixProtection );
			vclEventSched.fboCreateArgList( 1 );
			vclEventSched.fvoSetArg_Short( 0, vinDelay );
			vclEventSched.fvoSetDelayInSecs( vinDelay ); 
			vclEventSched.fboSendEvent( );
		}

	} // fvoMA_BOT_Event_fvoCheckPODBotFixProtection

	void fvoMA_BOT_Event_fvoKickDupBots( tclArgList& pclArgList )
	{
		short vinDelay = pclArgList.finGetArg_Short( 0 );
		int vinKicked = vclBot.finRemoveDupNamedBots( );

		if ( vinKicked > 0 )
			fvoServerPrint_nl( ctxMsgPrefix + "Kicked " + ftxIntToString( vinKicked ) + " bots with identical names." );

		if ( vclEventSched.fboCreateEvent( ) )
		{
			vclEventSched.fvoSetEventFunc( fvoMA_BOT_Event_fvoKickDupBots );
			vclEventSched.fboCreateArgList( 1 );
			vclEventSched.fvoSetArg_Short( 0, vinDelay );
			vclEventSched.fvoSetDelayInSecs( vinDelay ); 
			vclEventSched.fboSendEvent( );
		}

	} // fvoMA_BOT_Event_fvoKickDupBots

	void fvoMA_BOT_Event_fvoAddBotToTeam( tclArgList& pclArgList )
	{
		int vinBotTeam  = pclArgList.finGetArg_Int( 0 );
		vclBot.fboAddBot( vinBotTeam );
	} // fvoMA_BOT_Event_fvoAddBotToTeam

	void fvoMA_BOT_Event_fvoAddBots( tclArgList& pclArgList )
	{
		int vinNumBots  = pclArgList.finGetArg_Int( "numbots" );
		//int vinNumBots  = pclArgList.finGetArg_Int( 0 );
		vclBot.finAddBots( vinNumBots );
	} // fvoMA_BOT_Event_fvoAddBots

	void fvoMA_BOT_Event_fvoBalanceBots( tclArgList& pclArgList )
	{
		vclBot.fvoBalanceBots( );
		
		int vinInterval = 
			finCVarGetInt_Bounded( 
				ctxCVAR_AutoBalanceInterval, 
				cinAutoBalanceIntervalMin, 
				cinAutoBalanceIntervalMax );

		if ( vclEventSched.fboCreateEvent( ) )
		{
			vclEventSched.fvoSetEventFunc( fvoMA_BOT_Event_fvoBalanceBots );
			vclEventSched.fvoSetDelayInSecs( vinInterval );
			vclEventSched.fboSendEvent( );
		}

	} // fvoMA_BOT_Event_fvoBalanceBots

	tclBot::tclBot( void )
	{
		vboStatsProtection      = false;
		vboPODBotFixProtection	= true;
		vboBotHitEffectIsOn		= false;
		vboBotHitSoundsIsOn		= false;
		vboBotHitSparksIsOn		= false;
		vboKickDupoBotsIsOn		= false;
		vboBalanceBots				= cboRandomBotTeamSwitch_DEFAULT;
		vboEnforceBotTeam			= cboEnforceBotTeam_DEFAULT;
		vboRandomBotTeamSwitch	= cboRandomBotTeamSwitch_DEFAULT;
		vboRandomBotSkillSwitch	= cboRandomBotSkillSwitch_DEFAULT;
		vflProbOfBotSkillSwitch = cflSwitchProb_DEFAULT; 
		vflProbOfBotTeamSwitch  = cflSwitchProb_DEFAULT;

		if ( finRandom( 0, 1 ) == 0 )
			vinCurrentBotTeam	= cinTeam_TE;
		else
			vinCurrentBotTeam	= cinTeam_CT;
		
		vinMinBots			= cinNumBots_MIN;
		vinMaxBots			= cinNumBots_MAX;
		vflBotHumanRatio	= cflBotHumanRatio;
		vinBotSystem		= cinBot_Unknown;
		vtxBotSystem		= ctxBotName_Unknown;
		vinBotMode			= cinBotMode_BotsvsHumans;

		vinBotSkill_Fixed		= cinSkill_Fixed_DEFAULT;
		vinBotSkill_Variable_Min = cinSkill_variable_MinDEFAULT;
		vinBotSkill_Variable_Max = cinSkill_variable_MaxDEFAULT;
		
		vboAutoKillAllBots = false;
	//	fvoMA_Bot_Event_AutoKillBots_Start( );

	} // tclBot::tclBot

	bool tclBot::fboAssignBotSystem( string ptxBotName )
	{
		vtxBotSystem = ptxBotName;
		if ( ptxBotName == ctxBotName_PLCBmix )
			vinBotSystem = cinBot_PLCBmix;
		else 
		if ( ptxBotName == ctxBotName_CBPODmix )
			vinBotSystem = cinBot_CBPODmix;
		else 
		if ( ptxBotName == ctxBotName_PLPODmix )
			vinBotSystem = cinBot_PLPODmix;
		else 
		if ( ptxBotName == ctxBotName_CBJOEmix )
			vinBotSystem = cinBot_CBJOEmix;
		else 
		if ( ptxBotName == ctxBotName_PLJOEmix )
			vinBotSystem = cinBot_PLJOEmix;
		else 
		if ( ptxBotName == ctxBotName_CB )
			vinBotSystem = cinBot_CB;
		else 
		if ( ptxBotName == ctxBotName_PLB )
			vinBotSystem = cinBot_PLB;
		else 
		if ( ptxBotName == ctxBotName_JOE )
			vinBotSystem = cinBot_JOE;
		else
		if ( ptxBotName == ctxBotName_POD )
			vinBotSystem = cinBot_POD;
		else
		if ( ptxBotName == ctxBotName_PODMM )
			vinBotSystem = cinBot_PODMM;
		else
		if ( ptxBotName == ctxBotName_POX )
			vinBotSystem = cinBot_POX;
		else
		if ( ptxBotName == ctxBotName_EPOD )
			vinBotSystem = cinBot_EPOD;
		else
		if ( ptxBotName == ctxBotName_MEAN )
			vinBotSystem = cinBot_MEAN;
		else
		if ( ptxBotName == ctxBotName_WBOT )
			vinBotSystem = cinBot_WBOT;
		else
		if ( ptxBotName == ctxBotName_AKIMBOT )
			vinBotSystem = cinBot_AKIMBOT;
		else
		if ( ptxBotName == ctxBotName_RBAI )
			vinBotSystem = cinBot_REAL_AI;
		else
		if ( ptxBotName == ctxBotName_RBMM )
			vinBotSystem = cinBot_REAL_MM;
		else
		if ( ptxBotName == ctxBotName_BOC )
			vinBotSystem = cinBot_BOC; 
		else
		if ( ptxBotName == ctxBotName_RACC )
			vinBotSystem = cinBot_RACC;
		else
		{
			vtxBotSystem = ctxBotName_Unknown;
			vinBotSystem = cinBot_Unknown;
		}
		return vinBotSystem != cinBot_Unknown;

	} // tclBot::fboAssignBotSystem

	string tclBot::ftxGetBotSystem( )
	{
		return vtxBotSystem;
	} // tclBot::ftxGetBotSystem

	int tclBot::finGetBotSystem( )
	{
		return vinBotSystem;
	} // tclBot::finGetBotSystem

	bool tclBot::fboPODBotIsLoaded( )
	{
		return (	vinBotSystem == cinBot_CBPODmix 
						||
				   vinBotSystem == cinBot_PLPODmix
						||
					vinBotSystem == cinBot_POD );

	} // tclBot::fboPODBotIsLoaded

	int tclBot::finGetBotMode( void )
	{
		return vinBotMode;
	} // tclBot::fvoGetBotMode

	void tclBot::fvoSetBotMode( int pinBotMode )
	{
		if ( ( pinBotMode != cinBotMode_NoBots ) 
					&& 
			  ( pinBotMode != cinBotMode_BotvsBot ) 
			      && 
			  ( pinBotMode != cinBotMode_BotsWhenXPlayers ) 
			      && 
			  ( pinBotMode != cinBotMode_BotsvsHumans ) 
			      && 
			  ( pinBotMode != cinBotMode_BotsFillServer )

			)
		// this is an error condition caised by an invalid mode
		// assignment attempt; do not assign the value;
			return;

		if ( pinBotMode == cinBotMode_NoBots )
		{
			finKickAllBots( );
			vboEnforceBotTeam = false;
			vinCurrentBotTeam = cinTeam_Unknown;
			vboBalanceBots = false;
		}
		else
		if ( pinBotMode == cinBotMode_BotvsBot )
		{
			finKickAllBots( );
			vboEnforceBotTeam = false;
			vinCurrentBotTeam = cinTeam_Any;
			vboBalanceBots = true;
			fvoCVarSetString( "mp_autoteambalance", "0" );
		}
		else
		if ( pinBotMode == cinBotMode_BotsWhenXPlayers )
		{
			finKickAllBots( );
			vboEnforceBotTeam = false;
			vinCurrentBotTeam = vclPlayer.finGenRandomTeam( );
			vboBalanceBots = true;
			fvoCVarSetString( "mp_autoteambalance", "0" );
			if ( vinBotsWhenMinPlayers < 0 )
			{
				vinBotsWhenMinPlayers = 0;
			}
			else
			if ( vinBotsWhenMinPlayers > cinMaxPlayers )
			{
				vinBotsWhenMinPlayers = cinMaxPlayers;
			}

		}
		else
		if ( pinBotMode == cinBotMode_BotsFillServer )
		{
			finKickAllBots( );
			vboEnforceBotTeam = false;
			vinCurrentBotTeam = cinTeam_Any;
			vboBalanceBots = true;
			fvoCVarSetString( "mp_autoteambalance", "0" );
		}
		else
		if ( pinBotMode == cinBotMode_BotsvsHumans )
		{
			finKickAllBots( );
			vboEnforceBotTeam = true;
			// set team only if team is not already specific;
			if ( ( vinCurrentBotTeam != cinTeam_TE ) 
				       && 
				  ( vinCurrentBotTeam != cinTeam_CT ) 
				)
			{
				vinCurrentBotTeam = vclPlayer.finGenRandomTeam( );
			}
			vboBalanceBots = true;
			fvoCVarSetString( "mp_autoteambalance", "0" );
		}

		vinBotMode = pinBotMode;

	} // tclBot::fvoSetBotMode

	int tclBot::finGetHumanTeam ( void )
	{
		int vinBotTeam = finGetBotTeam( );

		if ( vinBotTeam == cinTeam_Any )
			return cinTeam_Any;
		if ( vinBotTeam == cinTeam_TE )
			return cinTeam_CT;

		if ( vinBotTeam == cinTeam_CT )
			return cinTeam_TE;
	
		return cinTeam_Unknown;

	} // finGetHumanTeam

	int tclBot::finGetBotTeam( void )
	{
		if ( ( vinBotSystem == cinBot_Unknown ) 
			       || 
			  ( vinCurrentBotTeam == cinTeam_Unknown ) 
			)
		{
			int vinHumanSpectators;
			int vinBotSpectators;
			int vinHumansOnTE;
			int vinBotsOnTE;
			int vinHumansOnCT;
			int vinBotsOnCT;

			vclPlayer.fvoCountEveryOne
				( vinHumanSpectators, 
				  vinBotSpectators, 
				  vinHumansOnTE,
				  vinBotsOnTE,
				  vinHumansOnCT,
				  vinBotsOnCT);

			if ( ( vinBotsOnCT == 0 ) 
				      && 
				  ( vinBotsOnTE > 0 ) 
				)
				vinCurrentBotTeam = cinTeam_TE;
			else
			if ( ( vinBotsOnTE == 0 )
				      && 
				  ( vinBotsOnCT > 0 ) 
				)
				vinCurrentBotTeam = cinTeam_CT;
			else
			if ( ( vinHumansOnTE > 0 ) 
				      && 
				  ( vinHumansOnCT == 0 ) 
				)
				vinCurrentBotTeam = cinTeam_CT;
			else
			if ( ( vinHumansOnCT > 0 ) 
				      && 
				  ( vinHumansOnTE == 0 ) 
				)
				vinCurrentBotTeam = cinTeam_TE;
			else
				vinCurrentBotTeam = cinTeam_Any;
		} // vinBotSystem == cinBot_Unknown

		if ( vinCurrentBotTeam == cinTeam_Unknown )
		// this setting is not allowed; switch to a randomly selected team
			vinCurrentBotTeam = vclPlayer.finGenRandomTeam( );

		return vinCurrentBotTeam;

	} // finGetBotTeam

	bool tclBot::fboAddBot ( int pinTeam ) 
	{
		if ( vinBotSystem == cinBot_Unknown )
			return false;

		if ( pinTeam == cinTeam_Unknown )
			return  false;

		if ( ( pinTeam != cinTeam_Any )
					&& 
			  ( pinTeam != cinTeam_TE  )
			      && 
			  ( pinTeam !=  cinTeam_CT ) )
			return  false;

		static int vinTeam;

		if ( pinTeam == cinTeam_Any )
		{

		// alternate to try and keep teams even;

			if ( vinTeam == cinTeam_Any )
				vinTeam = vclPlayer.finGenRandomTeam( );
			else
			if ( vinTeam == cinTeam_TE )
				vinTeam = cinTeam_CT;
			else
				vinTeam = cinTeam_TE;

		}
		else
		  vinTeam = pinTeam;
		
		static int vinBotMix;

		string vtxTeam = ftxIntToString ( vinTeam );
		string vtxCmd;
		string vtxSkill;

		if ( vinBotMix == 0 )
			vinBotMix = 1;
		else
		if ( vinBotMix == 1 )
			vinBotMix = 0;
		else
			vinBotMix = finRandom( 0, 1 );

		if ( vinBotSystem == cinBot_PLCBmix )
		{
			if ( vinBotMix == 0 )
			{
				vtxSkill = ftxGetActualBotSkill( cinBot_PLB );
				vtxCmd  = "plb_add " +  vtxTeam + " " + vtxSkill + "\n";
			}
			else			
			{
				vtxSkill = ftxGetActualBotSkill( cinBot_CB );
				vtxCmd = "cb_addbot " +  vtxTeam + "\n";
			}
		}
		else
		if ( vinBotSystem == cinBot_PLPODmix )
		{
			if ( vinBotMix == 0 )
			{
				vtxSkill = ftxGetActualBotSkill( cinBot_PLB );
				vtxCmd  = "plb_add " +  vtxTeam + " " + vtxSkill + "\n";
			}
			else			
			{
				vtxSkill = ftxGetActualBotSkill( cinBot_POD );
				vtxCmd += "pb \"addbot " + vtxSkill + " " + vtxTeam + "\"\n";
			}
		}
		else
		if ( vinBotSystem == cinBot_CBPODmix )
		{
			if ( vinBotMix == 0 )
			{
				vtxSkill = ftxGetActualBotSkill( cinBot_CB );
				vtxCmd = "cb_addbot " +  vtxTeam + "\n";
			}
			else			
			{
				vtxSkill = ftxGetActualBotSkill( cinBot_POD );
				vtxCmd += "pb \"addbot " + vtxSkill + " " + vtxTeam + "\"\n";
			}
		}
		else
		if ( vinBotSystem == cinBot_PLJOEmix )
		{
			if ( vinBotMix == 0 )
			{
				vtxSkill = ftxGetActualBotSkill( cinBot_PLB );
				vtxCmd  = "plb_add " +  vtxTeam + " " + vtxSkill + "\n";
			}
			else			
			{
				vtxSkill = ftxGetActualBotSkill( cinBot_JOE );
				vtxCmd = "joebot addbot|" +  vtxTeam + "|default|" + "default|" + vtxSkill + "\n";
			}
		}
		else
		if ( vinBotSystem == cinBot_CBJOEmix )
		{

			if ( vinBotMix == 0 )
			{
				vtxSkill = ftxGetActualBotSkill( cinBot_CB );
				vtxCmd = "cb_addbot " +  vtxTeam + "\n";
			}
			else			
			{
				vtxSkill = ftxGetActualBotSkill( cinBot_JOE );
				vtxCmd = "joebot addbot|" +  vtxTeam + "|default|" + "default|" + vtxSkill + "\n";
			}
		}
		else
		if ( vinBotSystem == cinBot_BOTT )
			vtxCmd = "addbot " +  vtxTeam + "\n";
		else
		if ( vinBotSystem == cinBot_PLB )
		{
			// plb_add <team> <skill>
			vtxSkill = ftxGetActualBotSkill( );
			vtxCmd = "plb_add " +  vtxTeam + " " + vtxSkill + "\n";
		}
		else	
		if ( vinBotSystem == cinBot_CB )
			vtxCmd = "cb_addbot " +  vtxTeam + "\n";
		else	
		if ( vinBotSystem == cinBot_POD )
		{
			vtxSkill = ftxGetActualBotSkill( );
			vtxCmd = "pb \"addbot " + vtxSkill + " " + vtxTeam + "\"\n";
		}
		else	
		if ( vinBotSystem == cinBot_PODMM )
		{
			vtxSkill = ftxGetActualBotSkill( );
			// the pod_mm command includes a "personality" which is left to random (5);
			vtxCmd = "pb addbot " + vtxSkill + " 5 " + vtxTeam + "\n";
		}
		else	
		if ( vinBotSystem == cinBot_POX )
		{
			vtxSkill = ftxGetActualBotSkill( );
			vtxCmd = "pb \"addbot " + vtxSkill + " " + vtxTeam + "\"\n";
		}
		else	
		if ( vinBotSystem == cinBot_EPOD )
		{
			vtxSkill = ftxGetActualBotSkill( );
			vtxCmd = "pb \"addbot " + vtxSkill + " " + vtxTeam + "\"\n";
		}
		else	
		if ( vinBotSystem == cinBot_MEAN )
		{
			vtxSkill = ftxGetActualBotSkill( );
			// vtxCmd = "addmean " + vtxSkill + " " + vtxTeam + "\"\n";
			vtxCmd = "m_addmean " + vtxTeam + "\n";
		}
		else	
		if ( vinBotSystem == cinBot_WBOT )
		{
			vtxSkill = ftxGetActualBotSkill( );
			vtxCmd = "wb \"addbot " + vtxSkill + " " + vtxTeam + "\"\n";
		}
		else	
		if ( vinBotSystem == cinBot_AKIMBOT )
		{
			// vtxSkill = ftxGetActualBotSkill( );
			if ( vinTeam == cinTeam_TE )
				vtxCmd = "akimbot \"addt\"\n";
			else
				vtxCmd = "akimbot \"addct\"\n";
		}
		else	
		if ( vinBotSystem == cinBot_JOE )
		{
			//	addbot team model name skill prefweapon
			// addbot [1/2/5] [1/2/3/4] name 
			vtxSkill = ftxGetActualBotSkill( );
			vtxCmd = "joebot addbot|" +  vtxTeam + "|default|" + "default|" + vtxSkill + "\n";
		}
		else
		if ( vinBotSystem == cinBot_REAL_AI )
		{
		// rbds addbot team skill model name
			vtxSkill = ftxGetActualBotSkill( );
			vtxCmd = "rbds addbot_" + vtxTeam + "_" + vtxSkill + "\n";
		}
		else	
		if ( vinBotSystem == cinBot_REAL_MM )
		{
		// realbot add (team) (skill) (model) (name)
			vtxSkill = ftxGetActualBotSkill( );
			vtxCmd = "realbot add " + vtxTeam + " " + vtxSkill + "\n";
		}
		else	
		if ( vinBotSystem == cinBot_BOC )
		{	
			vtxCmd = "boc addboc_" + vtxTeam + "\n"; 
		}
		else	
		if ( vinBotSystem == cinBot_RACC )
		{	

			if ( ftxCVarGetString( "racc_autofill") != "0" )
			{
				fvoCVarSetString( "racc_autofill", "0" );
				fvoServerPrint_nl( "Setting CVAR racc_autofill to 0" );
			}

			if ( ftxCVarGetString( "racc_internetmode") != "0" )
			{
				fvoCVarSetString( "racc_internetmode", "0" );
				fvoServerPrint_nl( "Setting CVAR racc_internetmode to 0" );
			}

			if ( ftxCVarGetString( "racc_botforceteam" ) != vtxTeam )
			{
				fvoCVarSetString( "racc_botforceteam", vtxTeam );
				fvoServerPrint_nl( "Setting CVAR racc_botforceteam to " + vtxTeam );
			}
			vtxCmd = "racc add\n";
		}
		else
			return false;
		
		fvoServerPrint( vtxCmd );
		if ( vclBotControl.fboBotAimIsOn( ) )
		{
			// display that the skill is will be overridden;
			if ( vinBotSystem != cinBot_MEAN )
			{
				fvoServerPrint_nl("Actual skill will be overridden by internal BotAim System as " + ftxGetBotSkill( ) );
			}
		}
		fvoServerCommand( vtxCmd );	

		return true;

	} // tclBot::fboAddBot

	int tclBot::finAddBots( int pinNum )
	{
		return finAddBots( finGetBotTeam( ), pinNum );
	} // tclBot::finAddBots

	int tclBot::finAddBots( int pinTeam, int pinNum )
	{
		if ( pinNum <= 0 )
			return 0;

		const float cflDelay = 1.25;
		float vflDelay = cflDelay;

		if ( pinNum > cinMaxPlayers )
			pinNum = cinMaxPlayers;

		for ( int vinIdx = 0; vinIdx < pinNum; vinIdx++ )
		{
			if ( vclEventSched.fboCreateEvent( ) )
			{
				vclEventSched.fboCreateArgList( 3 );
				vclEventSched.fvoSetArg_Int( 0, pinTeam );
				vclEventSched.fvoSetArg_Int( 1, pinNum );
				vclEventSched.fvoSetArg_Float( 2, cflDelay );
				vclEventSched.fvoSetEventFunc( fvoMA_BOT_Event_fvoAddBotToTeam );
				vclEventSched.fvoSetDelayInSecs( vflDelay );
				vclEventSched.fboSendEvent( );
				vflDelay = vflDelay + cflDelay;
			}
		}

		return pinNum;
	
	} // tclBot::finAddBots

	int tclBot::finKickSpectatorBots( void )
	{
		int vinNumKicked = 0;

		for ( int vinIdx = cinMinPlayerIndex; 
				vinIdx <= vclPlayer.finGetMaxPlayers( ); 
				vinIdx++ )
		{
			if (  vclPlayer.fboPlayerIsBotByIndex( vinIdx ) 
				      &&
				   vclPlayer.fboPlayerIsSpectatorByIndex( vinIdx ) 
				)
			{
				if ( vclPlayer.fboKickPlayerByIndex ( vinIdx, "" ) )
					vinNumKicked++;

			}//.if
		} //.for
		
		return vinNumKicked;

	} // tclBot::finKickSpectatorBots

	int tclBot::finKickAllBots ( void )
	{
		int vinNumKicked = 0;

		for ( int vinIdx = cinMinPlayerIndex; 
				vinIdx <= vclPlayer.finGetMaxPlayers( ); 
				vinIdx++ )
		{
			if ( !vclPlayer.fboPlayerIsBotByIndex( vinIdx ) )
				continue;

			if ( vclPlayer.fboKickPlayerByIndex( vinIdx, "" ) )
					vinNumKicked++;
			
		} //.for
		
		return vinNumKicked;

	} // tclBot::finKickAllBots

	int tclBot::finKickAllBotsOffTeam ( int pinTeam )
	{
		if ( pinTeam == cinTeam_Unknown )
			return 0;

		int vinNumKicked = 0;
		int vinTeam = pinTeam;

		for ( int vinIdx = cinMinPlayerIndex; 
				vinIdx <= vclPlayer.finGetMaxPlayers( ); 
				vinIdx++ )
		{
			if ( !vclPlayer.fboPlayerIsBotByIndex( vinIdx ) )
				continue;

			if ( pinTeam != cinTeam_Any )
				vinTeam = vclPlayer.finGetPlayerTeamByIndex( vinIdx );

			if ( vinTeam != pinTeam ) 
				continue;

			if ( vclPlayer.fboKickPlayerByIndex( vinIdx, "" ) )
					vinNumKicked++;
			
		} //.for
		
		return vinNumKicked;

	} // tclBot::finKickAllBotsOffTeam

	int tclBot::finKickAllAliveBotsOffTeam ( int pinTeam )
	{
		if ( pinTeam == cinTeam_Unknown )
			return 0;

		int vinNumKicked = 0;
		int vinTeam = pinTeam;

		for ( int vinIdx = cinMinPlayerIndex; 
				vinIdx <= vclPlayer.finGetMaxPlayers( ); 
				vinIdx++ )
		{
			if ( !vclPlayer.fboPlayerIsBotByIndex( vinIdx ) )
				continue;

			if ( !vclPlayer.fboPlayerIsAliveByIndex( vinIdx ) )
				continue;

			if ( pinTeam != cinTeam_Any )
				vinTeam = vclPlayer.finGetPlayerTeamByIndex ( vinIdx );

			if ( vinTeam != pinTeam ) 
				continue;

			if ( vclPlayer.fboKickPlayerByIndex ( vinIdx, "" ) )
					vinNumKicked++;
			
		} //.for
		
		return vinNumKicked;

	} // tclBot::finKickAllAliveBotsOffTeam

	int tclBot::finKickBotsByLivingStatus ( int pinTeam, int pinNum, bool pboAlive )
	{
		int vinNumKicked = 0;
		int vinTeam = pinTeam;

		if ( pinNum < 1 )
			return 0;

		for (	int vinIdx = cinMinPlayerIndex; 
				vinIdx <= vclPlayer.finGetMaxPlayers( ); 
				vinIdx++ )
		{
			if ( ( vclPlayer.fboPlayerIsBotByIndex( vinIdx ) ==  true )
					   && 
				  ( vclPlayer.fboPlayerIsAliveByIndex( vinIdx ) ==  pboAlive )
				)
			{
				if ( pinTeam != cinTeam_Any )
				// kick from specific team.
					vinTeam = vclPlayer.finGetPlayerTeamByIndex( vinIdx );
				
				if ( vinTeam == pinTeam )
				{
					if ( vclPlayer.fboKickPlayerByIndex( vinIdx, "" ) )
						vinNumKicked++;

					if ( vinNumKicked >= pinNum )
						return vinNumKicked;

				} //.if
			} //.if
		} //.for
			
		return vinNumKicked;

	} // tclBot::finKickBotsByLivingStatus

	int tclBot::finKickDeadBots ( int pinTeam, int pinNum )
	{
		return finKickBotsByLivingStatus( pinTeam, pinNum, /* is alive = */ false );
	} // tclBot::finKickDeadBots

	int tclBot::finKickAliveBots ( int pinTeam, int pinNum )
	{
		return finKickBotsByLivingStatus( pinTeam, pinNum, /* is alive = */ true );
	} // tclBot::finKickAliveBots

	int tclBot::finKickBots( int pinBotTeam, int pinNum )
	{
		int vinNumKicked = 0;
		int vinNumToKick = pinNum;

		// attempt to kick dead bots first
		vinNumKicked += finKickDeadBots( pinBotTeam, vinNumToKick );

		if ( vinNumKicked >= pinNum )
			return vinNumKicked;

		vinNumToKick = pinNum - vinNumKicked;

		// not enough dead bots to kick, so we attempt to kick live ones
		vinNumKicked += finKickAliveBots( pinBotTeam, vinNumToKick );
		
		return vinNumKicked;

	} // tclBot::finKickBots

	bool tclBot::fboKickBot( int vinTeam )
	{
		return finKickBots( vinTeam, 1 ) > 0;
	} // tclBot::fboKickBot

	int tclBot::finKillAllBots( int pinTeam, bool pboSuicide )
	{
		if ( pinTeam == cinTeam_Unknown )
			return 0;

		int vinNumKilled = 0;
		int vinTeam = pinTeam;
		edict_t* vst_ptrPlayer; 

		for ( int vinIdx = cinMinPlayerIndex; 
				vinIdx <= vclPlayer.finGetMaxPlayers( ); 
				vinIdx++ )
		{
			vst_ptrPlayer = vclPlayer.fst_ptrGetPlayerByIndex( vinIdx );

			if ( !vclPlayer.fboPlayerIsBotByEdict( vst_ptrPlayer ) )
				continue;

			if ( pinTeam != cinTeam_Any )
				vinTeam = vclPlayer.finGetPlayerTeamByEdict( vst_ptrPlayer );

			if ( vinTeam != pinTeam ) 
				continue;

			if ( vclPlayer.fboKillPlayerByEdict( vst_ptrPlayer, "", pboSuicide ) )
			{
				vinNumKilled++;
			}
			
		} //.for
		
		return vinNumKilled;

	} // tclBot::finKillAllBots

	bool tclBot::vboBotSkillIsValid_Range( int pinSkill )
	{
		return ( ( pinSkill >= cinSkillMin ) && ( pinSkill <= cinSkillMax ) );
	} // tclBot::vboBotSkillIsValid_Range

	bool tclBot::vboBotSkillIsValid_Fixed( int pinSkill )
	{
		return 
			( pinSkill == cinSkillNotSet ) 
					||
			( pinSkill == cinSkillInsane )
					||
			( pinSkill == cinSkillRand )
					||
			( pinSkill == cinSkillLow )
					||
			( pinSkill == cinSkillMed )
					||
			( pinSkill == cinSkillHigh )
					||
			( pinSkill == cinSkillHighest ) 
					||
			( pinSkill == cinSkillLowest );

	} // tclBot::vboBotSkillIsValid_Fixed

	bool tclBot::vboBotSkillIsValid_Variable( 
		int pinSkill_Fixed, int pinSkill_Variable_Min, int pinSkill_Variable_Max )
	{
		if ( !vboBotSkillIsValid_Fixed( pinSkill_Fixed ) )
			return false;

		if ( pinSkill_Fixed == cinSkillNotSet )
			return true;

		if ( pinSkill_Fixed == cinSkillRand )
			return ( pinSkill_Variable_Min == cinSkillRange_Low_Min ) && ( pinSkill_Variable_Max == cinSkillRange_High_Max );

		if ( pinSkill_Fixed == cinSkillInsane )
			return ( pinSkill_Variable_Min == cinSkillRange_High_Max ) && ( pinSkill_Variable_Max == cinSkillRange_High_Max );

		if ( pinSkill_Fixed == cinSkillHighest ) 
			return ( pinSkill_Variable_Min == cinSkillRange_High_Max ) && ( pinSkill_Variable_Max == cinSkillRange_High_Max );

		if ( pinSkill_Fixed == cinSkillLowest ) 
			return ( pinSkill_Variable_Min == cinSkillLowest ) && ( pinSkill_Variable_Max == cinSkillLowest );

		if ( pinSkill_Fixed == cinSkillLow ) 
			return ( pinSkill_Variable_Min >= cinSkillRange_Low_Min ) && ( pinSkill_Variable_Max <= cinSkillRange_Low_Max );
			
		if ( pinSkill_Fixed == cinSkillMed ) 
			return ( pinSkill_Variable_Min >= cinSkillRange_Med_Min ) && ( pinSkill_Variable_Max <= cinSkillRange_Med_Max );

		if ( pinSkill_Fixed == cinSkillHigh ) 
			return ( pinSkill_Variable_Min >= cinSkillRange_High_Min ) && ( pinSkill_Variable_Max <= cinSkillRange_High_Max );

		return false;

	} // tclBot::vboBotSkillIsValid_Variable

	string tclBot::ftxGetBotSkill( )
	{
		if ( vinBotSkill_Fixed == cinSkillNotSet ) 
			return ctxSkillNotSet;
		if ( vinBotSkill_Fixed == cinSkillInsane )
			return ctxSkillInsane;
		if ( vinBotSkill_Fixed == cinSkillRand )
			return ctxSkillRand;
		if ( vinBotSkill_Fixed == cinSkillLow )
			return ctxSkillLow;
		if ( vinBotSkill_Fixed == cinSkillMed )
			return ctxSkillMed;
		if ( vinBotSkill_Fixed == cinSkillHigh )
			return ctxSkillHigh;
		if ( vinBotSkill_Fixed == cinSkillHighest )
			return ctxSkillHighest;
		if ( vinBotSkill_Fixed == cinSkillLowest )
			return ctxSkillLowest;

		return ctxSkillInvalid;

	} // tclBot::ftxGetBotSkill

	string tclBot::ftxGetActualBotSkill( )
	{
		return ftxGetActualBotSkill( vinBotSystem );
	} // tclBot::ftxGetActualBotSkill
	
	string tclBot::ftxGetActualBotSkill( int pinBotSystem )
	{
		if ( pinBotSystem == cinBot_Unknown )
			return "";

		if ( !vboBotSkillIsValid_Fixed( vinBotSkill_Fixed ) 
			   	||
           ( vinBotSkill_Fixed == cinSkillNotSet )
					||
	   	  !vboBotSkillIsValid_Variable( vinBotSkill_Fixed, vinBotSkill_Variable_Min, vinBotSkill_Variable_Max )
			)
		{
			// This is an error condition;
			vclDebugTrace.fvoWriteEventInfo( "DEBUG (tclBot::ftxGetActualBotSkill) Invalid Skill Settings - Detals Follow ... "  );
			vclDebugTrace.fvoWriteEventInfo( "DEBUG (tclBot::ftxGetActualBotSkill) vinBotSkill_Fixed           = " + ftxIntToString( vinBotSkill_Fixed ) );
			vclDebugTrace.fvoWriteEventInfo( "DEBUG (tclBot::ftxGetActualBotSkill) vinBotSkill_Variable_Min    = " + ftxIntToString( vinBotSkill_Variable_Min ) );
			vclDebugTrace.fvoWriteEventInfo( "DEBUG (tclBot::ftxGetActualBotSkill) vinBotSkill_Variable_Max    = " + ftxIntToString( vinBotSkill_Variable_Max ) );
			vclDebugTrace.fvoWriteEventInfo( "DEBUG (tclBot::ftxGetActualBotSkill) vboBotSkillIsValid_Fixed    = " + ftxBoolToString( vboBotSkillIsValid_Fixed( vinBotSkill_Fixed ) ) );
			vclDebugTrace.fvoWriteEventInfo( "DEBUG (tclBot::ftxGetActualBotSkill) vboBotSkillIsValid_Variable = " + ftxBoolToString( vboBotSkillIsValid_Variable( vinBotSkill_Fixed, vinBotSkill_Variable_Min, vinBotSkill_Variable_Max ) ) );
			vinBotSkill_Fixed = cinSkillRand;
			vinBotSkill_Variable_Min = cinSkillRange_Low_Min;
			vinBotSkill_Variable_Max = cinSkillRange_High_Max;
			vclBotControl.fvoSetBotSkill( vinBotSkill_Variable_Min, vinBotSkill_Variable_Max );
		}

		int vinSelectedSkill;

		if ( vclBotControl.fboBotAimIsOn( ) )
		// always use highest setting when botaim is on since skill is not controled
		// from here;
			vinSelectedSkill = cinSkillRange_High_Max;
		else
			vinSelectedSkill = finRandom( vinBotSkill_Variable_Min, vinBotSkill_Variable_Max );

		if ( pinBotSystem == cinBot_PLB )
		{
			// if ( vinBotSkill_Fixed == cinSkillRand  )
			//	return ftxIntToString( finRandom( 1, 5 ) );
			//	return ftxIntToString( vinBotSkill_Variable / 20 ); 

			return ftxIntToString( finBoundValue( vinSelectedSkill / 20, 0, 5 ) );

		} // cinBot_PLB

		if ( pinBotSystem == cinBot_CB )
		{
			//if ( vinBotSkill_Fixed == cinSkillRand  )
			//	return ftxIntToString( random( 101 ) );
			// return ftxIntToString( 100 - vinBotSkill_Variable ); 

			 return ftxIntToString( finBoundValue( 100 - vinSelectedSkill, 0, 100 ) );

		} // cinBot_CB

		if ( pinBotSystem == cinBot_JOE )
		{
			//if ( vinBotSkill_Fixed == cinSkillRand  )
			//	return ftxIntToString( random( 101 ) );
			// return ftxIntToString( vinBotSkill_Variable ); 

			 return ftxIntToString( finBoundValue( vinSelectedSkill, 0, 100 ) );

		} // cinBot_JOE

		if ( pinBotSystem == cinBot_REAL_AI )
		{
			//if ( vinBotSkill_Fixed == cinSkillRand  )
			//	return ftxIntToString( random( 11 ) );
			//return ftxIntToString( ( 100 - vinBotSkill_Variable ) / 10 ); 
			return ftxIntToString( finBoundValue( ( 100 - vinSelectedSkill ) / 10, 0, 10 ) );
		} // cinBot_REAL_AI

		if ( pinBotSystem == cinBot_REAL_MM )
		{
			//if ( vinBotSkill_Fixed == cinSkillRand  )
			//	return ftxIntToString( random( 11 ) );
			//return ftxIntToString( ( 100 - vinBotSkill_Variable ) / 10 ); 
			return ftxIntToString( finBoundValue( ( 100 - vinSelectedSkill ) / 10, 0, 10 ) );
		} // cinBot_REAL_MM

		if ( pinBotSystem == cinBot_POD )
		{
			//if ( vinBotSkill_Fixed == cinSkillRand  )
			//	return ftxIntToString( random( 101 ) );
			//return ftxIntToString( vinBotSkill_Variable ); 
			return ftxIntToString( finBoundValue( vinSelectedSkill, 0, 100 ) );
		} // cinBot_POD

		if ( pinBotSystem == cinBot_PODMM )
		{
			return ftxIntToString( finBoundValue( vinSelectedSkill, 0, 100 ) );
		} // cinBot_PODMM

		if ( pinBotSystem == cinBot_POX )
		{
			//if ( vinBotSkill_Fixed == cinSkillRand  )
			//	return ftxIntToString( random( 101 ) );
			//return ftxIntToString( vinBotSkill_Variable ); 
			return ftxIntToString( finBoundValue( vinSelectedSkill, 0, 100 ) );
		} // cinBot_POX

		if ( pinBotSystem == cinBot_EPOD )
		{
			//if ( vinBotSkill_Fixed == cinSkillRand  )
			//	return ftxIntToString( random( 101 ) );
			//return ftxIntToString( vinBotSkill_Variable ); 
			return ftxIntToString( finBoundValue( vinSelectedSkill, 0, 100 ) );
		} // cinBot_EPOD

		if ( pinBotSystem == cinBot_MEAN )
		{
			return ftxIntToString( finBoundValue( vinSelectedSkill, 0, 100 ) );
		} // cinBot_MEAN

		if ( pinBotSystem == cinBot_WBOT )
		{
			//if ( vinBotSkill_Fixed == cinSkillRand  )
			//	return ftxIntToString( random( 100 ) + 1 );
			//if ( vinBotSkill_Variable == 0 )
			//{
			//	return "1"; 
			//}
			//return ftxIntToString( vinBotSkill_Variable ); 
			return ftxIntToString( finBoundValue( vinSelectedSkill, 1, 100 ) );
		} // cinBot_WBOT

		if ( pinBotSystem == cinBot_AKIMBOT )
		{
			//if ( vinBotSkill_Fixed == cinSkillRand  )
			//	return ftxIntToString( random( 5 ) + 1 );
			//int vinAkimSkill = finBoundValue( ( 100 - vinBotSkill_Variable ) / 20 , 1, 5 );
			//return ftxIntToString( vinAkimSkill ); 
			return ftxIntToString( finBoundValue( ( 100 - vinSelectedSkill ) / 20, 1, 5 ) );

		} // cinBot_AKIMBOT

		return "";

	} // tclBot::ftxGetActualBotSkill

	bool tclBot::vboSkillChangeSupported( )
	{
		// bots with no skill change support:
		//		cinBot_BOC  
		//		cinBot_RACC 

		return ( ( vinBotSystem == cinBot_PLB ) 
						||
					( vinBotSystem == cinBot_CB ) 
						||
					( vinBotSystem == cinBot_JOE )
						||
					( vinBotSystem == cinBot_REAL_AI )
						||
					( vinBotSystem == cinBot_REAL_MM )
						||
					( vinBotSystem == cinBot_POD ) 
						||
					( vinBotSystem == cinBot_PODMM ) 
						||
					( vinBotSystem == cinBot_POX ) 
						||
					( vinBotSystem == cinBot_EPOD ) 
						||
					( vinBotSystem == cinBot_MEAN ) 
						||
					( vinBotSystem == cinBot_WBOT ) 
						||
					( vinBotSystem == cinBot_PLPODmix )
						||
					( vinBotSystem == cinBot_CBPODmix )
						||
					( vinBotSystem == cinBot_PLJOEmix )
						||
					( vinBotSystem == cinBot_CBJOEmix )
						||
					( vinBotSystem == cinBot_PLCBmix ) );

	} // tclBot::vboSkillChangeSupported

	bool tclBot::fboSetBotSkill( int pinSkill )
	{
		if ( !vboSkillChangeSupported( ) && !vclBotControl.fboBotAimIsOn( ) )
			return false;

		if ( !vboBotSkillIsValid_Range( pinSkill ) )
			return false;

		if ( pinSkill == cinSkillNotSet ) 
			return false;

		if ( pinSkill == cinSkillInsane )
		{
			vinBotSkill_Fixed = pinSkill;
			vinBotSkill_Variable_Min = cinSkillRange_High_Max;
			vinBotSkill_Variable_Max = cinSkillRange_High_Max;
		}
		else
		if ( pinSkill == cinSkillRand )
		{
			vinBotSkill_Fixed = pinSkill;
			vinBotSkill_Variable_Min = cinSkillRange_Low_Min;
			vinBotSkill_Variable_Max = cinSkillRange_High_Max;
		}
		else
		if ( pinSkill == cinSkillLowest )
		{
			vinBotSkill_Fixed = pinSkill;
			vinBotSkill_Variable_Min = cinSkillLowest;
			vinBotSkill_Variable_Max = cinSkillLowest;
		}
		else
		if ( pinSkill == cinSkillLow )
		{
			vinBotSkill_Fixed = pinSkill;
			vinBotSkill_Variable_Min = cinSkillRange_Low_Min;
			vinBotSkill_Variable_Max = cinSkillRange_Low_Max;
		}
		else
		if ( pinSkill == cinSkillMed )
		{
			vinBotSkill_Fixed = pinSkill;
			vinBotSkill_Variable_Min = cinSkillRange_Med_Min;
			vinBotSkill_Variable_Max = cinSkillRange_Med_Max;
		}
		else
		if ( pinSkill == cinSkillHigh )
		{
			vinBotSkill_Fixed = pinSkill;
			vinBotSkill_Variable_Min = cinSkillRange_High_Min;
			vinBotSkill_Variable_Max = cinSkillRange_High_Max;
		}
		else
		if ( pinSkill == cinSkillHighest )
		{
			vinBotSkill_Fixed = pinSkill;
			vinBotSkill_Variable_Min = cinSkillRange_High_Max;
			vinBotSkill_Variable_Max = cinSkillRange_High_Max;
		}
		else
		{
			vinBotSkill_Variable_Min = pinSkill;
			vinBotSkill_Variable_Max = pinSkill;

			if ( ( pinSkill >= cinSkillRange_Low_Min ) && ( pinSkill <= cinSkillRange_Low_Max ) )
			{
				vinBotSkill_Fixed = cinSkillLow;
			}
			else
			if ( ( pinSkill >= cinSkillRange_Med_Min ) && ( pinSkill <= cinSkillRange_Med_Max ) ) 
			{
				vinBotSkill_Fixed = cinSkillMed;
			}
			else
			if ( ( pinSkill > cinSkillRange_High_Min ) && ( pinSkill <= cinSkillRange_High_Max ) ) 
			{
				vinBotSkill_Fixed = cinSkillHigh;
			}
			else
				return false;
		}

		string vtxCmd;

		if ( vinBotSystem == cinBot_PLCBmix
					||
			  vinBotSystem == cinBot_CBPODmix 
					||
			  vinBotSystem == cinBot_CBJOEmix 
					||
			  vinBotSystem == cinBot_CB ) 
		{
			vtxCmd = "cb_skill " +  ftxGetActualBotSkill( cinBot_CB ) + "\n";
			fvoServerPrint( vtxCmd );
			fvoServerCommand( vtxCmd );	
			goto locSetSkill;
		}

		if ( vboSkillChangeSupported( ) || vclBotControl.fboBotAimIsOn( ) )
		{
			goto locSetSkill;
		}

		return false;

		locSetSkill:
		{
			if ( !vclBotControl.fboBotAimIsOn( ) )
			{
				// remove existing bots and record how many were removed;
				int vinBotsInGame = finKickAllBots( );
				// add same number of bots back with the new skill;
				// we have to delay this to allow time to first remove
				// all of the existing bots;
				vclEventSched.fboCreateEvent( );
				vclEventSched.fboCreateArgList( 1 );
				vclEventSched.finSetArg_Int( "numbots", vinBotsInGame );
				//vclEventSched.finSetArg_Int( 0, vinBotsInGame );
				vclEventSched.fvoSetEventFunc( fvoMA_BOT_Event_fvoAddBots );
				vclEventSched.fvoSetDelayInSecs( 5.0 );
				vclEventSched.fboSendEvent( );
			}
			
			vclBotControl.fvoSetBotSkill( vinBotSkill_Variable_Min, vinBotSkill_Variable_Max );
		}
		
		return true;

	} // tclBot::fboSetBotSkill

	void fvoDisplayBalanceMsg( string ptxMsg )
	{
		if ( ftxToLower( ftxCVarGetString( ctxCVAR_AutoBalanceDisply ) ) == "on" )
		{
			fvoServerPrint_nl( ptxMsg );
		}
		
	} // fvoDisplayBalanceMsg


	void fvoGenBotDiff( 
		int vinBotTeam,
		int vinDesiredNumBots, 
		int vinBotsOnCT, int vinBotsOnTE, 
		int vinHumansOnTE, int vinHumansOnCT,
		int &vinBotDiff_CT, int &vinBotDiff_TE )
	{
		int vinDesiredNumBots_CT;
		int vinDesiredNumBots_TE;

		vinBotDiff_CT = 0;
		vinBotDiff_TE = 0;
		
		if ( vinDesiredNumBots <= 0 ) 
		{
			// kick all bots;
			vinDesiredNumBots_CT = 0;
			vinDesiredNumBots_TE = 0; 				
			vinBotDiff_CT = vinDesiredNumBots_CT - vinBotsOnCT;
			vinBotDiff_TE = vinDesiredNumBots_TE - vinBotsOnTE;
		}
		else
		if ( vinBotTeam == cinTeam_Any )
		{
			int vinTeamDiff = abs( vinHumansOnTE - vinHumansOnCT );
			int vinBotsToAdd = ( vinDesiredNumBots - vinTeamDiff ) / 2;

			if ( vinHumansOnTE < vinHumansOnCT )
			{
				vinBotDiff_CT = vinBotsToAdd - vinBotsOnCT;
				vinBotDiff_TE = ( vinTeamDiff + vinBotsToAdd ) - vinBotsOnTE;
				if ( ( vinBotsToAdd * 2 ) != ( vinDesiredNumBots - vinTeamDiff ) )
					vinBotDiff_CT += 1;

			}
			else
			if ( vinHumansOnCT < vinHumansOnTE )
			{
				vinBotDiff_CT = ( vinTeamDiff + vinBotsToAdd ) - vinBotsOnCT;
				vinBotDiff_TE = vinBotsToAdd - vinBotsOnTE;
				if ( ( vinBotsToAdd * 2 ) != ( vinDesiredNumBots - vinTeamDiff ) )
					vinBotDiff_CT += 1;
			}
			else
			{
				vinBotDiff_CT = vinBotsToAdd - vinBotsOnCT;
				vinBotDiff_TE = vinBotsToAdd - vinBotsOnTE;
				if ( ( vinBotsToAdd * 2 ) != ( vinDesiredNumBots - vinTeamDiff ) )
					vinBotDiff_CT += 1;

			}
		}
		else
		{
			if ( vinBotTeam == cinTeam_CT )
			{
				vinDesiredNumBots_CT = vinDesiredNumBots;
				vinDesiredNumBots_TE = 0;
			}
			else
			if ( vinBotTeam == cinTeam_TE )
			{
				vinDesiredNumBots_CT = 0;
				vinDesiredNumBots_TE = vinDesiredNumBots;
			}
			vinBotDiff_CT = vinDesiredNumBots_CT - vinBotsOnCT;
			vinBotDiff_TE = vinDesiredNumBots_TE - vinBotsOnTE;
		}

	} // fvoGenBotDiff

	void tclBot::fvoBalanceBots( void )
	{
		if ( vboBalanceBots == false )
			return;

		if ( vinBotSystem == cinBot_Unknown )
		{ // bots not present or not supported - cannot perform a balance.
			return;
		}

		int vinHumanTeam = finGetHumanTeam( );
		if ( vinHumanTeam == cinTeam_Unknown )
			return;

		int vinBotTeam = finGetBotTeam( );
		if ( vinBotTeam == cinTeam_Unknown )
			return;

		int vinHumanSpectators;
		int vinBotSpectators;
		int vinHumansOnCT;
		int vinHumansOnTE;
		int vinBotsOnCT;
		int vinBotsOnTE;

		vclPlayer.fvoCountEveryOne				
			( vinHumanSpectators, vinBotSpectators, 
		     vinHumansOnTE     , vinBotsOnTE,
		     vinHumansOnCT     , vinBotsOnCT );

		int vinHumansOnHumanTeam	= 0;
//		int vinBotsOnHumanTeam		= 0;
		int vinBotsOnBotTeam			= 0;

		int vinHumansOnAnyTeam	= vinHumansOnTE + vinHumansOnCT;
		int vinBotsOnAnyTeam		= vinBotsOnTE + vinBotsOnCT;
		int vinPlayersOnAnyTeam	= vinBotsOnAnyTeam + vinHumansOnAnyTeam;
//		int vinPlayersOnTE		= vinBotsOnTE + vinHumansOnTE;
//		int vinPlayersOnCT		= vinBotsOnCT + vinHumansOnCT;
		int  vinTotalBotsInGame = vinBotsOnAnyTeam + vinBotSpectators;

		if ( vinHumanTeam == cinTeam_Any )
		{
			vinHumansOnHumanTeam = vinHumansOnTE + vinHumansOnCT;
			vinBotsOnBotTeam		= vinBotsOnTE + vinBotsOnCT;
		}
		else
		if ( vinHumanTeam == cinTeam_TE )
		{
			vinHumansOnHumanTeam = vinHumansOnTE;
//			vinBotsOnHumanTeam   = vinBotsOnTE;
			vinBotsOnBotTeam		= vinBotsOnCT;
		}
		else
		if ( vinHumanTeam == cinTeam_CT )
		{
			vinHumansOnHumanTeam = vinHumansOnCT;
//			vinBotsOnHumanTeam   = vinBotsOnCT;
			vinBotsOnBotTeam		= vinBotsOnTE;
		}

		string vtxMsg = ctxMsgPrefix + "Bot mode: ";

		if ( vinBotMode == cinBotMode_NoBots )
			vtxMsg += "no bots";
		else
		if ( vinBotMode == cinBotMode_BotvsBot )
			vtxMsg += "bots vs bots";
		else
		if ( vinBotMode == cinBotMode_BotsWhenXPlayers )
			vtxMsg += "bots when " + ftxIntToString( vinBotsWhenMinPlayers ) + " human players or less";
		else
		if ( vinBotMode == cinBotMode_BotsFillServer )
			vtxMsg += "bots fill server";
		else
		if ( vinBotMode == cinBotMode_BotsvsHumans )
			vtxMsg += "bots vs humans";
		else
			vtxMsg += "unknown";

		fvoDisplayBalanceMsg( vtxMsg );

		vtxMsg = ctxMsgPrefix + "Balancing Bots ...";
		fvoDisplayBalanceMsg( vtxMsg );
		vtxMsg = "... Found: " + ftxIntToString( vinHumanSpectators ) + " human spectators.";
		fvoDisplayBalanceMsg( vtxMsg );
		vtxMsg = "... Found: " + ftxIntToString( vinHumansOnTE ) + " humans on TE team.";
		fvoDisplayBalanceMsg( vtxMsg );
		vtxMsg = "... Found: " + ftxIntToString( vinHumansOnCT ) + " humans on CT team.";
		fvoDisplayBalanceMsg( vtxMsg );

		vtxMsg = "... Found: " + ftxIntToString( vinBotSpectators ) + " bot spectators.";
		fvoDisplayBalanceMsg( vtxMsg );
		vtxMsg = "... Found: " + ftxIntToString( vinBotsOnTE ) + " bots on TE team.";
		fvoDisplayBalanceMsg( vtxMsg );
		vtxMsg = "... Found: " + ftxIntToString( vinBotsOnCT ) + " bots on CT team.";
		fvoDisplayBalanceMsg( vtxMsg );

		int vinNumKicked;

		if ( vinBotSpectators > 0 )
		{
			vtxMsg = "... Found " + ftxIntToString( vinBotSpectators ) + " spectator Bots.";
			fvoDisplayBalanceMsg( vtxMsg );
			if ( fboCVarGetBool( ctxCVar_KickSpecBots ) )
			{
			//!!.begin - kicking of spectator bots may result in instability
				vinNumKicked = finKickSpectatorBots( );
				if ( vinNumKicked > 0 )
				fvoDisplayBalanceMsg ("... Kicked " + ftxIntToString( vinNumKicked ) + " spectator bots.");
			//!!.end

			}
		}

/*
		if ( vinBotsOnHumanTeam > 0 )
		{
			vtxMsg = "... Found " + ftxIntToString( vinBotsOnHumanTeam ) + " bots on wrong team.";
			fvoDisplayBalanceMsg( vtxMsg );
			vinNumKicked = finKickAllAliveBotsOffTeam( vinHumanTeam );
			if ( vinNumKicked > 0 )
				fvoDisplayBalanceMsg("... Kicked " + ftxIntToString( vinNumKicked ) + " bots off wrong team.");
		}
*/

		int vinHumanCount = vinHumansOnHumanTeam; 
		int vinBotCount	= vinBotsOnBotTeam + vinBotSpectators; 

		int vinBotDiff_TE;
		int vinBotDiff_CT;
		int vinDesiredNumBots;

		if ( vinHumanCount <= 0 )
		{ 
			// no humans around so set bot count to minimum allowed;

			fvoGenBotDiff( 
				vinBotTeam,	vinMinBots, 
				vinBotsOnCT, vinBotsOnTE, 
				vinHumansOnTE, vinHumansOnCT,	
				vinBotDiff_CT, vinBotDiff_TE );

		}
		else
		if ( vinBotMode == cinBotMode_NoBots )
		{
			fvoGenBotDiff( 
				vinBotTeam,	0, 
				vinBotsOnCT, vinBotsOnTE, 
				vinHumansOnTE, vinHumansOnCT,	
				vinBotDiff_CT, vinBotDiff_TE );

		}
		else
		if ( vinBotMode == cinBotMode_BotvsBot )
		{
			vinDesiredNumBots = int ( vinHumansOnAnyTeam * vflBotHumanRatio ) + vinMinBots;

			if ( vinDesiredNumBots > vinMaxBots )
				vinDesiredNumBots = vinMaxBots;
			else
			if ( vinDesiredNumBots < vinMinBots )
				vinDesiredNumBots = vinMinBots;

			fvoGenBotDiff( 
				vinBotTeam,	vinDesiredNumBots, 
				vinBotsOnCT, vinBotsOnTE, 
				vinHumansOnTE, vinHumansOnCT,	
				vinBotDiff_CT, vinBotDiff_TE );

		}
		else
		if ( vinBotMode == cinBotMode_BotsWhenXPlayers )
		{
			if ( vinHumansOnAnyTeam > vinBotsWhenMinPlayers )
				vinDesiredNumBots = 0;
			else
				vinDesiredNumBots = vinMaxBots;

			fvoGenBotDiff( 
				vinBotTeam,	vinDesiredNumBots, 
				vinBotsOnCT, vinBotsOnTE, 
				vinHumansOnTE, vinHumansOnCT,	
				vinBotDiff_CT, vinBotDiff_TE );
		}
		else
		if ( vinBotMode == cinBotMode_BotsFillServer )
		{
			int vinDesiredNumBots = vinMaxBots - vinPlayersOnAnyTeam;
			vinDesiredNumBots = vinDesiredNumBots + vinBotCount;

			fvoGenBotDiff( 
				vinBotTeam,	vinDesiredNumBots, 
				vinBotsOnCT, vinBotsOnTE, 
				vinHumansOnTE, vinHumansOnCT,	
				vinBotDiff_CT, vinBotDiff_TE );

		}
		else
		if ( vinBotMode == cinBotMode_BotsvsHumans )
		{
			int vinDesiredNumBots = int( vinHumanCount * vflBotHumanRatio);
			if ( vinDesiredNumBots > vinMaxBots )
				vinDesiredNumBots = vinMaxBots;
			else
			if ( vinDesiredNumBots < vinMinBots )
				vinDesiredNumBots = vinMinBots;

			fvoGenBotDiff( 
				vinBotTeam,	vinDesiredNumBots, 
				vinBotsOnCT, vinBotsOnTE, 
				vinHumansOnTE, vinHumansOnCT,	
				vinBotDiff_CT, vinBotDiff_TE );
		}

		if ( ( vinBotDiff_CT == 0 ) && ( vinBotDiff_TE == 0 ) )
		{
			vtxMsg = "... No adjustment needed. Bots are in a balanced state.";
			fvoDisplayBalanceMsg( vtxMsg );
		}
		{

			// make sure that we do not add more bots than the max bot setting allows;

			int vinOrder = finRandom(1, 2);
			int vinPass;
			int vinBotDiff;

			locBotDiff:
			vinBotDiff = ( vinBotDiff_CT + vinBotDiff_TE + vinTotalBotsInGame ) - vinMaxBots;

			if ( vinOrder = 1 && vinPass < 2 )
			{
				if ( vinBotDiff_CT > 0 && vinBotDiff > 0 )
				{
					vtxMsg = "... Maximum bot limit will be reached. Lowering CT adjustment.";
					fvoDisplayBalanceMsg( vtxMsg );

					vinBotDiff_CT = vinBotDiff_CT - vinBotDiff;
					if ( vinBotDiff_CT < 0 )
						vinBotDiff_CT = 0;
				}
				vinOrder = 2;
				vinPass++;
				if ( vinPass < 2 )
					goto locBotDiff;
			}

			if ( vinOrder = 2 && vinPass < 2 )
			{
				if ( vinBotDiff_TE > 0 && vinBotDiff > 0 )
				{
					vtxMsg = "... Maximum bot limit will be reached. Lowering TE adjustment.";
					fvoDisplayBalanceMsg( vtxMsg );

					vinBotDiff_TE = vinBotDiff_TE - vinBotDiff;
					if ( vinBotDiff_TE < 0 )
						vinBotDiff_TE = 0;
				}
				vinOrder = 1;
				vinPass++;
				if ( vinPass < 2 )
					goto locBotDiff;
			}
			
			if ( vinBotDiff_CT > 0 )
			{
				vtxMsg = "... Adding to CT Team " + ftxIntToString( vinBotDiff_CT ) + " bots.";
				fvoDisplayBalanceMsg( vtxMsg );
				finAddBots ( cinTeam_CT, vinBotDiff_CT );
			}
			else
			if ( vinBotDiff_CT < 0 )
			{
				vinBotDiff_CT = abs( vinBotDiff_CT );
				vtxMsg = "... Removing from CT Team " + ftxIntToString( vinBotDiff_CT ) + " bots.";
				fvoDisplayBalanceMsg( vtxMsg );
				finKickBots ( cinTeam_CT, vinBotDiff_CT );
			}

			if ( vinBotDiff_TE > 0 )
			{
				vtxMsg = "... Adding to TE Team " + ftxIntToString( vinBotDiff_TE ) + " bots.";
				fvoDisplayBalanceMsg( vtxMsg );
				finAddBots ( cinTeam_TE, vinBotDiff_TE );
			}
			else
			if ( vinBotDiff_TE < 0 )
			{
				vinBotDiff_TE = abs( vinBotDiff_TE );
				vtxMsg = "... Removing from TE Team " + ftxIntToString( vinBotDiff_TE ) + " bots.";
				fvoDisplayBalanceMsg( vtxMsg );
				finKickBots ( cinTeam_TE, vinBotDiff_TE );
			}
		}		

		vtxMsg = ctxMsgPrefix + "Bot team balance completed.";
		fvoDisplayBalanceMsg( vtxMsg );

	} // tclBot::fvoBalanceBots

	bool tclBot::fboSetBotTeam( int pinNewTeam )
	{
		if ( vinBotSystem == cinBot_Unknown )
			return false;

		if ( ( pinNewTeam != cinTeam_TE )
			      &&
			  ( pinNewTeam != cinTeam_CT )
					&&
			  ( pinNewTeam != cinTeam_Any ) )
		// disallow invalid team setting
		return false;
	
	//	finKickAllBotsOffTeam( cinTeam_Any );
		vinCurrentBotTeam = pinNewTeam;
	//	finAddBots( vinCurrentBotTeam, vinMinBots );

		if ( vinCurrentBotTeam != cinTeam_Any )
		// ensure bot team does not get autobalanced or
		// bots will be moved to the wrong team.
			fvoCVarSetString( "mp_autoteambalance", "0" );

		return true;

	} // tclBot::fboSetBotTeam

	void tclBot::fvoFillServerWithBots( void )
	{
		if ( vinBotSystem == cinBot_Unknown )
			return;

		int vinBotTeam = finGetBotTeam( );
		finKickAllBots( );
		if ( vclPlayer.finCountBotsOnTeam( cinTeam_Any ) <= 0  )
		{
			finAddBots( vinBotTeam, vinMinBots );
		}
	} // tclBot::fvoFillServerWithBots

	bool tclBot::fboSwitchBotTeam( void )
	{
		//!! FIX SO THAT TEAMS CAN BE SWITCHED WITHOUT AUTO KICKING BOTS

		if ( vinBotSystem == cinBot_Unknown )
			return false;

		int vinCurBotTeam = finGetBotTeam( );

		if ( ( vinCurBotTeam == cinTeam_Unknown )
				   ||
			  ( vinCurBotTeam == cinTeam_Any ) )
		// cannot switch teams
		return false;

		int vinNewBotTeam;

		if ( vinCurBotTeam == cinTeam_TE )
			vinNewBotTeam = cinTeam_CT;
		else
		if ( vinCurBotTeam == cinTeam_CT )
			vinNewBotTeam = cinTeam_TE;
		else
			return false;

		if ( !fboSetBotTeam( vinNewBotTeam ) )
			return false;

		// remove existing bots and record how many were removed;
	//	int vinBotsInGame = finKickAllBots( );
		// add same number of bots back on new team;
		// we have to delay this to allow time to first remove
		// all of the existing bots;
	//	vclEventSched.fboCreateEvent( );
	//	vclEventSched.fboCreateArgList( 1 );
	//	vclEventSched.finSetArg_Int( "numbots", vinBotsInGame );
		//vclEventSched.finSetArg_Int( 0, vinBotsInGame );
	//	vclEventSched.fvoSetEventFunc( fvoMA_BOT_Event_fvoAddBots );
	//	vclEventSched.fvoSetDelayInSecs( 4.0 );
	//	vclEventSched.fboSendEvent( );
		return true;

	} // tclBot::fboSwitchBotTeam

	bool tclBot::fboSwitchBotTeamRandomly( )
	{
		if ( !vboRandomBotTeamSwitch )
			return false;

		if ( vinBotSystem == cinBot_Unknown )
			return false;

		if ( finGetBotMode( ) == cinBotMode_NoBots )
			return false;

		if ( vflProbOfBotTeamSwitch > 1 || vflProbOfBotTeamSwitch <= 0 )
			return false;

		float vflSwitch = fflRandomFloat( 0, 1 );

		if ( vflSwitch <= vflProbOfBotTeamSwitch )
			return fboSwitchBotTeam( );
		
		return false;

	} // tclBot::fboSwitchBotTeamRandomly

	bool tclBot::fboSwitchBotSkillRandomly( )
	{
		if ( !vboRandomBotSkillSwitch )
			return false;

		if ( vinBotSystem == cinBot_Unknown )
			return false;

		if ( finGetBotMode( ) == cinBotMode_NoBots )
			return false;

		if ( vflProbOfBotSkillSwitch > 1 || vflProbOfBotSkillSwitch <= 0 )
			return false;

		float vflSwitch = fflRandomFloat( 0, 1 );

		if ( vflSwitch <= vflProbOfBotSkillSwitch )
		{
			int vinSelect = finRandom( 0, 6 );

			if ( vinSelect == 0 )
				vinSelect = cinSkillRand; 
			else
			if ( vinSelect == 1 )
				vinSelect = cinSkillInsane;
			else
			if ( vinSelect == 2 )
				vinSelect = cinSkillLowest;
			else
			if ( vinSelect == 3 )
				vinSelect = cinSkillHighest;
			else
			if ( vinSelect == 4 )
				vinSelect = cinSkillLow;
			else
			if ( vinSelect == 5 )
				vinSelect = cinSkillMed;
			else
			if ( vinSelect == 6 )
				vinSelect = cinSkillHigh;
			else
				vinSelect = cinSkillNotSet;

			return fboSetBotSkill( vinSelect );
		}

		return false;

	} // tclBot::fboSwitchBotSkillRandomly

	void tclBot::fvoKillAllHumansOnBotTeam( string ptxReason )
	{
		int vinBotTeam = finGetBotTeam( );

		if ( ( vinBotTeam == cinTeam_Unknown )
					|| 
			  ( vinBotTeam == cinTeam_Any )
			)
		return;

		vclPlayer.fvoKillAllHumansOnBotTeam( vinBotTeam, ptxReason );

	} // tclBot::fvoKillAllHumansOnBotTeam

	void tclBot::fvoSwitchAllHumansOnBotTeam( string ptxReason )
	{
		int vinBotTeam = finGetBotTeam( );

		if ( ( vinBotTeam == cinTeam_Unknown )
					|| 
			  ( vinBotTeam == cinTeam_Any )
			)
		return;

		vclPlayer.fvoSwitchAllHumansOnBotTeam( vinBotTeam, ptxReason );

	} // tclBot::fvoSwitchAllHumansOnBotTeam

	void tclBot::fvoEnforceBotTeam( void )
	{
		if ( vboEnforceBotTeam && vboBotsInGame )
		{
			fvoKillAllHumansOnBotTeam( "You are on the BOT team - press 'M' to switch teams.\n" );
			//fvoSwitchAllHumansOnBotTeam( "" );
		}

	} // tclBot::fvoEnforceBotTeam

	bool tclBot::fboEmitSoundFromBot ( int pinPlayerIndex, string ptxSoundFile )
	{
		if ( ptxSoundFile.empty( ) )
			return false; 

		if ( !vclPlayer.fboPlayerIsBotByIndex( pinPlayerIndex ) )
			return false; 

		return vclPlayer.fboEmitSoundFromAlivePlayerByIndex 
					( pinPlayerIndex, ptxSoundFile );

	} // tclBot::fboEmitSoundFromBot

	bool tclBot::fboEmitSoundFromABot ( string ptxSoundFile )
	{

		if ( ptxSoundFile.empty( ) )
			return false;

		int vin_aryBot[ cinMaxPlayers ];
		int vinBotCount = 0;

		for ( int vinIdx = cinMinPlayerIndex; 
				vinIdx <= vclPlayer.finGetMaxPlayers(); 
				vinIdx++ )
		{  // cycle through each player counting and storing index of living bots.

			if ( vclPlayer.fboPlayerIsBotByIndex( vinIdx )
						&& 
				  vclPlayer.fboPlayerIsAliveByIndex( vinIdx ) 
				)
			{	
				vin_aryBot[ vinBotCount ] = vinIdx;
				vinBotCount++;
			}
		}

		if ( vinBotCount <= 0 )
			return false;

		return fboEmitSoundFromBot( vin_aryBot[ rand() % vinBotCount ], ptxSoundFile );

	} // tclBot::fboEmitSoundFromABot

	bool tclBot::fboBotYell( void )
	{
		string vtxSndFile = vclSoundCmdList_System.ftxGetSoundFile( "botyell" );
		return fboEmitSoundFromABot( vtxSndFile );
	} // tclBot::fvoBotYell

	bool tclBot::fboBotSpeak( void )
	{
		string vtxSndFile = vclSoundCmdList_BotRandom.ftxGetSoundFile( "randombotsound" );
		return fboEmitSoundFromABot( vtxSndFile );
	} // tclBot::fvoBotSpeak

	void	tclBot::fvoCheckStatsProtection( void )
	{
		if ( !fboStatsProtectionIsOn( ) )
			return;

		string vtxSwitch = ftxCVarGetString( "mp_logfile" );

		// fvoServerPrint_nl( "Bots: " + ftxIntToString( vinBotCount ) + " Switch: " + vtxSwitch );

		if ( vboBotsInGame )
		{
			if ( vtxSwitch != "0" )
			{
				// fvoServerCommand_nl( "log off" );
				fvoCVarSetString( "mp_logfile", "0" );
				// fvoServerCommand_nl( "log on" ); // so statsme can keep working;
				fvoServerPrint_nl( ctxMsgPrefix + "Bots in Game: File logging turned off." );
			}
		}
		else
		{
			if ( vtxSwitch != "1" )
			{
				// fvoServerCommand_nl( "log off" );
				fvoCVarSetString( "mp_logfile", "1" );
				// fvoServerCommand_nl( "log on" );
				// fvoServerPrint_nl( ctxMsgPrefix + "No Bots in Game: File logging turned back on." );
				fvoServerPrint_nl( ctxMsgPrefix + "No Bots in Game: File logging turned back on." );
			}
		}

	} // tclBot::fvoCheckStatsProtection

	void	tclBot::fvoCheckPODBotFixProtection( void )
	{

		if ( !fboPODBotFixProtectionIsOn( ) )
			return;

		string vtxSwitch = ftxCVarGetString( ctxCVar_PODFixes );

		if ( !fboPODBotIsLoaded( ) )
		{
			if ( vtxSwitch != "off" )
				goto locTurnOff;
			return;
		}

		if ( vboBotsInGame )
		{
			if ( vtxSwitch != "on" )  
				goto locTurnOn;
		}
		else
		if ( vtxSwitch != "off" ) 
			goto locTurnOff;
		
		return;

		locTurnOn:
			fvoCVarSetString( ctxCVar_PODFixes, "on" );
			fvoServerPrint_nl( ctxMsgPrefix + "PODBots in Game: POD fixes turned on." );
			return;

		locTurnOff:
			fvoCVarSetString( ctxCVar_PODFixes, "off" );
			fvoServerPrint_nl( ctxMsgPrefix + "No POD Bots in Game: POD fixes turned off." );
			return;

	} // tclBot::fvoCheckPODBotFixProtection

	bool fboDublicateName( const string ptxName )
	{
		if ( ptxName.length( ) <= 0 )
			return false;

		if ( ptxName[ 0 ] != '(' )
			return false;

		string vtxNum = "";
		int vinNum;
		int vinLength = ptxName.length( );
	// 0123
	// (xx)

		int vinIdx = 1;
		while ( vinIdx <vinLength )
		{
			if ( vinIdx > 3)
				return false;

			if ( ptxName[ vinIdx ] == ')' )
				goto locCheck;

			vtxNum += ptxName[ vinIdx ];
			vinIdx++;
		}

		locCheck:
			return ( finStringToInt( vtxNum ) > 0 );
		
	} // fboDublicateName

	int tclBot::finRemoveDupNamedBots( )
	{

		if ( !fboKickDupBotsIsOn( ) )
			return 0;

		int vinNumKicked = 0;
		int vinIdx;
		string vtxName;

		for ( vinIdx = cinMinPlayerIndex; 
				vinIdx <= vclPlayer.finGetMaxPlayers( ); 
				vinIdx++ )
		{
			if ( vclPlayer.fboPlayerIsBotByIndex( vinIdx ) )
			{
				vtxName = vclPlayer.ftxGetPlayerNameByIndex( vinIdx );
				if ( fboDublicateName( vtxName ) )
				{
					if ( vclPlayer.fboKickPlayerByIndex( vinIdx, "" ) )
						vinNumKicked++;
				}
			}//.if
		} //.for
		
		return vinNumKicked;

	} // tclBot::finRemoveDupNamedBots

