//.b 	
//	Copyright 2001 [MEAN].BOT
//	
//	File: MA_BotControl.h
//	
//	[MEAN] Alternate control for bots
//
//.e	

//.b skip over if header has already been included.
#ifndef defMA_BotControl_h

// Prevent the reprocessing of this definition file by defining 
// the alias used in the above "ifndef" check.
#define defMA_BotControl_h

	// Include all general definition files.
	#include "MB_Includes.h"
	#include "MA_Player.h"
	#include "MA_time.h"
	#include "MA_Weapon.h"
	#include "MA_Message.h"

// remove "x" to enable individual debug trace options;
	#define xdefDebug_Bot
	#define xdefDebug_Bombing
	#define xdefDebug_Zooming
	#define xdefDebug_Nade
	#define xdefDebug_WeaponSelect
	#define xdefDebug_ShieldCheck
	#define xdefDebug_BoneIndex
	#ifdef defDebug_Bot

		void fvoDebugBot( edict_t* pst_ptrEdict, string ptxMsg );
		#ifdef defDebug_Bombing
		void fvoDebugBot_Bombing( edict_t* pst_ptrEdict, string ptxMsg );
		#endif
		#ifdef defDebug_Bombing
		void fvoDebugBot_Zooming( edict_t* pst_ptrEdict, string ptxMsg );
		#endif
		#ifdef defDebug_Nade
		void fvoDebugBot_Nade( edict_t* pst_ptrEdict, string ptxMsg );
		#endif
		#ifdef defDebug_WeaponSelect
		void fvoDebugBot_WeaponSelect( edict_t* pst_ptrEdict, string ptxMsg );
		#endif
		#ifdef defDebug_BoneIndex
		void fvoDebugBot_BoneIndex( edict_t* pst_ptrEdict, string ptxMsg );
		#endif
		#ifdef defDebug_ShieldCheck
		void fvoDebugBot_ShieldCheck( edict_t* pst_ptrEdict, string ptxMsg );
		#endif
	#endif

// Search for visible bones!
// http://dynamic.gamespy.com/~botman/yabb/YaBB.pl?board=2&action=display&num=4010
//

//.!! Should be moved elsewhere
const string ctxCVar_KickSpecBots				= "m_kickspecbots";
const string ctxCVAR_AutoBalanceDisply			= "m_autobalancedisplay";
const string ctxCVar_BotDamageAffects			= "m_boteffectswhenhit";
const string ctxCVar_BotsThrowSparks			= "m_botsmakesparkswhenhit";
const string ctxCVar_BotsMakeDamageSounds		= "m_botsmakesoundswhenhit";
const string ctxCVar_WeaponBanPenalty			= "m_WeaponBanPenalty";
const string ctxCVar_WeaponBanPenalty_Amount = "m_WeaponBanPenalty_amount";

const string ctxCVAR_AutoBalanceInterval		= "m_autobalanceinterval";
const int cinAutoBalanceIntervalMin =   1; // seconds;
const int cinAutoBalanceIntervalMax = 600;

// off health_reduced health_dropped timebomb slap_soft slap_hard slap_bitch death
// (health reduced to) (health points lost) (time to explosion) (number of slaps) (ignored)

//.!!

const float cflUpdateCVarsInSec = 7.0;

const string ctxCVar_TKBan					= "m_tkban"; // ban after number of kills:  0 disables
const string ctxCVar_TKBotBan				= "m_tkbotban"; // on | off
const string ctxCVar_TKHumanBan			= "m_tkhumanban"; // on | off
const string ctxCVar_TKBotsShootBack	= "m_tkbotsshootback"; // probability
const string ctxCVar_TKBotsInsult		= "m_tkbotsinsult"; // probability
const string ctxCVar_TKBotPunish			= "m_tkbotpunish"; // on | off
const string ctxCVar_TKHumanPunish		= "m_tkhumanpunish"; // on | off

const string ctxCVar_BotAimFix			= "m_botaimfix";
const string ctxCVar_BotScopeFix			= "m_botscopefix";
const string ctxCVar_BotKnifeFix			= "m_botknifefix";
const string ctxCVar_BotNadeFix			= "m_botnadefix";
const string ctxCVar_BotNadeThrowDelay	= "m_botnadethrowdelay";
const string ctxCVar_PODFixes				= "m_podfixes";
const string ctxCVar_PODHostageFix		= "m_podhostagefix";
const string ctxCVar_BotBombFix			= "m_botbombfix";
const string ctxCVar_BotJumpFix			= "m_botjumpfix";
const string ctxCVar_BotLogFix			= "m_botlogfix";
const string ctxCVar_BotsBuyDefuseKit	= "m_botsbuydefusekit";
const string ctxCVar_BotsBuyHENade		= "m_botsbuyhenade";
const string ctxCVar_BotsBuyFlashNade	= "m_botsbuyflashnade";
const string ctxCVar_BotsBuySmokeNade	= "m_botsbuysmokenade";
const string ctxCVar_BotBuyDelay			= "m_botbuydelay";
const string ctxCVar_BotZoomDelay		= "m_botzoomdelay";
const string ctxCVar_BotScopeDelay		= "m_botscopedelay";
const string ctxCVar_BotScopeDelay_awp	= "m_botscopedelay_awp";
const string ctxCVar_BotCombatFix		= "m_botcombatfix";
const string ctxCVar_BotsShootThroughWalls = "m_botsshootthroughwalls";

const string ctxCVar_BotSkillDelay		= "m_botskilldelay";

const string ctxCVar_BotTargetFrameScanRate	= "m_bottargetframescanrate";
const int cinBotTargetFrameScanRateMin = 1;
const int cinBotTargetFrameScanRateMax = 100;

const string ctxCVar_BotTargetPlayerScanRate	= "m_bottargetplayerscanrate";
const int cinBotTargetPlayerScanRateMin = 1;
const int cinBotTargetPlayerScanRateMax = cinMaxPlayers;

//const string ctxCVar_BotSkillPistol		= "m_botskill_pistol";
//const string ctxCVar_BotSkillSub			= "m_botskill_sub";
//const string ctxCVar_BotSkillAssault	= "m_botskill_assault";
//const string ctxCVar_BotSkillZoom		= "m_botskill_zoom";
//const string ctxCVar_BotSkillSnipe		= "m_botskill_snipe";

const string ctxCVar_BotBurstFireFix	= "m_botburstfirefix";

const float			cflBotBurstFireDistMin	= 0;
const float			cflBotBurstFireDistMax	= 10000;
const string ctxCVar_BotBurstFireDist_Min	= "m_botburstfire_dist_min";

const float			cflBotBurstFireOnMin	= 0;
const float			cflBotBurstFireOnMax	= 300;
const string ctxCVar_BotBurstFireOnMin	= "m_botburstfire_on_min"; // in seconds
const string ctxCVar_BotBurstFireOnMax	= "m_botburstfire_on_max";

const float			cflBotBurstFireOffMin	= 0;
const float			cflBotBurstFireOffMax	= 300;
const string ctxCVar_BotBurstFireOffMin= "m_botburstfire_off_min";
const string ctxCVar_BotBurstFireOffMax= "m_botburstfire_off_max";

//const float			cflBotJumpOnMin	= 0;
//const float			cflBotJumpOnMax	= 300;
//const string ctxCVar_BotJumpOnMin	= "m_botjump_on_min"; // in seconds
//const string ctxCVar_BotJumpOnMax	= "m_botjump_on_max";

//const float			cflBotJumpOffMin	= 0;
//const float			cflBotJumpOffMax	= 300;
//const string ctxCVar_BotJumpOffMin= "m_botjump_off_min";
//const string ctxCVar_BotJumpOffMax= "m_botjump_off_max";

//const float			cflBotDuckOnMin	= 0;
//const float			cflBotDuckOnMax	= 300;
//const string ctxCVar_BotDuckOnMin	= "m_botDuck_on_min"; // in seconds
//const string ctxCVar_BotDuckOnMax	= "m_botDuck_on_max";

//const float			cflBotDuckOffMin	= 0;
//const float			cflBotDuckOffMax	= 300;
//const string ctxCVar_BotDuckOffMin= "m_botDuck_off_min";
//const string ctxCVar_BotDuckOffMax= "m_botDuck_off_max";

//const float			cflBotStopOnMin	= 0;
//const float			cflBotStopOnMax	= 300;
//const string ctxCVar_BotStopOnMin	= "m_botStop_on_min"; // in seconds
//const string ctxCVar_BotStopOnMax	= "m_botStop_on_max";

//const float			cflBotStopOffMin	= 0;
//const float			cflBotStopOffMax	= 300;
//const string ctxCVar_BotStopOffMin= "m_botStop_off_min";
//const string ctxCVar_BotStopOffMax= "m_botStop_off_max";

//!! should be moved to a CVAR module;
const string ctxCVar_WeapomSelectBan	= "m_weaponselectban";

// silent walk control switch;
const string ctxCVar_BotSilentWalk		= "m_botsilentwalk";

// allowable walk speed;
const float			cflWalkSpeedMin		= 0;
const float			cflWalkSpeedMax		= 320;
const string ctxCVar_BotWalkSpeed		= "m_botwalkspeed"; 

// allowable run speed;
const float			cflRunSpeedMin		   = 0;
const float			cflRunSpeedMax		   = 1000;
const string ctxCVar_BotRunSpeed			= "m_botrunspeed"; 

// allowable number of seconds to rush from spawn before walking is allowed;
const int			cinBotRushTimeMin		= 0;
const int			cinBotRushTimeMax		= 300;
const string ctxCVar_BotRushTimeMin		= "m_botrushtime_min"; 
const string ctxCVar_BotRushTimeMax		= "m_botrushtime_max";

// allowable number of seconds of walking;
const int			cinBotWalkTimeMin		= 0;
const int			cinBotWalkTimeMax		= 300;
const string ctxCVar_BotWalkTimeMin		= "m_botwalktime_min";
const string ctxCVar_BotWalkTimeMax		= "m_botwalktime_max";

// allowable number of seconds between walking;
const int			cinBotRunTimeMin		= 0;
const int			cinBotRunTimeMax		= 300;
const string ctxCVar_BotRunTimeMin		= "m_botruntime_min";
const string ctxCVar_BotRunTimeMax		= "m_botruntime_max";

// allowable number of seconds to disengage walking after taking damage;
const int			cinBotFightTimeMin	= 0;
const int			cinBotFightTimeMax	= 300;
const string ctxCVar_BotFightTimeMin	= "m_botfighttime_min";
const string ctxCVar_BotFightTimeMax	= "m_botfighttime_max";

// allowable FOV settings for "seeing" enemy targets;
const float			cflFieldOfViewMin		= -1; // +- 180
const float			cflFieldOfViewMax		=  1; // +- 0
const string ctxCVar_FieldOfView		= "m_fieldofview"; 

// allow time for a scope action to complete;
// const float cflScopeDelay = 0.09;
const float cflBotScopeDelayMin = 0.00;
const float cflBotScopeDelayMax = 1.00;

const float cflBotNadeDelayMin = 0.00;
const float cflBotNadeDelayMax = 1.00;

const float cflHoldStillDelay = 0.25; // stop for aiming;

const float cflBotSkillDelayMin = 0.0;
const float cflBotSkillDelayMax = 5.0;

	class tstBotStatus
	{
		private:
			int vinBoneIndex;
//			float vflMaxSpeed;
			float vflMaxSpeed_ORIG;

		public:
		int vinBotIdx;
		int vinScanIndex;
		int vinScanCount;
		int vinBotSkill;
		bool vboActionWalk;     // true = forced walking; false = normal bot control;
		bool vboActionDuck;
		bool vboActionNoJump;
		bool vboActionNoMove;
		bool vboActionBurstFire;
		bool vboBurstFire_State;
		bool vboIgnoreBotMovement;
		float vflBurstRate_OnMin;
		float vflBurstRate_OnMax;
		float vflBurstRate_OffMin;
		float vflBurstRate_OffMax;
		
//		float fflGetMaxSpeed( );
		float fflGetMaxSpeed_ORIG( ){ return vflMaxSpeed_ORIG; };
//		void fvoSetMaxSpeed( float pflNewMaxSpeed ){ vflMaxSpeed = pflNewMaxSpeed; };
		void fvoSetMaxSpeed_ORIG( float pflOrigMaxSpeed ){ vflMaxSpeed_ORIG = pflOrigMaxSpeed; };

		bool vboActionHasKnife;
		bool vboActionHasNade;
		bool vboPlantBomb;
		bool vboActionZoom;
		bool fboHasZoom( ) { if ( vst_ptrWeapon == NULL ) return false; return ( vst_ptrWeapon->fboHasZoom( ) ); };
		bool fboHasScope( ) { if ( vst_ptrWeapon == NULL ) return false; return ( vst_ptrWeapon->fboHasScope( ) ); };
		bool vboZoomReady;
		bool vboAllowRescope;
		bool fboWaitForRescope( );
		bool vboHasTarget;
		int vinKnifeAttack;
		int vinNadeAttack;

		string vtxWeaponModel_Full;
		string vtxWeaponModel_Compact;
		int vinWeaponIndex;
		tstWeapon* vst_ptrWeapon;
		float vflMinTrackTime;
		float vflMaxTrackTime;
		float vflDistance;
		float vflPrevHealth;    // used to detect if taking damage;
	
		tclTimer vclWalkTimer;  // timer for measuring walk/run time;
		tclTimer vclAttackTimer;
		tclTimer vclNadeTimer;
		tclTimer vclNoJumpTimer;	// suppress jumping at spawn or when shooting from a distance;
		tclTimer vclDuckTimer;
		tclTimer vclNoMoveTimer;
		tclTimer vclBurstFireTimer;
		tclTimer vclZoomedTimer;
		tclTimer vclLastTargetTimer;
		tclTimer vclScopeDelayTimer;
		tclTimer vclFlashedTimer;
		tclTimer vclShieldAttackTimer;
		bool vboAttackShield;
		int vinLastTargetIdx; // this is the ENT index, not our array of bots index;
		
		int vinMoney;
		Vector vclBotAngle_Vector;
		void fvoSetWeaponModel( string ptxWeaponModel_Full );
		
		bool fboIsBlind( ){ return !vclFlashedTimer.fboTimedOut( ); };
		bool fboReactionSkillDelay( ); 
		
		int finBoneIndex( ){ return vinBoneIndex; };
		void fvoBoneIndex( int pinBoneIndex ){ vinBoneIndex = pinBoneIndex; };
		bool fboIsTargeting( );
		void fvoHasLostTarget( );
		bool fboHasZoomable( );
		bool fboHasNade( );
		bool fboHasPistol( );
		edict_t* fst_ptrThisBot( ){ return fst_ptrGetEntityByIndex( vinBotIdx+1 ); };
		void fvoSetNewTarget( edict_t *pst_ptrBot, edict_t *pst_ptrTarget ); 
		edict_t* fst_ptrGetTarget( );
		bool fboTargetHasShieldUp( );
		bool fboTargetHasShieldUpCanShoot( );
		bool fboBurstFire_StateOn( ) { return( vboBurstFire_State == 0 ); };
		bool fboBurstFire_StateOff( ) { return( vboBurstFire_State == 1 ); };
		void fvoSwitchBurstFireOff( );
		void fvoSwitchBurstFireOn( float pflBR_OnMin, float pflBR_OnMax, float pflBR_OffMin, float pflBR_OffMax );
		void fvoSetBurstFireStateOn( );
		void fvoSetBurstFireStateOff( );
		void fvoSetBurstFireTiming( float pflBR_OnMin, float pflBR_OnMax, float pflBR_OffMin, float pflBR_OffMax );
		void fvoCycleBurstFire( );
		void fvoStartRescopeDelay( );
		void fvoStartScopeDelay( );
		void fvoDisableScoping( ) { vclZoomedTimer.fvoStart( 7.0 ); };
		bool fboWeaponIsReadyToFire( ){ return vclScopeDelayTimer.fboTimedOut( ); };
		edict_t* fst_ptrFindVisibleTarget( edict_t* pst_ptrSource );
		
	}; // tstBotStatus

	class tclBotControl
	{
		public:
			bool vboBotAimIsOn;
			bool vboBotScopeFireIsOn;
			bool vboBotCombatIsOn;
			bool vboBotsShootThroughWallsIsOn;
			bool vboBotBurstFireIsOn;
			bool vboBotKnifeFixIsOn;
			bool vboBotNadeFixIsOn;
			bool vboSilentWalkIsOn;	
			bool vboPODFixesAreOn;
			bool vboPODHostageFixIsOn;
			bool vboBotBombFixIsOn;
			bool vboBotLogFixIsOn;
			bool vboBotJumpFixIsOn;
			float vflBotSkillDelay;
//			float vflTurnSpeed;
//			float vflTurnSkill;
			float	vflSyncWalkTime;     // base amount of time all bots will silent walk;
			bool vboSyncActionWalk;		// used to force all bots into a syncronized silent walk;
			tclTimer vclSyncWalkTimer;	// used to timeout the syncronized silent walking;
			tclTimer vclSyncJumpTimer;
			float vflMaxSpeed;			// from cvar sv_maxspeed;
			float vflBotWalkSpeed;

			long vinFrameScanRate; // number of frames to pass over before doing a scan for enemy targets;
			long vinPlayerScanRate; // number of players to scan over during each check for enemy targets;
		
			int vinBotRushTimeMin; 
			int vinBotRushTimeMax;
			int vinBotWalkTimeMin;
			int vinBotWalkTimeMax;
			int vinBotRunTimeMin;
			int vinBotRunTimeMax;
			int vinBotFightTimeMin;
			int vinBotFightTimeMax;

			float	vflBotBurstFireOnMin;
			float	vflBotBurstFireOnMax;
			float	vflBotBurstFireOffMin;
			float	vflBotBurstFireOffMax;
			float	vflZoomDelay;
			float	vflScopeDelay;
			float	vflScopeDelay_awp;
			float	vflBotNadeDelay;

			float vflFieldOfView;

//			float	vflBotJumpOnMin;
//			float	vflBotJumpOnMax;
//			float	vflBotJumpOffMin;
//			float	vflBotJumpOffMax;

//			float	vflBotDuckOnMin;
//			float	vflBotDuckOnMax;
//			float	vflBotDuckOffMin;
//			float	vflBotDuckOffMax;

//			float	vflBotStopOnMin;
//			float	vflBotStopOnMax;
//			float	vflBotStopOffMin;
//			float	vflBotStopOffMax;

			tstBotStatus vstBotStatus[ cinMaxPlayers ];

			tclBotControl( );
			bool fboSilentWalkIsOn( ) { return vboSilentWalkIsOn; };
			bool fboBotAimIsOn( ) { return vboBotAimIsOn; };
			bool fboBotScopeFireIsOn( ) { return vboBotScopeFireIsOn; };
			bool fboBotCombatIsOn( ) { return vboBotCombatIsOn; };
			bool fboBotsShootThroughWallsIsOn( ) { return vboBotsShootThroughWallsIsOn; };
			bool fboBotBurstFireIsOn( ) { return vboBotBurstFireIsOn; };
			bool fboBotKnifeFixIsOn( ) { return vboBotKnifeFixIsOn; };
			bool fboBotNadeFixIsOn( ) { return vboBotNadeFixIsOn; };
			bool fboPODFixesAreOn( ) { return vboPODFixesAreOn; };
			bool fboPODHostageFixIsOn( ) { return fboPODFixesAreOn( ) && vboPODHostageFixIsOn; };
			bool fboBotBombFixIsOn( ) { return vboBotBombFixIsOn; };
			bool fboBotJumpFixIsOn( ) { return vboBotJumpFixIsOn; };
			bool fboBotLogFixIsOn( ) { return vboBotLogFixIsOn; };
			void fvoResetBotStatus( );
			void fvoResetBotStatus( int pinIdx );
			void fvoSetCVars( );
			short finGetGameSettings( short pinGroup );
			void fvoRoundStart( );
			int finControlBot( edict_t* pst_ptrEdict );

			void fvoUpdateBotTarget( edict_t *pst_ptrEdict, TraceResult *pst_ptrTR, int pinIdx );
			void fvoUpdateBotControl( edict_t* pst_ptrEdict, int pinIdx );
			void TraceLine_Bot( const float *v1, const float *v2, int fNoMonsters, edict_t *pentToSkip, TraceResult *ptr );

			void fvoBotWalkStart_Ask( edict_t *pst_ptrEdict, int pinIdx, float pflUntil );
			void fvoBotWalkStop_Ask( edict_t *pst_ptrEdict, int pinIdx, float pflUntil );
			void fvoBotWalkStart_Force( edict_t *pst_ptrEdict, int pinIdx, float pflUntil );
			void fvoBotWalkStop_Force( edict_t *pst_ptrEdict, int pinIdx, float pflUntil );
			void fvoBotWalkStop_Force_CT( float pflUntil );
			void fvoUpdateSilentWalk( edict_t* pst_ptrEdict, int pinIdx );
			void fvoUseKnife( edict_t* pst_ptrEdict, int pinIdx );
			void fvoUseNade( edict_t* pst_ptrEdict, int pinIdx );
			void fvoUpdateBotBurstFire( edict_t *pst_ptrEdict, int pinIdx );
			void fvoUpdateBotScopeFire( edict_t *pst_ptrEdict, int pinIdx );

			void fvoUpdateTargeting( edict_t *pst_ptrEdict, int pinIdx );
			void fvoUpdateTargeting_TEST( edict_t *pst_ptrEdict, int pinIdx );

			void fvoModifyPlayerMove( edict_t* pst_ptrEdict, unsigned short &pinButtons, float &forwardmove, float &sidemove );
			void fvoPODFixHostage( edict_t* pst_ptrEdict );
			void fvoPODFixHostage( TraceResult* pst_ptrTR );
			void fvoUpdateBotBombFix( edict_t* pst_ptrEdict, int pinIdx );

//			bool fboButtonIsOn( unsigned short &pinButtons, unsigned short pinBit ){ return ( ( pinButtons & pinBit ) == pinBit ); };
//			bool fboButtonIsOff( unsigned short &pinButtons, unsigned short pinBit ){ return !fboButtonIsOn( pinButtons, pinBit ); };
//			void fvoSetButtonOn( unsigned short &pinButtons, unsigned short pinBit ){ pinButtons |= pinBit; };
//			void fvoSetButtonOff( unsigned short &pinButtons, unsigned short pinBit ){ pinButtons &= ~pinBit; };
//			bool fboSetButtonOn( unsigned short &pinButtons, unsigned short pinBit ){ pinButtons |= pinBit; return true; };
//			bool fboSetButtonOff( unsigned short &pinButtons, unsigned short pinBit ){ pinButtons &= ~pinBit;  return false; };

			bool fboAimsAtSomething( edict_t *pst_ptrEdict );
			void fvoPointGun( edict_t *pst_ptrEdict, bool save_angles, int pinIdx );

			int finIfBotGetPlayerIdx( edict_t* pst_ptrEdict );
			bool fboUseBotAim( edict_t* pst_ptrEdict, int pinIdx );
			float fflBotChangeYaw( edict_t *pEdict, float speed );
			float fflBotChangePitch( edict_t *pEdict, float speed );
			Vector fclBotBodyTarget( edict_t *pBotEnemy, int pinBoneIndex = -1 );
			bool fboPlayerIsHit( TraceResult *pst_ptrTR );
			bool fboPlayerIsVisible_Quick( int pinBotIdx, edict_t *pSource, edict_t *pPlayer, int &pinBoneIndex, Vector &pclOrigin );
			bool fboPlayerIsVisible_Quick( int pinBotIdx, edict_t *pSource, edict_t *pPlayer, int &pinBoneIndex );
			void fvoSetBotSkill( int pinSkillMin, int pinSkillMax, int pinIdx = 0 );
			int finGetBotSkillByUserIndex( int pinUserIdx );
			
	//		void fvoSetMaxSpeed( float pflMaxSpeed, int pinBotIdx );

	}; // tclBotControl

	extern tclBotControl vclBotControl;

	void fvoBotMoneyMsg_End( void* pclMessage );
	void fvoMsgScreenFade_End( void* pclMessage );

#endif //e. defMA_BotControl_h

