//.b 	
//	Copyright 2001 [MEAN].BOT
//	
//	File: MI_Cmd.h
//	
//	[MEAN] Command Module. 
//
//.e	

//.b skip over if header has already been included.
	#ifndef defMA_Cmd_h

	// Prevent the reprocessing of this definition file by defining 
	// the alias used in the above "ifndef" check.
		#define defMA_Cmd_h

	// Include all general definition files.
		#include "MB_Includes.h"

// MEAN Server Commands

	const int cinMinArgs		=   0;
	const int cinMaxArgs		= 255;
	const int cinMinArg_Idx =   0;
	const int cinMaxArg_Idx = cinMaxArgs - 1;

	typedef string ttxArgList[ cinMaxArgs ];

	typedef void (*tfn_ptrCmd) ( edict_t*, ttxArgList, string );

	const int cinMinCmds			=   0;  // minimum command count;
	const int cinMaxCmds			= 140;  // maximum command count;
	const int cinStartCmd_Idx	=   0;  // start index of command array;
	const int cinEndCmd_Idx		=  cinMaxCmds - 1; // end index of command array;

	enum tenCmdExecFrom 
		{ enServerOrClient	= 0,  // from server or client;
		  enServer				= 1,  // from server only;
		  enClient				= 2,  // from client only;
		  enClientSay			= 3}; // client "say";

	const tenCmdExecFrom cenExecFrom_DEFAULT = enServerOrClient;

	const bool cboCommandLock_On		 = true;
	const bool cboCommandLock_Off		 = false;
	const bool cboCommandLock_DEFAULT = cboCommandLock_Off;

	// globally accessable help command line
	const string ctxCmd_Help    = "m_help";
	const string ctxArg_Help    = "-help";
	
	struct tst_Cmd
	{
		string vtxCommand;
		string vtxHelpUsage;
		bool vboEnabled;
		bool vboLocked;
		int vinAccess;
		tenCmdExecFrom venExecFrom;
		tfn_ptrCmd vfn_ptrCmd;

	}; // tst_Cmd

	#define COMMAND_ENABLED true
	#define COMMAND_DISABLED false

	typedef tst_Cmd tst_aryCmdList[ cinMaxCmds ];

	class tclCommand
	{
		public:

			tst_aryCmdList vst_aryCmdList;
			int vinNumCmds;
			ttxArgList vtxArgList;
			string vtxArgString;
			int vinNumArgs;
			bool vboCancel;
			
			tclCommand( void );
			void fvoGetArgs( void );
			int finAddCmd
				( string         ptxCommand, 
				  tfn_ptrCmd     pfn_ptrCmd, 
				  tenCmdExecFrom penExecFrom, 
				  int				  pinAccess );
			bool fboAddAllCmds( void );
			
			bool fboSetCmdEnabled( string ptxCommand, bool pboSwitch );
			bool fboSetCmdEnabled( int pinCmdIdx, bool pboSwitch );

			bool fboSetCmdAsEnabled( string ptxCommand );
			bool fboSetCmdAsDisabled( string ptxCommand );
			bool fboSetCmdAsEnabled( int pinCmdIdx );
			bool fboSetCmdAsDisabled( int pinCmdIdx );

			bool fboCmdIsEnabled( int pinCmdIdx );

			bool fboSetCmdAccess( string ptxCommand, string ptxAccess );
			bool fboSetCmdAccess( string ptxCommand, int pinAccess );
			bool fboSetCmdAccess( int pinCmdIdx, int pinAccess );
			string ftxGetCmdAccess( int pinCmdIdx );

			bool fboCmdCountIsValid( void );
			bool fboCmdCountIsFull( void );
			bool fboCmdIsSay( int pinCmdIdx );
			bool fboCmdIdxIsValid( int pinCmdInd );

			int  finFindCmdIdx( string ptxCommand );
			bool fboCmdAccessIsValid( int pinAccess );

			bool fboCmdDispatch( edict_t* pst_ptrEdict, tenCmdExecFrom penExecFrom );
			bool fboExecCmd( edict_t* pst_ptrEdict, int pinCmdIdx );
			bool fboExecServerCmd( void );
			bool fboExecClientCmd( edict_t* pst_ptrEdict );
			bool fboExecSayCmd( edict_t* pst_ptrEdict );
			void fvoListCmd( edict_t* pst_ptrEdict, int pinAccess, tenCmdExecFrom penExecFrom );
			bool fboLockCommand( string ptxCommand, bool pboLockSetting );
			void fvoListCmdLocks( edict_t* pst_ptrEdict );

	}; // tclCommand

	extern tclCommand vclCommand;

	extern void fvoClientConsoleWarModeDisplay( edict_t* pst_ptrEdict );

	#endif // defMA_Cmd_h
//.e skip over if header has already been included.

