//.b 	
//	Copyright 2001 [MEAN].BOT
//	
//	File: MA_Configs.h
//	
//	[MEAN] Config File Load class definitions.
//
//.e	

//.b skip over if header has already been included.
#ifndef defMA_Configs_h

	// Prevent the reprocessing of this definition file by defining 
	// the alias used in the above "ifndef" check.
	#define defMA_Configs_h

	// Include all general definition files.
	#include "MB_Includes.h"
	#include "MB_InterfaceL1.h"

	const string ctxGameModeFolder = "gamemodes";

	const int cinForTeam_Any		=  0;
	const int cinForTeam_Clan		=  1;
	const int cinForTeam_Bot      =  2;

	const float cflDelayInSec = .0125;

	class tclCmdLine
	{
		public:
			string vtxCmd;
			int vinForTeam;
			int vinTeam;
			tclCmdLine* vcl_ptrNext;
			tclCmdLine( );
	}; // tclCmdLine

	class tclConfigFile 
	{
		public:
			int vinLineCount;
			
			float vflLastDelay;
			float vflDelayInSec;
			string vtxFilePathName;
			string vtxNotFoundMsg;

			tclCmdLine* vcl_ptrCur;
			tclCmdLine* vcl_ptrFirst;
			tclCmdLine* vcl_ptrLast;
			tclCmdLine* vcl_ptrTemp;

			tclConfigFile( );
			~tclConfigFile( );

			bool fboCmdLineIsValid( string ptxMsgLine, tclCmdLine* pcl_ptrTextLine );
			void fvoDestroyList( );
			bool fboLoadList( );
			void fvoExecuteCommands( );
			void fvoRunConfigFile( string ptxFileName, string ptxNotFoundMessage = "",  float pflDelayInSec = .0125 );

	}; // tclConfigFile

	extern tclConfigFile vclConfigFile;

#endif // defMA_Configs_h

