//.b 	
//	Copyright 2001 [MEAN].BOT
//	
//	File: MA_EngDLLCmd.cpp
//	
//	[MEAN] Interface Wrapper for commonly used Engine/DLL Commands.
//
//.e	

#include "MA_EngDLLCmd.h"
#include "MB_InterfaceL1.h"
#include "MG_Lib.h"
#include "MA_Sched.h"

	int vinTextMsgReg = 0;

	const int cinMaxChatMsgLen = 79;

	void fvoMA_EngDLLCmd_Event_fvoServerCommand( tclArgList& pclArgList )
	{
		fvoServerCommand( pclArgList.ftxGetArg_String( "ServerCommand" ) );
	} // fvoMA_EngDLLCmd_Event_fvoServerCommand

	void fvoMA_EngDLLCmd_Event_fvoClientCommand( tclArgList& pclArgList )
	{
		edict_t* vst_ptrEdict = static_cast< edict_t* >( pclArgList.fvo_ptrGetArg_PtrVoid( 0 ) );
//		vclDebugTrace.fvoWriteEventInfo( "Real Client event message execute - start.");
//		vclDebugTrace.fvoWriteEventInfo( "  Entity Addr   : " + ftxIntToString( long( vst_ptrEdict ) ) );
//		vclDebugTrace.fvoWriteEventInfo( "  Command Line  : " + pclArgList.ftxGetArg_String( 1 ) );

		fvoExecClientCommand( vst_ptrEdict, pclArgList.ftxGetArg_String( 1 ) );

//		vclDebugTrace.fvoWriteEventInfo( "Real Client event message execute - stop.");
	} // fvoMA_EngDLLCmd_Event_fvoClientCommand

	void fvoMA_EngDLLCmd_Event_fvoFakeClientCommand( tclArgList& pclArgList )
	{
		edict_t* vst_ptrEdict = static_cast< edict_t* >( pclArgList.fvo_ptrGetArg_PtrVoid( 0 ) );

//		vclDebugTrace.fvoWriteEventInfo( "Fake Client event message execute - start.");
//		vclDebugTrace.fvoWriteEventInfo( "  Entity Void   : " + ftxIntToString( long( vvo_ptrVoid ) ) );
//		vclDebugTrace.fvoWriteEventInfo( "  Entity Casted : " + ftxIntToString( long( vst_ptrEdict ) ) );
//		vclDebugTrace.fvoWriteEventInfo( "  Arg 1         : " + pclArgList.ftxGetArg_String( 1 ) );
//		vclDebugTrace.fvoWriteEventInfo( "  Arg 2         : " + pclArgList.ftxGetArg_String( 2 ) );
//		vclDebugTrace.fvoWriteEventInfo( "  Arg 3         : " + pclArgList.ftxGetArg_String( 3 ) );
//		vclDebugTrace.fvoWriteEventInfo( "  Arg 4         : " + pclArgList.ftxGetArg_String( 4 ) );

		fvoExecFakeClientCommand( 
			vst_ptrEdict, 
			pclArgList.ftxGetArg_String( 1 ), 
			pclArgList.ftxGetArg_String( 2 ), 
			pclArgList.ftxGetArg_String( 3 ), 
			pclArgList.ftxGetArg_String( 4 ) );

//		vclDebugTrace.fvoWriteEventInfo( "Fake Client event message execute - stop.");
	} // fvoMA_EngDLLCmd_Event_fvoFakeClientCommand

	void fvoServerPrint( string ptxMsg )
	{
		if ( ptxMsg.empty( ) ) return;
		vstENGFuncsOrig.pfnServerPrint( ptxMsg.c_str() );
	} // fvoServerPrint

	void fvoServerPrint_nl( string ptxMsg )
	{
		ptxMsg += "\n";
		fvoServerPrint( ptxMsg );
	} // fvoServerPrint_nl

// HUD_PRINTNOTIFY		1
// HUD_PRINTCONSOLE		2
// HUD_PRINTTALK			3
// HUD_PRINTCENTER		4

	void fvoClientPrint( edict_t* pst_ptrEdict, PRINT_TYPE penHow, string ptxMsg )
	{	// NOTE: Whenever possible, *always* use this function over 
		//       fvoClientPrint_Alt. This function is the most stable, the
		//       _Alt function will crash the client if the message sent is
		//       too long.
		//
		// Chat does not work - must use fvoClientPrint_Alt;
		// Notify is not defined - must use fvoClientPrint_Alt;
		//

		if ( ptxMsg.empty( ) ) return;
		
		vstENGFuncsOrig.pfnClientPrintf( pst_ptrEdict, penHow, ptxMsg.c_str( ) );

	} // fvoClientPrint

	void fvoClientPrint_Alt( edict_t* pst_ptrEdict, int pinMsgDest, string ptxMsg )
	{ 
		if ( ptxMsg.empty( ) ) return;
		
		if ( vinTextMsgReg == 0 )
			vinTextMsgReg = vstENGFuncsOrig.pfnRegUserMsg( "TextMsg", -1 ); 

		int vinSendMsgTo;

		if ( pst_ptrEdict == NULL )
			vinSendMsgTo = MSG_BROADCAST;
		else
			vinSendMsgTo = MSG_ONE_UNRELIABLE;

		fvoMessage_Begin( vinSendMsgTo, vinTextMsgReg, NULL, pst_ptrEdict );
			fvoMessage_WriteByte( pinMsgDest );
			fvoMessage_WriteString( ptxMsg );
		fvoMessage_End( );

	} // fvoClientPrint_Alt

	void fvoClientPrintNotify( edict_t* pst_ptrEdict, string ptxMsg )
	{
		if ( ptxMsg.empty( ) ) return;
		fvoClientPrint_Alt( pst_ptrEdict, HUD_PRINTNOTIFY, ptxMsg );
	} // fvoClientPrintNotifyAll

	void fvoClientPrintConsole( edict_t* pst_ptrEdict, string ptxMsg )
	{
		if ( ptxMsg.empty( ) ) return;
		vstENGFuncsOrig.pfnClientPrintf( pst_ptrEdict, print_console, ptxMsg.c_str( ) );
	} // fvoClientPrintConsole

	void fvoClientPrintConsole_nl( edict_t* pst_ptrEdict, string ptxMsg )
	{
		fvoClientPrintConsole( pst_ptrEdict, ptxMsg + "\n" );
	} // fvoClientPrintConsole

	void fvoClientPrintChat( edict_t* pst_ptrEdict, string ptxMsg )
	{
		if ( ptxMsg.empty( ) ) return;
		// truncate a message that is too long
		fvoTrunc( ptxMsg, cinMaxChatMsgLen );
		fvoClientPrint_Alt( pst_ptrEdict, HUD_PRINTTALK, ptxMsg );
	} // fvoClientPrintChat

	void fvoClientPrintCenter( edict_t* pst_ptrEdict, string ptxMsg )
	{
		if ( ptxMsg.empty( ) ) return;
		vstENGFuncsOrig.pfnClientPrintf( pst_ptrEdict, print_center, ptxMsg.c_str( ) );
	} // fvoClientPrintCenter

	void fvoClientPrintNotifyAll( string ptxMsg )
	{
		if ( ptxMsg.empty( ) ) return;
		fvoClientPrint_Alt( NULL, HUD_PRINTNOTIFY, ptxMsg );
	} // fvoClientPrintNotifyAll

	void fvoClientPrintConsoleAll( string ptxMsg )
	{
		if ( ptxMsg.empty( ) ) return;
		fvoClientPrint_Alt( NULL, HUD_PRINTCONSOLE, ptxMsg );
	} // fvoClientPrintChatAll

	void fvoClientPrintChatAll( string ptxMsg )
	{
		if ( ptxMsg.empty( ) ) return;
		// truncate a message that is too long
		fvoTrunc( ptxMsg, cinMaxChatMsgLen );
		fvoClientPrint_Alt( NULL, HUD_PRINTTALK, ptxMsg );
	} // fvoClientPrintChatAll

	void fvoClientPrintCenterAll( string ptxMsg )
	{
		fvoClientPrint_Alt( NULL, HUD_PRINTCENTER, ptxMsg );
	} // fvoClientPrintCenterAll

	void fvoConsolePrint( edict_t* pst_ptrEdict, string ptxMsg )
	{
		if ( pst_ptrEdict == NULL )
			fvoServerPrint( ptxMsg );
		else
			fvoClientPrintConsole( pst_ptrEdict, ptxMsg );
	} // fvoConsolePrint

	void fvoConsolePrint_nl( edict_t* pst_ptrEdict, string ptxMsg )
	{
		fvoConsolePrint( pst_ptrEdict, ptxMsg + "\n" );
	} // fvoConsolePrint_nl

	void fvoServerCommand( string ptxServerCmd )
	{
		vstENGFuncsOrig.pfnServerCommand( const_cast <char *>( ptxServerCmd.c_str( ) ) );
	} // fvoServerCommand

	void fvoServerCommand_nl( string ptxServerCmd )
	{
		fvoServerCommand( ptxServerCmd + "\n" );
	} // fvoServerCommand_nl

	void fvoServerCommandDELAYED( float pflDelayInSec, string ptxServerCmd )
	{
		vclEventSched.fboCreateEvent( );
		vclEventSched.fvoSetEventFunc( fvoMA_EngDLLCmd_Event_fvoServerCommand );
		vclEventSched.fboCreateArgList( 1 );
		vclEventSched.finSetArg_String( "ServerCommand", ptxServerCmd );
		vclEventSched.fvoSetDelayInSecs( pflDelayInSec );
		vclEventSched.fboSendEvent( );
	} // fvoServerCommandDELAYED

	void fvoServerCommand_nlDELAYED( float pflDelayInSec, string ptxServerCmd )
	{
		fvoServerCommandDELAYED( pflDelayInSec, ptxServerCmd + "\n" );
	} // fvoServerCommand_nlDELAYED

	char* fch_ptrGetInfoKeyBuffer( edict_t* pst_ptrEdict )
	{ // NOTE: if pst_ptrEdict is NULL then get server infor buffer.
		
		return vstENGFuncsOrig.pfnGetInfoKeyBuffer( pst_ptrEdict );
	} // fch_ptrGetInfoKeyBuffer

	string ftxGetInfoKeyValue( char* pch_ptrInfoBuffer, string ptxKey )
	{
		if ( pch_ptrInfoBuffer == NULL )
			return ""; 

		const unsigned long culgMaxKeyValueLen = 1024;
		char *vch_ptrKeyValue;

		vch_ptrKeyValue = 
			vstENGFuncsOrig.pfnInfoKeyValue
				( pch_ptrInfoBuffer, const_cast <char *>( ptxKey.c_str() ) );

		string vtxKeyValue = "";

		if ( fboCharStrIsOK( vch_ptrKeyValue, culgMaxKeyValueLen ) )
			vtxKeyValue = vch_ptrKeyValue; 

		return vtxKeyValue;

	} // ftxGetInfoKeyValue

	bool fboSetInfoKeyValue
		( int		pinClientIndex, 
		  char*	pch_ptrInfoBuffer, 
		  string ptxKey, 
		  string ptxKeyValue )
	{
		if ( pinClientIndex <= 0 || pch_ptrInfoBuffer == NULL )
			return false; 

		vstENGFuncsOrig.pfnSetClientKeyValue
			( pinClientIndex,
			  pch_ptrInfoBuffer, 
			  const_cast <char *>( ptxKey.c_str( ) ), 
			  const_cast <char *>( ptxKeyValue.c_str( ) ) );

		return true;

	} // ftxSetInfoKeyValue

	string ftxGetEdictKeyValue ( edict_t* pst_ptrEdict, string ptxKey )
	{
		// NOTEL if pst_ptrEdict is NULL then get keyvalue from server buffer

		char* vch_ptrInfobuffer;
		vch_ptrInfobuffer = fch_ptrGetInfoKeyBuffer( pst_ptrEdict );
		string vtxKeyValue = ftxGetInfoKeyValue( vch_ptrInfobuffer, ptxKey );
		return vtxKeyValue;

	} // ftxGetEdictKeyValue

	string ftxGetServerKeyValue ( string ptxKey )
	{
		return ftxGetEdictKeyValue ( NULL, ptxKey );

	} // ftxGetServerKeyValue

	bool fboSetClientKeyValue ( edict_t* pst_ptrEdict, string ptxKey, string ptxKeyValue )
	{
		if ( pst_ptrEdict == NULL )
			return false;

		char* vch_ptrInfobuffer;
		int vinClientIndex = vstENGFuncsOrig.pfnIndexOfEdict( pst_ptrEdict );
		
		if ( vinClientIndex <= 0 )
			return false;

		vch_ptrInfobuffer = fch_ptrGetInfoKeyBuffer( pst_ptrEdict );
		return fboSetInfoKeyValue( vinClientIndex, vch_ptrInfobuffer, ptxKey, ptxKeyValue );

	} // fboSetClientKeyValue

	void fvoEmitSoundFromPlayer ( edict_t* pst_ptrEdict, int pinChannel, string ptxSoundFile )
	{	
		if ( pst_ptrEdict == NULL )
			return;

		if ( ptxSoundFile.empty( ) )
			return;

		vstENGFuncsOrig.pfnEmitSound	
			( pst_ptrEdict, pinChannel, ptxSoundFile.c_str(), 1, ATTN_NORM, 0, PITCH_NORM);

	} // fvoEmitSoundFromPlayer

	void fvoKillPlayer( edict_t* pst_ptrEdict, string vtxReason )
	{
		if ( pst_ptrEdict == NULL )
			return;
		fvoClientPrintChat( pst_ptrEdict, vtxReason );
		vstDLLFuncsOrig.pfnClientKill( pst_ptrEdict );
	} // fvoKillPlayer

	float fflRandomFloat ( float pflLow, float pflHigh )
	{
		return vstENGFuncsOrig.pfnRandomFloat( pflLow, pflHigh );
	} // fflRandomFloat

	string ftxCVarGetString( string ptxCVarName )
	{
		if ( ptxCVarName.empty( ) )
			return "";
		string vtxResult = vstENGFuncsOrig.pfnCVarGetString( ptxCVarName.c_str( ) );
		return vtxResult;

	} // ftxCVarGetString

	void fvoCVarSetString( string ptxCVarName, string ptxValue )
	{
		if ( ptxCVarName.empty( ) )
			return;
		vstENGFuncsOrig.pfnCVarSetString( ptxCVarName.c_str( ), ptxValue.c_str( ) );

	} // fvoCVarSetString

	float fflCVarGetFloat( string ptxCVarName )
	{
		if ( ptxCVarName.empty( ) )
			return 0.0;
		float vflResult = vstENGFuncsOrig.pfnCVarGetFloat( ptxCVarName.c_str( ) );
		return vflResult;

	} // fflCVarGetFloat

	float fflCVarGetFloat_Bounded( string ptxCVarName, float pflMin, float pflMax )
	{
		float vflValue = fflCVarGetFloat( ptxCVarName );
		return fflBoundValue( vflValue, pflMin, pflMax );

	} // fflCVarGetFloat_Bounded

	void fvoCVarSetFloat( string ptxCVarName, float pflValue )
	{
		if ( ptxCVarName.empty( ) )
			return;
		vstENGFuncsOrig.pfnCVarSetFloat( ptxCVarName.c_str( ), pflValue );

	} // fvoCVarSetFloat

	long finCVarGetInt( string ptxCVarName )
	{
		if ( ptxCVarName.empty( ) )
			return 0;
		return long( vstENGFuncsOrig.pfnCVarGetFloat( ptxCVarName.c_str( ) ) );

	} // finCVarGetInt

	long finCVarGetInt_Bounded( string ptxCVarName, long pinMin, long pinMax )
	{
		long vinValue = finCVarGetInt( ptxCVarName );
		return finBoundValue( vinValue, pinMin, pinMax );

	} // fflCVarGetFloat_Bounded

	void fvoCVarSetInt( string ptxCVarName, long pinValue )
	{
		if ( ptxCVarName.empty( ) )
			return;
		vstENGFuncsOrig.pfnCVarSetFloat( ptxCVarName.c_str( ), float( pinValue ) );

	} // fvoCVarSetInt

	bool fboCVarGetBool( string ptxCVarName )
	{
		string vtxValue = ftxToLower( ftxCVarGetString( ptxCVarName ) );
		return fboIsOn( vtxValue );	
//		return ( vtxValue ==  "on" || vtxValue ==  "1" || vtxValue ==  "true" );
		
	} // fboCVarGetBool

	void fvoCVarSetBool( string ptxCVarName, bool pboValue )
	{
		if ( ptxCVarName.empty( ) )
			return;
		fvoCVarSetString( ptxCVarName, ftxBoolToString( pboValue, "1", "0" ) );

	} // fvoCVarSetBool

	void fvoMessage_Begin
		( int          pinMsgDest, 
		  int          pinMsgType, 
		  const float* pfl_ptrOrigin, 
		  edict_t*     pst_ptrEdict )
	{
		vstENGFuncsOrig.pfnMessageBegin( pinMsgDest, pinMsgType, pfl_ptrOrigin, pst_ptrEdict );
	} // fvoMessage_Begin

	void fvoMessage_End( void )
	{
		vstENGFuncsOrig.pfnMessageEnd( );
	} // fvoMessage_End

	void fvoMessage_WriteString( string ptxString )
	{
		vstENGFuncsOrig.pfnWriteString( ptxString.c_str( ) );
	} // fvoMessage_WriteString

	void fvoMessage_WriteByte( int pinByte )
	{
		vstENGFuncsOrig.pfnWriteByte( pinByte );
	} // fvoMessage_WriteByte

	void fvoMessage_WriteChar( int pinChar )
	{
		vstENGFuncsOrig.pfnWriteChar( pinChar );
	} // fvoMessage_WriteChar

	void fvoMessage_WriteShort( int pinShort )
	{
		vstENGFuncsOrig.pfnWriteShort( pinShort );
	} // fvoMessage_WriteShort

	void fvoMessage_WriteLong( int pinLong )
	{
		vstENGFuncsOrig.pfnWriteLong( pinLong );
	} // fvoMessage_WriteLong

	void fvoMessage_WriteAngle( float pflAngle )
	{
		vstENGFuncsOrig.pfnWriteAngle( pflAngle );
	} // fvoMessage_WriteAngle

	void fvoMessage_WriteCoord( float pflCoord )
	{
		vstENGFuncsOrig.pfnWriteCoord( pflCoord );
	} // fvoMessage_WriteCoord

	void fvoMessage_WriteEntity( int pinEntity )
	{
		vstENGFuncsOrig.pfnWriteEntity( pinEntity );
	} // fvoMessage_WriteEntity

	float fflGetEngineTime( void )
	{
		return vstENGFuncsOrig.pfnTime( );
	} // fflGetEngineTime

	void fvoExecClientCommand( edict_t* pst_ptrEdict, string vtxCmd )
	{
		if ( vtxCmd.empty( ) )
			return;

		if ( vtxCmd[ vtxCmd.length( )-1 ] != '\n' )
			vtxCmd += "\n";

		 vstENGFuncsOrig.pfnClientCommand( pst_ptrEdict, const_cast <char *>( vtxCmd.c_str( ) ) );
	} //  fvoExecClientCommand

	void fvoExecClientCommandDELAYED( 
		float pflDelayInSec, edict_t* pEntity, string vtxCmd )
	{
//		vclDebugTrace.fvoWriteEventInfo( "Creating Real Client event message - start.");
//		vclDebugTrace.fvoWriteEventInfo( "  Entity Address: " + ftxIntToString( long( pEntity ) ) );
//		vclDebugTrace.fvoWriteEventInfo( "  Comannd Line  : " + vtxCmd );
		vclEventSched.fboCreateEvent( );
		vclEventSched.fvoSetEventFunc( fvoMA_EngDLLCmd_Event_fvoFakeClientCommand );
		vclEventSched.fboCreateArgList( 2 );
		vclEventSched.fvoSetArg_PtrVoid( 0, pEntity );
		vclEventSched.fvoSetArg_String ( 1, vtxCmd );
		vclEventSched.fvoSetDelayInSecs( pflDelayInSec );
		vclEventSched.fboSendEvent( );
//		vclDebugTrace.fvoWriteEventInfo( "Creating Real Client event message - end.");
	} // fvoExecClientCommandDELAYED

	void fvoExecFakeClientCommand( edict_t *pEntity, string ptxArg1, string ptxArg2, string ptxArg3, string ptxArg4, string ptxArg5, string ptxArg6 )
	{
//		vclDebugTrace.fvoWriteEventInfo( "About to run Fake Client command - start.");
//		vclDebugTrace.fvoWriteEventInfo( "  Entity Address: " + ftxIntToString( long( pEntity ) ) );
//		vclDebugTrace.fvoWriteEventInfo( "  Arg 1         : " + ptxArg1 );
//		vclDebugTrace.fvoWriteEventInfo( "  Arg 2         : " + ptxArg2 );
//		vclDebugTrace.fvoWriteEventInfo( "  Arg 3         : " + ptxArg3 );
//		vclDebugTrace.fvoWriteEventInfo( "  Arg 4         : " + ptxArg4 );

		vclInterfaceL1.vboIsFakeClient = false;
		vclInterfaceL1.fvoClearArgS( );

		if ( pEntity == NULL ) 
			return;

		vclInterfaceL1.fvoAddArgS( ptxArg1 );
		vclInterfaceL1.fvoAddArgS( ptxArg2 );
		vclInterfaceL1.fvoAddArgS( ptxArg3 );
		vclInterfaceL1.fvoAddArgS( ptxArg4 );
		vclInterfaceL1.fvoAddArgS( ptxArg5 );
		vclInterfaceL1.fvoAddArgS( ptxArg6 );

		if ( vclInterfaceL1.vinNumFakeArgs <= 0 )
			return;

	   // force MOD DLL to execute the fake client command;

		vclInterfaceL1.vboIsFakeClient = true;
		vstDLLFuncsOrig.pfnClientCommand( pEntity );
		vclInterfaceL1.vboIsFakeClient = false;

//		vclDebugTrace.fvoWriteEventInfo( "About to run Fake Client command - stop.");

	} // fvoExecFakeClientCommand

	void fvoExecFakeClientCommandDELAYED( 
		float pflDelayInSec, edict_t* pEntity, string ptxArg1, string ptxArg2, string ptxArg3, string ptxArg4, string ptxArg5, string ptxArg6 )
	{
//		vclDebugTrace.fvoWriteEventInfo( "Creating Fake Client event message - start.");
//		vclDebugTrace.fvoWriteEventInfo( "  Entity Address: " + ftxIntToString( long( pEntity ) ) );
//		vclDebugTrace.fvoWriteEventInfo( "  Arg 1         : " + ptxArg1 );
//		vclDebugTrace.fvoWriteEventInfo( "  Arg 2         : " + ptxArg2 );
//		vclDebugTrace.fvoWriteEventInfo( "  Arg 3         : " + ptxArg3 );
//		vclDebugTrace.fvoWriteEventInfo( "  Arg 4         : " + ptxArg4 );
//		vclDebugTrace.fvoWriteEventInfo( "  About to Create Entity" );
		vclEventSched.fboCreateEvent( );
		vclEventSched.fvoSetEventFunc( fvoMA_EngDLLCmd_Event_fvoFakeClientCommand );
		vclEventSched.fboCreateArgList( 7 );
		vclEventSched.fvoSetArg_PtrVoid( 0, pEntity );
		vclEventSched.fvoSetArg_String ( 1, ptxArg1 );
		vclEventSched.fvoSetArg_String ( 2, ptxArg2 );
		vclEventSched.fvoSetArg_String ( 3, ptxArg3 );
		vclEventSched.fvoSetArg_String ( 4, ptxArg4 );
		vclEventSched.fvoSetArg_String ( 5, ptxArg3 );
		vclEventSched.fvoSetArg_String ( 6, ptxArg4 );
		vclEventSched.fvoSetDelayInSecs( pflDelayInSec );
		vclEventSched.fboSendEvent( );
//		vclDebugTrace.fvoWriteEventInfo( "Creating Fake Client event message - end.");
	} // fvoFakeClientCommandDELAYED

	bool fboIsMapValid( string ptxFileName )
	{
		if ( ptxFileName.substr( 0, 2 ) == "//" )
		// for some reason, a map name that starts with '//' will be viewed
		// as a valid map by pfnIsMapValid, but the game will correctly view 
		// the map name as invalid; we block it here;
			return false;

		int vinResult = vstENGFuncsOrig.pfnIsMapValid( const_cast <char *>( ptxFileName.c_str( ) ) );
		return vinResult;
	} // fboIsMapValid

	void fvoAddServerCommand( string ptxCmd, tfn_ptrServerCmd pfn_ptrServerCmd )
	{
		vstENGFuncsOrig.pfnAddServerCommand(const_cast <char *>( ptxCmd.c_str( ) ), pfn_ptrServerCmd);
	} // fvoAddServerCommand

	int finGetCmdLineArgCount( void )
	{ // returns number of command line arguments including the command itself;
		return vstENGFuncsOrig.pfnCmd_Argc();
	} // finGetCmdLineArgCount

	string ftxGetCmdLineArgValue( int pinIdx )
	{
		return vstENGFuncsOrig.pfnCmd_Argv( pinIdx );
	} // ftxGetCmdLineArgValue

	string ftxGetCmdLineString( void )
	{ // returns the command line argument list;
	  // does *not* include the command portion;
		return vstENGFuncsOrig.pfnCmd_Args( );
	} // ftxGetCmdLineString

//	unsigned int finuGetPlayerWONId( edict_t* pst_ptrEdict )
//	{
//		return vstENGFuncsOrig.pfnGetPlayerWONId( pst_ptrEdict );
//	} // finuGetPlayerWONId

//	string ftxGetPlayerWONId( edict_t* pst_ptrEdict )
//	{
//		return ftxIntToString( finuGetPlayerWONId( pst_ptrEdict ) );
//	} // ftxGetPlayerWONId
	
	string ftxGetPlayerAuthId( edict_t* pst_ptrEdict )
	{
		// bots MUST have an Auth Id of "0" to keep things simple;
		//if ( pst_ptrEdict->v.flags & def_FAKE_CLIENT_BIT )
		//	return "0";

		//if ( pst_ptrEdict->v.flags & FL_FAKECLIENT )
		//	return "0";

		return vstENGFuncsOrig.pfnGetPlayerAuthId( pst_ptrEdict );

	} // ftxGetPlayerAuthId

	int finGetPlayerPing( edict_t* pst_ptrEdict )
	{
		int vinPing;
		int vinPacketLoss;
		vstENGFuncsOrig.pfnGetPlayerStats( pst_ptrEdict, &vinPing, &vinPacketLoss );
		return vinPing;
	} // finGetPlayerPing

	int finGetPlayerUserId( edict_t* pst_ptrEdict )
	{	
		if ( pst_ptrEdict == NULL )
			return 0;

		return vstENGFuncsOrig.pfnGetPlayerUserId( pst_ptrEdict );
	} // finGetPlayerUserId

	string ftxGetPlayerUserId( edict_t* pst_ptrEdict )
	{	
		if ( pst_ptrEdict == NULL )
			return "";

		return ftxIntToString( finGetPlayerUserId( pst_ptrEdict ) );

	} // ftxGetPlayerUserId
	
	int finPrecacheSound( string ptxWavFile )
	{
		if ( ptxWavFile.empty( ) )
			return 0;

		return vstENGFuncsOrig.pfnPrecacheSound( const_cast <char *>( ptxWavFile.c_str( ) ) );
	} // finPrecacheSound

	int finPrecacheModel( string ptxModelFile )
	{
		if ( ptxModelFile.empty( ) )
			return 0;

		return vstENGFuncsOrig.pfnPrecacheModel( const_cast <char *>( ptxModelFile.c_str( ) ) );
	} // finPrecacheModel

	edict_t* fst_ptrGetEntityByIndex( int pinIndex )
	{ 
		return vstENGFuncsOrig.pfnPEntityOfEntIndex( pinIndex ); 
	} // fst_ptrGetEntityByIndex

	int finGetIndexOfEdict( const edict_t *pst_ptrEdict )
	{
		return vstENGFuncsOrig.pfnIndexOfEdict( pst_ptrEdict );
	} // finGetIndexOfEdict

	void fvoMakeVectors( const float *pfl_ptrVector )
	{
		vstENGFuncsOrig.pfnMakeVectors( pfl_ptrVector );
	} // fvoMakeVectors

	float fflWrapAngle( float pAngle )
	{
		float vAngle = pAngle;

		// check for wraparound of angle
		if ( vAngle > 180 )
			vAngle -= 360 * ( (int) ( vAngle / 360 ) + 1 );
		if ( vAngle < -180 )
			vAngle += 360 * ( (int) ( vAngle / 360 ) + 1 );

		return vAngle;
	} // fflWrapAngle

	Vector fstWrapAngles( Vector pAngles )
	{
		Vector vAngles = pAngles;

		// check for wraparound of angles
		if ( vAngles.x > 180 )
			vAngles.x -= 360 * ( (int) ( vAngles.x / 360 ) + 1 );
		if ( vAngles.x < -180)
			vAngles.x += 360 * ( (int) ( vAngles.x / 360 ) + 1 );
		if ( vAngles.y > 180)
			vAngles.y -= 360 * ( (int) ( vAngles.y / 360 ) + 1 );
		if ( vAngles.y < -180)
			vAngles.y += 360 * ( (int) ( vAngles.y / 360 ) + 1 );
		if ( vAngles.z > 180)
			vAngles.z -= 360 * ( (int) ( vAngles.z / 360 ) + 1 );
		if ( vAngles.z < -180 )
			vAngles.z += 360 * ( (int) ( vAngles.z / 360 ) + 1 );

		return vAngles;
	} // fstWrapAngles

	int finGetNumBones( edict_t *pPlayer ) 
	{        
		void *pmodel = GET_MODEL_PTR( pPlayer );        
		studiohdr_t *pstudiohdr = (studiohdr_t *)pmodel;         
		if (! pstudiohdr)           
			return 0;         
		else            
			return pstudiohdr->numbones;     

	} // finGetNumBones

	void fvoGetBonePosition( const edict_t* pEdict, int iBone, float *rgflOrigin, float *rgflAngles )
	{
		vstENGFuncsOrig.pfnGetBonePosition( pEdict, iBone, rgflOrigin, rgflAngles );
	} // fvoGetBonePosition

	void fvoTraceLine( const Vector &vecStart, const Vector &vecEnd, IGNORE_MONSTERS igmon, IGNORE_GLASS ignoreGlass, edict_t *pentIgnore, TraceResult *ptr )
	{
		TRACE_LINE( vecStart, vecEnd, (igmon == ignore_monsters ? TRUE : FALSE) | (ignoreGlass?0x100:0), pentIgnore, ptr );
	} // fvoTraceLine


	bool fboButtonIsOn( unsigned short &pinButtons, unsigned short pinBit )
	{ 
		return ( ( pinButtons & pinBit ) == pinBit ); 
	}
	bool fboButtonIsOff( unsigned short &pinButtons, unsigned short pinBit )
	{ return !fboButtonIsOn( pinButtons, pinBit ); }
	void fvoSetButtonOn( unsigned short &pinButtons, unsigned short pinBit ){ pinButtons |= pinBit; }
	void fvoSetButtonOff( unsigned short &pinButtons, unsigned short pinBit ){ pinButtons &= ~pinBit; }
	bool fboSetButtonOn( unsigned short &pinButtons, unsigned short pinBit ){ pinButtons |= pinBit; return true; }
	bool fboSetButtonOff( unsigned short &pinButtons, unsigned short pinBit ){ pinButtons &= ~pinBit;  return false; }



	void fvoRunPlayerMove( 
		edict_t *fakeclient, const float *viewangles, float forwardmove, 
		float sidemove, float upmove, unsigned short buttons, byte impulse, 
		byte msec )
	{
		vstENGFuncsOrig.pfnRunPlayerMove( fakeclient, viewangles, forwardmove, sidemove, upmove, buttons, impulse, msec );
	} // fvoRunPlayerMove

	
	void fvoMA_EngDLLCmd_Event_fvoRunPlayerMove( tclArgList& pclArgList )
	{
		edict_t* vst_ptrEdict = static_cast< edict_t* >( pclArgList.fvo_ptrGetArg_PtrVoid( 0 ) );

		fvoRunPlayerMove( 
			vst_ptrEdict, 
			vst_ptrEdict->v.v_angle, //pclArgList.fflGetArg_PtrFloat( 1 ), 
			pclArgList.fflGetArg_Float(	 2 ), 
			pclArgList.fflGetArg_Float(	 3 ), 
			pclArgList.fflGetArg_Float(	 4 ), 
			pclArgList.finGetArg_UShort(	 5 ), 
			pclArgList.fchGetArg_UChar(	 6 ), 
			pclArgList.fchGetArg_UChar(	 7 )	);

	} // fvoMA_EngDLLCmd_Event_fvoRunPlayerMove

	void fvoRunPlayerMove_DELAYED( 
		float pflDelayInSec, edict_t *fakeclient, const float *viewangles, float forwardmove, 
		float sidemove, float upmove, unsigned short buttons, byte impulse, 
		byte msec )
	{

		vclEventSched.fboCreateEvent( );
		vclEventSched.fvoSetEventFunc( fvoMA_EngDLLCmd_Event_fvoRunPlayerMove );
		vclEventSched.fboCreateArgList(   8 );
		vclEventSched.fvoSetArg_PtrVoid(  0, fakeclient );
//		vclEventSched.fvoSetArg_PtrFloat( 1, viewangles );
		vclEventSched.fvoSetArg_Float(    2, forwardmove );
		vclEventSched.fvoSetArg_Float(    3, sidemove );
		vclEventSched.fvoSetArg_Float(    4, upmove );
		vclEventSched.fvoSetArg_UShort(   5, buttons );
		vclEventSched.fvoSetArg_UChar(    6, impulse );
		vclEventSched.fvoSetArg_UChar(    7, msec );
		vclEventSched.fvoSetDelayInSecs( pflDelayInSec );
		vclEventSched.fboSendEvent( );
		
	} // fvoRunPlayerMove
