//.b 	
//	Copyright 2001 [MEAN].BOT
//	
//	File: MA_Message.cpp
//	
//	[MEAN] Interface UTIL function definitions.
//
//.e	

#include "MG_Lib.h"
#include "MA_EngDLLCmd.h"
#include "MA_Message.h"
#include "MA_Player.h"

//.b MA_Message.cpp

	tclMessage vclMessage;

	tclBaseMsg::tclBaseMsg( )
	{
		vinMsgType					= -1;
		vinMsgDest					= -1;
	   vfl_ptrOrigin				= NULL;
		vst_ptrEdict				= NULL;
	} // tclBaseMsg::tclBaseMsg

	tclMessage::tclMessage( void )
	{
		vboCaptureMsg				= false;
		vboSendMsg					= true;
		vboTraceMsg					= false;
		vboTraceDisplayMsg		= false;
		// Message contents
		vfn_ptrMsgBegin			= NULL;
		vfn_ptrMsgEnd				= NULL;
		vfn_ptrMsgCapture			= NULL;
		vfn_ptrMsgSent				= NULL;

		fvoClearValueList_Full( );

	} // tclMessage::tclMessage

	void tclMessage::fvoTraceEventInfo( string ptxMsg )
	{
		if ( !vboTraceMsg )
			return;

		if ( vboTraceDisplayMsg )
			fvoServerPrint_nl( ptxMsg );

		vclDebugTrace.fvoWriteEventInfo( ptxMsg );

	} // tclMessage::fvoTraceEventInfo

	void tclMessage::fvoClearValueList_Full( void )
	{
		for ( int vinIdx = cinMinValueIdx; 
				vinIdx <= cinMaxValueIdx; 
				vinIdx++ )
		{
			vst_aryValueList[ vinIdx ].vinValueType = cinValueType_Null;
		}
		vinNumValues = 0;
	} // tclMessage::fvoClearValueList_Full

	void tclMessage::fvoClearValueList( void )
	{
		vinNumValues = 0;		
	} // tclMessage::fvoClearValueList

	void tclMessage::fvoSetCaptureMsgOn( void )
	{
		vboCaptureMsg = true;
	} // tclMessage::fvoSetCaptureMsgOn

	void tclMessage::fvoSetCaptureMsgOff( void )
	{
		vboCaptureMsg = false;
	} // tclMessage::fvoSetCaptureMsgOff

	void tclMessage::fvoSendMsg( void )
	{
		if ( !vboCaptureMsg )
		// message was not captured;
			return;

		if ( fboSendMsgFlagIsOff( ) )
		// message is blocked;
			return;
		
		if ( vinNumValues > cinMaxValues )
		{
			// this is a critical error;
			vclDebugTrace.fvoWriteEventInfo( "CRITICAL ERROR(2): Message capture buffer overflow." );
			return;
		}

		string vtxMsg;

		if ( !vboTraceMsg )
		// skip trace code;
			goto locSendMessage;

		fvoTraceEventInfo( "Message_Begin" );
		

		vtxMsg = "...MessageType: " + ftxIntToString( vinMsgType );
		fvoTraceEventInfo( vtxMsg );
		vtxMsg = "...MessageDest: " + ftxIntToString( vinMsgDest );
		fvoTraceEventInfo( vtxMsg );

		if ( vst_ptrEdict != NULL )
		{
			vtxMsg = "...Entity Origin x : " + ftxFloatToString( vst_ptrEdict->v.origin.x );
			fvoTraceEventInfo( vtxMsg );
			vtxMsg = "...Entity Origin y : " + ftxFloatToString( vst_ptrEdict->v.origin.y );
			fvoTraceEventInfo( vtxMsg );
			vtxMsg = "...Entity Origin z : " + ftxFloatToString( vst_ptrEdict->v.origin.z );
			fvoTraceEventInfo( vtxMsg );
			vtxMsg = "...Entity Name     : " + vclPlayer.ftxGetPlayerNameByEdict( vst_ptrEdict );
			fvoTraceEventInfo( vtxMsg );
		}
		
		if ( vfl_ptrOrigin != NULL )
		{
			vtxMsg = "...Message Target x: " + ftxFloatToString( vfl_ptrOrigin[ 0 ] );
			fvoTraceEventInfo( vtxMsg );
			vtxMsg = "...Message Target y: " + ftxFloatToString( vfl_ptrOrigin[ 1 ] );
			fvoTraceEventInfo( vtxMsg );
			vtxMsg = "...Message Target z: " + ftxFloatToString( vfl_ptrOrigin[ 2 ] );
			fvoTraceEventInfo( vtxMsg );
		}
		
		locSendMessage:

		fvoMessage_Begin( vinMsgDest, vinMsgType, vfl_ptrOrigin, vst_ptrEdict );	
		
		for ( int vinIdx = 0; vinIdx < vinNumValues; vinIdx++ )
		{
			switch ( vst_aryValueList[ vinIdx ].vinValueType )
			{
				case cinValueType_Null :
					vclDebugTrace.fvoWriteEventInfo( "CRITICAL ERROR(1): Undefined message value." );
					break;
				case cinValueType_Byte :
					if ( vboTraceMsg ) fvoTraceEventInfo( "...WriteByte       : " + ftxIntToString( vst_aryValueList[ vinIdx ].vinInt ) );
					fvoMessage_WriteByte( vst_aryValueList[ vinIdx ].vinInt );
					break;
				case cinValueType_Char :
					if ( vboTraceMsg ) fvoTraceEventInfo( "...WriteChar       : " + ftxIntToString( vst_aryValueList[ vinIdx ].vinInt ) );
					fvoMessage_WriteChar( vst_aryValueList[ vinIdx ].vinInt );
					break;
				case cinValueType_Short :
					if ( vboTraceMsg ) fvoTraceEventInfo( "...WriteShort      : " + ftxIntToString( vst_aryValueList[ vinIdx ].vinInt ) );
					fvoMessage_WriteShort( vst_aryValueList[ vinIdx ].vinInt );
					break;
				case cinValueType_Long :
					if ( vboTraceMsg ) fvoTraceEventInfo( "...WriteLong       : " + ftxIntToString( vst_aryValueList[ vinIdx ].vinInt ) );
					fvoMessage_WriteLong( vst_aryValueList[ vinIdx ].vinInt );
					break;
				case cinValueType_Angle :
					if ( vboTraceMsg ) fvoTraceEventInfo( "...WriteAngle      : " + ftxFloatToString( vst_aryValueList[ vinIdx ].vflFloat ) );
					fvoMessage_WriteAngle( vst_aryValueList[ vinIdx ].vflFloat );
					break;
				case cinValueType_Coord :
					if ( vboTraceMsg ) fvoTraceEventInfo( "...WriteCoord      : " + ftxFloatToString( vst_aryValueList[ vinIdx ].vflFloat ) );
					fvoMessage_WriteCoord( vst_aryValueList[ vinIdx ].vflFloat );
					break;
				case cinValueType_String :
					if ( vboTraceMsg ) fvoTraceEventInfo( "...WriteString     : " + vst_aryValueList[ vinIdx ].vtxString );
					fvoMessage_WriteString( vst_aryValueList[ vinIdx ].vtxString );
					break;
				case cinValueType_Entity :
					if ( vboTraceMsg ) fvoTraceEventInfo( "...WriteLong       : " + ftxIntToString( vst_aryValueList[ vinIdx ].vinInt ) );
					fvoMessage_WriteEntity( vst_aryValueList[ vinIdx ].vinInt );
					break;
				default :
					vclDebugTrace.fvoWriteEventInfo( "CRITICAL ERROR(1): Undefined message value." );
			} 
		}

		if ( vboTraceMsg ) fvoTraceEventInfo( "Message_End" );
		fvoMessage_End( );

	} // tclMessage::fvoSendMsg

	bool tclMessage::fboCaptureMsgIsOn( void )
   {
		return vboCaptureMsg;
	} // tclMessage::fboCaptureMsgIsOn

	bool tclMessage::fboCaptureMsgIsOff( void )
   {
		return !vboCaptureMsg;
	} // tclMessage::fboCaptureMsgIsOff

	void tclMessage::fvoSetSendMsgFlagOn( void )
	{
		vboSendMsg = true;
	} // tclMessage::fvoSetSendMsgFlag

	void tclMessage::fvoSetSendMsgFlagOff( void )
	{
		vboSendMsg = false;
	} // tclMessage::fvoSetSendMsgFlag

	bool tclMessage::fboSendMsgFlagIsOn( void )
   {
		return vboSendMsg;
	} // tclMessage::fboSendMsgFlagIsOn

	bool tclMessage::fboSendMsgFlagIsOff( void )
   {
		return !vboSendMsg;
	} // tclMessage::fboSendMsgFlagIsOff

	void tclMessage::fvoMsg_Begin( int pinMsgDest, int pinMsgType, const float* pfl_ptrOrigin, edict_t* pst_ptrEdict )
	{
		fvoSetCaptureMsgOff( );
		fvoSetSendMsgFlagOff( );

		vinMsgDest      = pinMsgDest;
		vinMsgType      = pinMsgType;
		vfl_ptrOrigin   = pfl_ptrOrigin;
		vst_ptrEdict	 = pst_ptrEdict;

		vfn_ptrMsgCapture = NULL;
		vfn_ptrMsgEnd     = NULL;
		vfn_ptrMsgSent		= NULL;

		fvoClearValueList( );
		if ( vfn_ptrMsgBegin != NULL )
		// this function call will determine if the message will be captured or not;
			vfn_ptrMsgBegin( this );	
		
	} // tclMessage::fvoMsg_Begin

	void tclMessage::fvoMsg_End( void )
   {
		if ( !vboCaptureMsg )
		// message was not captured;
			return;

		if ( vfn_ptrMsgEnd != NULL )
			vfn_ptrMsgEnd( this );

		fvoSendMsg( );

		if ( vfn_ptrMsgSent != NULL )
			vfn_ptrMsgSent( this );

		// clear function pointers because they no longer apply;
		vfn_ptrMsgEnd		= NULL;
		vfn_ptrMsgCapture = NULL;
		vfn_ptrMsgSent	   = NULL;
		
		fvoSetCaptureMsgOff( );
		fvoClearValueList( );

	} // tclMessage::fvoMsg_End

	bool tclMessage::fboBufferOverflow( )
	{
		if ( vinNumValues >= cinMaxValues )
		{ // this is a critical error;
			vclDebugTrace.fvoWriteEventInfo( "CRITICAL ERROR(1): Message capture buffer overflow." );
			return true;
		}
		return false;
	} // tclMessage::fboBufferOverflow

	void tclMessage::fvoFinishCapture( int pinValueType )
	{
		vst_aryValueList[ vinNumValues ].vinValueType = pinValueType;
		vinNumValues++;
		if ( vinNumValues < cinMaxValues )
		{ // null terminate list only when not yet at end of list;
			vst_aryValueList[ vinNumValues ].vinValueType = cinValueType_Null;
		}

		if ( vfn_ptrMsgCapture != NULL )
			vfn_ptrMsgCapture( this );
		
	} // tclMessage::fvoFinishCapture

	void tclMessage::fvoCapture_IntValue( int pinValueType, int pinValue )
	{
		if ( !vboCaptureMsg )
		// message is not being captured;
			return;

		if ( fboBufferOverflow( ) )
		{ // this is a critical error;
			return;
		}
		
		vst_aryValueList[ vinNumValues ].vinInt = pinValue;
		
		//.begin - MUST be the last line of this routine;
			fvoFinishCapture( pinValueType );
		//.end

	} // tclMessage::fvoCapture_IntValue

	void tclMessage::fvoCapture_FloatValue( int pinValueType, float pflValue )
	{
		if ( !vboCaptureMsg )
		// message is not being captured;
			return;

		if ( fboBufferOverflow( ) )
		{ // this is a critical error;
			return;
		}
		
		vst_aryValueList[ vinNumValues ].vflFloat = pflValue;
		
		//.begin - MUST be the last line of this routine;
		fvoFinishCapture( pinValueType );
		//.end

	} // tclMessage::fvoCapture_FloatValue

	void tclMessage::fvoCapture_StringValue( int pinValueType, string ptxValue )
	{
		if ( !vboCaptureMsg )
		// message is not being captured;
			return;

		if ( fboBufferOverflow( ) )
		{ // this is a critical error;
			return;
		}
		
		vst_aryValueList[ vinNumValues ].vtxString = ptxValue;
		
		//.begin - MUST be the last line of this routine;
		fvoFinishCapture( pinValueType );
		//.end

	} // tclMessage::fvoCapture_StringValue

	void tclMessage::fvoCapture_Byte( int pinByte )
	{
		fvoCapture_IntValue( cinValueType_Byte, pinByte );
	} // tclMessage::fvoCapture_Byte

	void tclMessage::fvoCapture_Char( int pinChar )
	{
		fvoCapture_IntValue( cinValueType_Char, pinChar );
	} // tclMessage::fvoCapture_Char

	void tclMessage::fvoCapture_Short( int pinShort )
	{
		fvoCapture_IntValue( cinValueType_Short, pinShort );
	} // tclMessage::fvoCapture_Short
	
	void tclMessage::fvoCapture_Long( int pinLong )
	{
		fvoCapture_IntValue( cinValueType_Long, pinLong );
	} // tclMessage::fvoCapture_Long

	void tclMessage::fvoCapture_Angle( float pflAngle )
	{
		fvoCapture_FloatValue( cinValueType_Angle, pflAngle );
	} // tclMessage::fvoCapture_Angle

	void tclMessage::fvoCapture_Coord( float pflCoord )
	{
		fvoCapture_FloatValue( cinValueType_Coord, pflCoord );
	} // tclMessage::fvoCapture_Coord

	void tclMessage::fvoCapture_String( const char* pch_ptrString )
	{
		string vtxString;
		if ( pch_ptrString != NULL )
			vtxString = pch_ptrString;

		fvoCapture_StringValue( cinValueType_String, vtxString );
	} // tclMessage::fvoCapture_String

	void tclMessage::fvoCapture_Entity( int pinEntity )
	{
		fvoCapture_IntValue( cinValueType_Entity, pinEntity );
	} // tclMessage::fvoCapture_Entity

//.e MA_Message.cpp
