//.b 	
//	Copyright 2001 [MEAN].BOT
//	
//	File: MA_message.h
//	
//	[MEAN] Message Capture Module. 
//
//.e	

//.b skip over if header has already been included.
	#ifndef defMI_Message_h

	// Prevent the reprocessing of this definition file by defining 
	// the alias used in the above "ifndef" check.
		#define defMI_Message_h

	// Include all general definition files.
		#include "MB_Includes.h"

	const short cinValueType_Null   = 0; // no value defined - end of list marker;
	const short cinValueType_Byte   = 1; // stored as an int;
	const short cinValueType_Char   = 2; // stored as an int;
	const short cinValueType_Short  = 3; // stored as an int;
	const short cinValueType_Long   = 4; // stored as an int;
	const short cinValueType_Angle  = 5; // stored as a float;
	const short cinValueType_Coord  = 6; // stored as a float;
	const short cinValueType_String = 7; // stored as a string;
	const short cinValueType_Entity = 8; // stored as an int;

	struct tstValue
	{
		int vinValueType;
		union 
		{ 	int vinInt; float vflFloat; };
		string vtxString;
	}; // tstValue

	// The list of values for each message;
	const int cinMinValues	 =  1; 
	const int cinMaxValues	 = 30; // this value should be more than large enough;
	const int cinMinValueIdx =  0;
	const int cinMaxValueIdx = cinMaxValues - 1;

	typedef void ( *tfn_ptrMsgBegin )( void* pcl_ptrMessage );
	typedef void ( *tfn_ptrMsgEnd )( void* pcl_ptrMessage );
	typedef void ( *tfn_ptrMsgCapture )( void* pcl_ptrMessage );
	typedef void ( *tfn_ptrMsgSent )( void* pcl_ptrMessage );

	class tclBaseMsg
	{
		public:
			int			 vinMsgType;			// indicates what type of message it is;
			int			 vinMsgDest;			// MSG_BROADCAST, MSG_ALL, MSG_ONE_UNRELIABLE, MSG_ONE, MSG_PVS, MSG_PVS_R, MSG_PAS, MSG_PAS_R
			const float* vfl_ptrOrigin;      // the origin of the entity receiving the message;
			edict_t*     vst_ptrEdict;			// this is the entity receiving the message;
			tclBaseMsg( );
	}; // tclBaseMsg

	class tclMessage: public tclBaseMsg
	{
		public:
			bool			 vboCaptureMsg;		// indicates if a message capture is allowed;
			bool			 vboSendMsg;		   // indicates if a captured message will be sent;
			bool			 vboTraceMsg;			// indicates if a captured message will be traced;
			bool			 vboTraceDisplayMsg;	// indicates if a captured message will be displayed on screen;

			tfn_ptrMsgBegin   vfn_ptrMsgBegin;   // function that is called just before the message starts;
			tfn_ptrMsgEnd     vfn_ptrMsgEnd;     // function that is called just before the message is sent;
			tfn_ptrMsgCapture vfn_ptrMsgCapture; // function that is called during each message write event;
			tfn_ptrMsgSent		vfn_ptrMsgSent;	 // function that is called after message is sent;

		//.begin - message contents
			tstValue vst_aryValueList[ cinMaxValueIdx ]; // list of values making up the message;
		//.end - message contents
			int  vinNumValues; // number of values in the value list;

			tclMessage( void );
			void fvoTraceEventInfo( string ptxMsg );
			void fvoSetCaptureMsgOn( void );
			void fvoSetCaptureMsgOff( void );
			void fvoSetSendMsgFlagOn( void );
			void fvoSetSendMsgFlagOff( void );
			bool fboSendMsgFlagIsOn( void );
			bool fboSendMsgFlagIsOff( void );
			void fvoSendMsg( void );
			void fvoClearValueList_Full( void );
			void fvoClearValueList( void );
			bool fboCaptureMsgIsOn( void );
			bool fboCaptureMsgIsOff( void );
			void fvoMsg_Begin( int pinMsgDest, int pinMsgType, const float* pfl_ptrOrigin, edict_t* pst_ptrEdict );
			void fvoMsg_End( void ); 
			bool fboBufferOverflow( );
			void fvoFinishCapture( int pinValueType );
			void fvoCapture_IntValue( int pinValueType, int pinValue );
			void fvoCapture_FloatValue( int pinValueType, float pflValue );
			void fvoCapture_StringValue( int pinValueType, string ptxValue );
			void fvoCapture_Byte( int pinByte );
			void fvoCapture_Char( int pinChar );
			void fvoCapture_Short( int pinShort );
			void fvoCapture_Long( int pinLong );
			void fvoCapture_Angle( float pflAngle );
			void fvoCapture_Coord( float pflCoord );
			void fvoCapture_String( const char* pch_ptrString );
			void fvoCapture_Entity( int pinEntity );

	}; // tclMessage

	extern tclMessage vclMessage;
	#endif // defMI_Message_h
//.e skip over if header has already been included.

