//.b 	
//	Copyright 2001 [MEAN].BOT
//	
//	File: MA_Player.h
//	
//	[MEAN] Interface Wrapper for the player entity.
//
//.e	

//.b skip over if header has already been included.
#ifndef defMA_Player_h

	// Prevent the reprocessing of this definition file by defining 
	// the alias used in the above "ifndef" check.
	#define defMA_Player_h

	// Include all general definition files.
	#include "MB_Includes.h"
	#include "MA_Sched.h"
	
	#ifndef def_Util_h
		#include "util.h"
		#include "cbase.h"
		#define def_Util_h
	#endif
	
	// Hit Group standards
	#define HITGROUP_GENERIC	0
	#define HITGROUP_HEAD		1
	#define HITGROUP_CHEST		2
	#define HITGROUP_STOMACH	3
	#define HITGROUP_LEFTARM	4	
	#define HITGROUP_RIGHTARM	5
	#define HITGROUP_LEFTLEG	6
	#define HITGROUP_RIGHTLEG	7

	const int cinHeadShot_Off		= 0; // all body parts take damage;
	const int cinHeadShot_Bot		= 1; // bots take damage from head shots only;
	const int cinHeadShot_Human	= 2; // humans take damage from head shots only;
	const int cinHeadShot_Clan		= 3; // clan members take damage from head shots only;
	const int cinHeadShot_World	= 4; // world members take damage from head shots only;
	const int cinHeadShot_All		= 5; // everyone takes damage from head shots only;

	const int cinTeam_Unknown	= -1;
	const int cinTeam_Any		=  5;
	const int cinTeam_TE			=  1;
	const int cinTeam_CT			=  2;

	const int cinBio_Unknown = -1;
	const int cinBio_Any		 = 0;
	const int cinBio_Bot		 = 1;
	const int cinBio_Human	 = 2;

	const string ctxTeam_Unknown	= "?";
	const string ctxTeam_UnknownLong	= "unknown";
	const string ctxTeam_Any		= "any";
	const string ctxTeam_TE			= "TE";
	const string ctxTeam_CT			= "CT";
	const string ctxTeam_TELong	= "terrorist";
	const string ctxTeam_CTLong	= "counter-terrorist";

	const string ctxBio_Unknown = "?";
	const string ctxBio_UnknownLong = "unknown";
	const string ctxBio_Any		 = "any";
	const string ctxBio_Bot		 = "bot";
	const string ctxBio_Human	 = "human";

	const int cinMaxPlayers			= 32;
	const int cinMinPlayers			= 1;
	const int cinMaxPlayerIndex	= cinMaxPlayers;
	const int cinMinPlayerIndex	= 1;
	const int cinMinUserId			= 1;

//!!.begin - should go into a common module used by all other modules;
	const int cinYes		 =  1;
	const int cinNo		 =  0;
	const int cinNotSet   = -1;

	const string ctxYes		 = "yes";
	const string ctxNo		 = "no";
	const string ctxNotSet   = "notset";
//!!.end 
	const int cinPlayerName_MaxLen =  40;

	const int cinPlayer_PlayerIndexNotFound	= 0;
	const int cinPlayer_UserIdNotFound			= 0;

	const int cinEffect_AdminSlap = 0;
	const int cinEffect_BitchSlap = 1;
	const int cinEffect_FastAdminSlap = 2;
	const int cinEffect_FastBitchSlap = 3;

	const int cinGameMode_Fun		= 0;
	const int cinGameMode_Serious = 1;
	const int cinGameMode_DEFAULT = cinGameMode_Serious;

	class tclPlayer 
	{
		public:
			tclPlayer( void );

			int	 vinCurrentClanTeam;
			bool	 vboEnforceClanTeam;
			bool	 vboEnforceClanTeamStrict;
			bool	 vboEnforceClanTeamAuto;
			int	 vinCurrentHumanTeam;
			bool	 vboEnforceHumanTeam;
			bool	 vboEnforceHumanTeam_Fixed;

			int vinReservedSlots;
			int vinMaxHumans;

			// sound command indexes
			int vinDamage_EqualProbCmdIdx;
			int vinDamage_HighProbCmdIdx;
			int vinDamage_LowProbCmdIdx;
			
			int vinDamage_HandSlapCmdIdx;
			int vinDamage_BitchSlapCmdIdx;

			void   fvoInitSoundDamage( void );
			int	 finGetMaxPlayers( void );
			int	 finGetCurPlayers( void );
			int	 finGenRandomTeam( void );
			bool	 fboAddHealthByEdict				( edict_t* pst_ptrEdict, int pinAddHealth, int pinMinHealth );
			bool	 fboThrowPlayerByEdict			( edict_t* pst_ptrEdict, bool pboHard );
			bool	 fboSlapPlayerByEdict			( edict_t* pst_ptrEdict, bool	pboHard, int pinEffect, string ptxReason );
			bool   fboKillPlayerByEdict			( edict_t* pst_ptrEdict, string ptxReason, bool pboSuicide = true );

			bool   fboPlayerIsValidByEdict      ( edict_t* pst_ptrEdict );
			bool	 fboPlayerIsAliveByEdict		( edict_t* pst_ptrEdict );
			bool	 fboPlayerIsSpectatorByEdict  ( edict_t* pst_ptrEdict );
			string ftxGetPlayerNameByEdict	   ( edict_t* pst_ptrEdict ); 
			int	 finGetUserIdByEdict          ( edict_t* pst_ptrEdict );
			int    finGetPlayerIndexByEdict	   ( edict_t* pst_ptrEdict );
			string ftxGetPlayerModelNameByEdict ( edict_t* pst_ptrEdict );
			int    finGetPlayerTeamByEdict      ( edict_t* pst_ptrEdict );
			int	 finGetPlayerBioByEdict		   ( edict_t* pst_ptrEdict );
			int	 finGetPlayerBioByEdict_RAW	( edict_t* pst_ptrEdict );
			bool	 fboGetPlayerOriginByEdict		( edict_t* pst_ptrEdict, Vector& pstOrigin );
			int	 finGetPlayerHealthByEdict		( edict_t* pst_ptrEdict );
			bool   fboPlayerIsHumanByEdict      ( edict_t* pst_ptrEdict );
			bool   fboPlayerIsBotByEdict        ( edict_t* pst_ptrEdict );
			bool   fboKickPlayerByEdict			( edict_t* pst_ptrEdict, string ptxReason );
			bool	 fboEmitSparksFromPlayerByEdict( edict_t* pst_ptrEdict, Vector pstOrigin );
			bool	 fboEmitBloodFromPlayerByEdict ( edict_t* pst_ptrEdict );
			bool	 fboEmitSoundFromPlayerByEdict ( edict_t* pst_ptrEdict, 
															   string	ptxSoundFile, 
															   bool     pboAliveOnly  );
			bool	 fboBanPlayerByEdict( edict_t* pst_ptrEdict, int pinMins, string ptxReason, edict_t* pst_ptrEdictBannedBy = NULL );			
			bool	 fboSwitchTeamByEdict          ( edict_t* pst_ptrEdict, string ptxReason );

			edict_t*     fst_ptrGetPlayerByIndex ( int pinPlayerIndex );
			edict_t*     fst_ptrGetPlayerByUserId( int pinPlayerId );

			bool   fboPlayerIsValidByIndex( int pinPlayerIndex );
			int	 finGetUserIdByIndex    ( int pinPlayerIndex );
			int	 fboPlayerIsAliveByIndex( int pinPlayerIndex );
			bool	 fboPlayerIsSpectatorByIndex( int pinPlayerIndex );
			string ftxGetPlayerNameByIndex( int pinPlayerIndex );
			int	 finGetPlayerTeamByIndex( int pinPlayerIndex );
			int	 finGetPlayerBioByIndex ( int pinPlayerIndex );
			int	 finGetPlayerPingByIndex( int pinPlayerIndex );
			bool   fboPlayerIsHumanByIndex( int pinPlayerIndex );
			bool   fboPlayerIsBotByIndex  ( int pinPlayerIndex );
			bool   fboKickPlayerByIndex   ( int pinPlayerIndex, string ptxReason );
			bool	 fboThrowPlayerByIndex  ( int pinPlayerIndex, bool pboHard );
			bool	 fboSlapPlayerByIndex   ( int pinPlayerIndex, bool pboHard, int pinEffect, int pinRepeat, string ptxReason );
			bool	 fboKillPlayerByIndex   ( int pinPlayerIndex, string ptxReason );
			bool	 fboBanPlayerByIndex( int pinPlayerIndex, int pinMins, string ptxReason, edict_t* pst_ptrEdictBannedBy = NULL );
			bool	 fboEmitSoundFromPlayerByIndex      ( int		pinPlayerIndex,  
																	  string ptxSoundFile, 
																	  bool	pboAliveOnly );
			bool	 fboEmitSoundFromAlivePlayerByIndex	( int pinPlayerIndex, string ptxSoundFile );

			bool	 fboSwitchTeamByIndex( int pinPlayerIndex, string ptxReason );

			bool   fboPlayerExistsByUserId  ( int pinUserId );
			int	 finGetPlayerIndexByUserId( int pinUserId );
			bool	 fboPlayerIsAliveByUserId ( int pinUserId );
			bool	 fboPlayerIsSpectatorByUserId( int pinPlayerIndex );
			string ftxGetPlayerNameByUserId ( int pinUserId );
			bool   fboPlayerIsHumanByUserId ( int pinUserId );
			bool   fboPlayerIsBotByUserId   ( int pinUserId );
			int	 finGetPlayerBioByUserId  ( int pinUserId );
			int    finGetPlayerTeamByUserId ( int pinUserId );
			bool   fboKickPlayerByUserId    ( int pinUserId, string ptxReason );
			bool	 fboThrowPlayerByUserId	  ( int pinUserId, bool pboHard );
			bool	 fboSlapPlayerByUserId	  ( int pinUserId, bool pboHard, int pinEffect, int pinRepeat, string ptxReason );
			bool	 fboKillPlayerByUserId	  ( int pinUserId, string ptxReason );
			bool	 fboBanPlayerByUserId	  ( int pinUserId, int pinMins, string ptxReason, edict_t* pst_ptrEdictBannedBy = NULL );
			bool	 fboEmitSoundFromPlayerByUserId      ( int    pinPlayerIndex, 
																		string ptxSoundFile, 
																	   bool	 pboAliveOnly );
			bool   fboEmitSoundFromAlivePlayerByUserId ( int pinUserId, string ptxSoundFile );
			
			void	 fvoCountClanMembers			( int& pinClanOnTeam_TE, int& pinClanOnTeam_CT );
			int	 finCountClanMembersOnTeam ( int pinTeam );
			int	 finCountPlayersOnTeam		( int pinTeam );
			int	 finCountHumansOnTeam		( int pinTeam );
			void	 finCountHumansOnTeam		( int& pinHumansOnTeam_TE, int& pinHumansOnTeam_CT );
			int	 finCountAliveHumansOnTeam	( int pinTeam );
			int	 finCountDeadHumansOnTeam	( int pinTeam );
			int	 finCountBotsOnTeam			( int pinTeam );
			int	 finCountAliveBotsOnTeam	( int pinTeam );
			int	 finCountDeadBotsOnTeam		( int pinTeam );
			int	 finCountBotsInGame			( );
			int	 finCountAliveBotsInGame	( );
			int	 finCountDeadBotsInGame		( );
			int	 finCountHumansInGame		( );
			int	 finCountAliveHumansInGame	( );
			int	 finCountDeadHumansInGame	( );
			bool	 fboBotsInGame					( );
			void   fvoCountEveryOne				( int &pinHumanSpectators, 
														  int &pinBotSpectators, 
														  int &pinHumansOnTE,
														  int &pinBotsOnTE,
												        int &pinHumansOnCT,
														  int &pinBotsOnCT);

			void   fvoCountAliveDead(	int &pinAliveBots_TE, 
												int &pinAliveBots_CT,
												int &pinDeadHumansInGame,
												int &pinAliveHumansInGame );

			void	 fvoKillAllHumansOnBotTeam ( int pinBotTeam, string ptxReason );
			void	 fvoSwitchAllHumansOnBotTeam( int pinBotTeam, string ptxReason );
			void   fvoKillAllPlayers			( int pinTeam, bool pboExcludeBots, string ptxReason );
			void   fvoKillAllHumans 			( int pinTeam, string ptxReason );

			void   fvoKickAllPlayers			( int pinTeam, bool pboExcludeBots, string ptxReason );
			void   fvoKickAllHumans 			( int pinTeam, string ptxReason );
			void   fvoSlapAll						( int pinBio, bool pboHard, int pinEffect, int pinRepeat, string ptxReason );
			void   fvoSlapAllPlayers			( bool pboHard, int pinEffect, int pinRepeat, string ptxReason );
			void   fvoSlapAllBots				( bool pboHard, int pinEffect, int pinRepeat, string ptxReason );
			void   fvoSlapAllHumans				( bool pboHard, int pinEffect, int pinRepeat, string ptxReason );
			string ftxIntToTeamStr				( int pinTeam );
			string ftxIntToTeamStrLong			( int pinTeam );
			string ftxIntToBioStr				( int pinBio );
			string ftxIntToBioStrLong			( int pinBio );

			int	 finTeamStrToInt				( string ptxTeam );
			int	 finBioStrToBioInt			( string ptxBio );
	
			void	 fvoListPlayers            ( edict_t* pst_ptrEdict, int pinTeam, int pinBio );
			bool	 fboListUserInfoByUserId	( edict_t* pst_ptrEdict, int pinUserId );

			bool   fboPlayDamageSound ( edict_t* pst_ptrEdict );
			//!! misplaced; should go into a "game" module;
			int	 vinGameMode; 
			int	 vinHeadShotMode;
			int	 finGetGameMode( void );
			//!! set game mode is a hack; the default game mode is not
			//!! set on game start up; you have to place fvoSetGameMode
			void	 fvoSetGameMode( void );
			void	 fvoSetGameMode( int pinGameMode );
			int	 finGetHeadShotMode( ){ return vinHeadShotMode;	};
			void	 fvoSetHeadShotMode( int pinHeadShotMode );
			void	 fvoCheckHeadShotMode( TraceResult* ptrTR );
			bool   fboIsAllowedOnClanTeamByUserId( int pinUserId );
			bool   fboIsAllowedOffClanTeamByUserId( int pinUserId );
			int	 finGetClanTeam( void );
			void	 fvoEnforceClanTeam( void );
			bool   fboSendEvent_EnforceClanTeam( float pflDelay );
			int	 finGetHumanTeam( void );
			void	 fvoEnforceHumanTeam( void );
			bool   fboSendEvent_EnforceHumanTeam( float pflDelay );

			int finGetMaxHumans( );
			bool fboSetMaxHumans( int pinMaxHumans );
			bool fboHumanCountExceeded( );
			int finGetReservedSlots( );
			bool fboSetReservedSlots( int pinSlots );
			void fvoAddBot( string tvxBotName, const int pinTeam = cinTeam_Any );

	}; // tclPlayer

// Make global instance of tclPlayer object available.
	extern tclPlayer vclPlayer;

	void fvoMA_Player_Event_SlapSwicken( tclArgList& pclArgList );
	
#endif // defMA_Player_h
