//.b 	
//	Copyright 2001 [MEAN].BOT
//	
//	File: MA_Text.cpp
//	
//	[MEAN] Text Message Loader. 
//
//.e	

#include "MG_Lib.h"
#include "MA_Text.h"
#include "MA_EngDLLCmd.h"
#include "MB_InterfaceL1.h"
#include "MI_Hud.h"

	tclTextLine::tclTextLine( )
	{
		vtxText = "";
		vcl_ptrNext = NULL;
	} // tclTextLine::tclTextLine

	tclConnMsg::tclConnMsg( )
	{
		vinLineCount = 0;
		vcl_ptrCur = NULL;
		vcl_ptrFirst = NULL;
		vcl_ptrLast = NULL;
		vcl_ptrTemp = NULL;

	} // tclConnMsg::tclConnMsg

	tclConnMsg::~tclConnMsg( )
	{
		fvoDestroyList( );
	} // tclConnMsg::tclConnMsg

	void tclConnMsg::fvoDestroyList( )
	{
		vcl_ptrCur = vcl_ptrFirst;
		while ( vcl_ptrCur != NULL )
		{
			vcl_ptrTemp = vcl_ptrCur;
			vcl_ptrCur = vcl_ptrCur->vcl_ptrNext;
			delete vcl_ptrTemp;
		}
		
		vcl_ptrFirst = NULL;
		vcl_ptrLast	= NULL;
		vcl_ptrTemp	= NULL;
		vinLineCount = 0;

	} // tclConnMsg::fvoDestroyList

	bool tclConnMsg::fboTextLineIsValid( string ptxMsgLine, tclTextLine* pcl_ptrTextLine )
	{
		if ( pcl_ptrTextLine == NULL )
			return false;

		// do nothing for now; later on check maximum line length and look for
		// illegal characters;

		pcl_ptrTextLine->vtxText = ptxMsgLine;
		return true;
	} // tclConnMsg::fboTextLineIsValid

	void tclConnMsg::fvoLoadList( void )
	{
		fvoLoadList( NULL );
	} // tclConnMsg::fvoLoadList

	void tclConnMsg::fvoLoadList( edict_t* pst_ptrEdict )
	{
		string vtxMsg;
		string vtxFileName = ctxGameSubFolder + def_PathBarStr + ctxMEANFolder + def_PathBarStr + ctxConnMsgFile;

		vtxMsg  = ctxMsgPrefix + "Loading user connection message from file:\n  " + vtxFileName;
		fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
		vclDebugTrace.fvoWriteEventInfo( true, vtxMsg );

		if ( !( fboFileExists( vtxFileName ) 
			        && 
			     fboFileCanBeRead( vtxFileName ) )  
			)
		{
			vtxMsg  = "** ERROR: cannot read from " + ctxConnMsgFile + " \n";
			vtxMsg += ctxMsgPrefix + "Load was aborted due to an error."; 
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
			vclDebugTrace.fvoWriteEventInfo( true, vtxMsg);
			return;
		} 

		FILE* vna_ptrFile;
		char vch_aryMsgLine[ 255 ];

		if ( vcl_ptrFirst != NULL )
			fvoDestroyList( );
		
		vna_ptrFile = fopen( vtxFileName.c_str( ), "r" );

		if ( vna_ptrFile == NULL )
		{
			vtxMsg  = "** ERROR: cannot open " + ctxConnMsgFile;
			vtxMsg += ctxMsgPrefix + "Load was aborted due to an error."; 
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
			vclDebugTrace.fvoWriteEventInfo( true, vtxMsg);
			return;
		}

		vcl_ptrCur = NULL;
		tclTextLine* vcl_ptrTextLine_New;
		vinLineCount = 0;
		string vtxMsgLine;

		while	( fgets( vch_aryMsgLine, 255, vna_ptrFile ) != NULL ) 
		{
			vtxMsgLine = vch_aryMsgLine;
			vtxMsgLine = ftxTrim( vtxMsgLine );

//			if ( vtxMsgLine.empty( ) )
//				continue;

			if ( vtxMsgLine[ 0 ] == ';' )
				continue;

			vcl_ptrTextLine_New = new tclTextLine;

			if ( !fboTextLineIsValid( vtxMsgLine, vcl_ptrTextLine_New ) )
			{
				delete vcl_ptrTextLine_New;
				vtxMsg  = "** WARNING: message line not valid! \n  " + vtxMsgLine;
				fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
				vclDebugTrace.fvoWriteEventInfo( true, vtxMsg);
				continue;
			}

			if ( vcl_ptrFirst == NULL )
				vcl_ptrFirst = vcl_ptrTextLine_New;
			
			if ( vcl_ptrLast == NULL )
				vcl_ptrLast = vcl_ptrTextLine_New;	
			else
			{
				vcl_ptrLast->vcl_ptrNext = vcl_ptrTextLine_New;
				vcl_ptrLast = vcl_ptrTextLine_New;
			}	

			vinLineCount = ++vinLineCount;
//.begin for debugging only
//			vtxMsg  = "  Loaded: " + vtxMsgLine;
//			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
//			vclDebugTrace.fvoWriteEventInfo( true, vtxMsg);
//.end
		}

		fclose( vna_ptrFile );

		vtxMsg  = ctxMsgPrefix + "User connection message load completed.";		
		fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
		vclDebugTrace.fvoWriteEventInfo( true, vtxMsg);

	} // tclConnMsg::fvoLoadList

	void tclConnMsg::fvoDisplayMsg( edict_t* pst_ptrEdict )
	{
		vcl_ptrCur = vcl_ptrFirst;
		while ( vcl_ptrCur != NULL )
		{
			fvoConsolePrint( pst_ptrEdict, vcl_ptrCur->vtxText + "\n" );
			vcl_ptrCur = vcl_ptrCur->vcl_ptrNext;
		}
	} // tclConnMsg::fvoDisplayMsg

	tclPopupMsg::tclPopupMsg( )
	{
		vinLineCount = 0;
		vflDelayInSec = vflDelayInSec_DEFAULT;
		vcl_ptrCur = NULL;
		vcl_ptrFirst = NULL;
		vcl_ptrLast = NULL;
		vcl_ptrTemp = NULL;
		
	} // tclPopupMsg::tclPopupMsg

	tclPopupMsg::~tclPopupMsg( )
	{
		fvoDestroyList( );
	} // tclPopupMsg::~tclPopupMsg

	bool tclPopupMsg::fboTextLineIsValid( string ptxMsgLine, tclTextLine* pcl_ptrTextLine )
	{
		if ( pcl_ptrTextLine == NULL )
			return false;

		// do nothing for now; later on check maximum line length and look for
		// illegal characters;

		pcl_ptrTextLine->vtxText = ptxMsgLine;
		return true;
	} // tclPopupMsg::fboTextLineIsValid

	void tclPopupMsg::fvoDestroyList( )
	{
		vcl_ptrCur = vcl_ptrFirst;
		while ( vcl_ptrCur != NULL )
		{
			vcl_ptrTemp = vcl_ptrCur;
			vcl_ptrCur = vcl_ptrCur->vcl_ptrNext;
			delete vcl_ptrTemp;
		}
		
		vcl_ptrFirst = NULL;
		vcl_ptrLast	= NULL;
		vcl_ptrTemp	= NULL;
		vinLineCount = 0;

	} // tclPopupMsg::fvoDestroyList

	bool tclPopupMsg::fboAddLine( edict_t* pst_ptrEdict, string ptxLine )
	{
		ptxLine = ftxTrim( ptxLine );

		if ( ptxLine.empty( ) )
			return false;

		if ( ptxLine[ 0 ] == ';' )
			return false;

		tclTextLine* vcl_ptrTextLine_New = new tclTextLine;

		if ( !fboTextLineIsValid( ptxLine, vcl_ptrTextLine_New ) )
		{
			delete vcl_ptrTextLine_New;
			string vtxMsg  = "** WARNING: message line not valid! \n  " + ptxLine;
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
			vclDebugTrace.fvoWriteEventInfo( true, vtxMsg);
			return false;
		}

		if ( vcl_ptrFirst == NULL )
			vcl_ptrFirst = vcl_ptrTextLine_New;
		
		if ( vcl_ptrLast == NULL )
			vcl_ptrLast = vcl_ptrTextLine_New;	
		else
		{
			vcl_ptrLast->vcl_ptrNext = vcl_ptrTextLine_New;
			vcl_ptrLast = vcl_ptrTextLine_New;
		}	

		vinLineCount++;
		return true;

	} // tclPopupMsg::fboAddLine

	void tclPopupMsg::fvoLoadList( edict_t* pst_ptrEdict )
	{
		string vtxMsg;
		string vtxFileName = ctxGameSubFolder + def_PathBarStr + ctxMEANFolder + def_PathBarStr + ctxPopupMsgFile;

		vtxMsg  = ctxMsgPrefix + "Loading popup message list from file:\n  " + vtxFileName;
		fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
		vclDebugTrace.fvoWriteEventInfo( true, vtxMsg );

		if ( !( fboFileExists( vtxFileName ) 
			        && 
			     fboFileCanBeRead( vtxFileName ) )  
			)
		{
			vtxMsg  = "** ERROR: cannot read from " + ctxPopupMsgFile + " \n";
			vtxMsg += ctxMsgPrefix + "Load was aborted due to an error."; 
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
			vclDebugTrace.fvoWriteEventInfo( true, vtxMsg);
			return;
		} 

		FILE* vna_ptrFile;
		char vch_aryMsgLine[ 255 ];

		if ( vcl_ptrFirst != NULL )
			fvoDestroyList( );
		
		fvoLoadDefaultList( );

		vna_ptrFile = fopen( vtxFileName.c_str( ), "r" );

		if ( vna_ptrFile == NULL )
		{
			vtxMsg  = "** ERROR: cannot open " + ctxConnMsgFile;
			vtxMsg += ctxMsgPrefix + "Load was aborted due to an error."; 
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
			vclDebugTrace.fvoWriteEventInfo( true, vtxMsg);
			return;
		}

		tclTextLine* vcl_ptrTextLine_New;
		string vtxMsgLine;

		while	( fgets( vch_aryMsgLine, 255, vna_ptrFile ) != NULL ) 
		{
			vtxMsgLine = vch_aryMsgLine;
			fboAddLine( pst_ptrEdict, vtxMsgLine );
		}

		fclose( vna_ptrFile );

		vtxMsg  = ctxMsgPrefix + "Popup message load completed.";		
		fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
		vclDebugTrace.fvoWriteEventInfo( true, vtxMsg);

	} // tclPopupMsg::fvoLoadList

	void tclPopupMsg::fvoLoadList( )
	{
		fvoLoadList( NULL );
	} // tclPopupMsg::fvoLoadList

	void tclPopupMsg::fvoLoadDefaultList( )
	{
		string vtxMsgLine = "This server is powered by the (mEAn) Bot.Admin Mod";
		fboAddLine( NULL, vtxMsgLine );

	} // tclPopupMsg::fvoLoadDefaultList

	void tclPopupMsg::fvoSetTimeDelayInSec( float pflSec )
	{
		vflDelayInSec = pflSec;
		vclTimer_Pop.fvoStart( vflDelayInSec );
	} // tclPopupMsg::fvoSetTimeDelayInSec
	
	void tclPopupMsg::fvoDisplayMsg( )
	{
		if ( !vclTimer_Pop.fboTimedOut( ) )
			return;

		if ( vcl_ptrFirst == NULL )
		// nothing in the list;
			return;

		if ( vcl_ptrCur ==  NULL )
			vcl_ptrCur = vcl_ptrFirst;

		// display message;
		// vclHUD.fvoStatusSay( ctxMsgPrefix + vcl_ptrCur->vtxText + "\n" );
		vclHUD.fvoStatusSay( vcl_ptrCur->vtxText + "\n" );
		vcl_ptrCur = vcl_ptrCur->vcl_ptrNext;

		vclTimer_Pop.fvoStart( vflDelayInSec );
		
	} // tclPopupMsg::fvoDisplayMsg

	tclMA_Text::tclMA_Text( )
	{
	} // tclMA_Text::tclMA_Text

	tclMA_Text::~tclMA_Text( )
	{
	} // tclMA_Text::tclMA_Text

	// Define global instance of Security Class;
	tclMA_Text vclMA_Text;

