//.b 	
//	Copyright 2001 [MEAN].BOT
//	
//	File: MA_Weapon.cpp
//	
//	[MEAN] Weapon Class Definitions.
//
//.e	

#include "MG_Lib.h"
#include "MA_EngDLLCmd.h"
#include "MA_Weapon.h"
#include "MA_Bot.h"
#include "MA_Player.h"
#include "MI_player.h"
#include "MI_Sound.h"
#include "MA_GlobalVars.h"
#include "MA_BotControl.h" //!! wrong place for CVAR string ctxCVar_WeapomSelectBan
#include "MA_Security.h"
#include "MI_Hud.h"

#ifdef defDebug_Bot

	#define xdefDebug_WeaponBuy
	#define xdefDebug_WeaponFind

	#ifdef defDebug_WeaponBuy
	void fvoDebugBot_WeaponBuy( edict_t* pst_ptrEdict, string ptxMsg )
	{
		fvoDebugBot( pst_ptrEdict, ptxMsg );
	} // fvoDebugBot_WeaponBuy
	#endif

	#ifdef defDebug_WeaponFind
	void fvoDebugBot_WeaponFind( edict_t* pst_ptrEdict, string ptxMsg )
	{
		fvoDebugBot( pst_ptrEdict, ptxMsg );
	} // fvoDebugBot_WeaponFind
	#endif

#endif // defDebug_Bot

  int vinLineSpriteTexture = 0;

//.b MA_Weapon.cpp

	const float cflMinDamageReduction = 0; // set off
	const float cflMaxDamageReduction = 1; // 100%

	bool fboModelIsShield( string ptxWeapon )
	{
		if ( ptxWeapon.length( ) < 9 )
			return false;
		// only shield weapons have the '_' at this position;
		return ptxWeapon[ 8 ] == '_';

	} // fboModelIsShield

	string ftxConvertShieldModel( string ptxWeapon )
	{
		// assumes path info is alreay stripped!

		//           123456789
		//           012345678 
		// example: "p_shield_knife"
	   // return: "p_knife"

		if ( ptxWeapon.length( ) < 9 )
			return ptxWeapon;

		if ( ptxWeapon[ 8 ] != '_' )
			return ptxWeapon;

		string vtxNew = "";
		int vinPos = ptxWeapon.length( ) - 1;

		while ( vinPos >= 0 )
		{
			if ( ptxWeapon[ vinPos ] == '_' )
				goto locExit;

			vtxNew = ptxWeapon[ vinPos ] + vtxNew;

			vinPos--;
		}
		locExit:

		return "p_" + vtxNew;

	} // ftxConvertShieldModel

	string ftxWeaponRemovePath( string ptxWeapon )
	{ 
		// example: "models/p_ak47.mdl"
	   // return: "p_ak47"

		if ( ptxWeapon.length( ) <= 0 )
			return ptxWeapon;

		string vtxNew = "";
		int vinPos = ptxWeapon.length( ) - 1;

		while ( vinPos >= 0 )
		{
			if ( ptxWeapon[ vinPos ] == '/' )
				goto locExit;
			if ( ptxWeapon[ vinPos ] == '.' )
			// remove ".mdl" portion;
				vtxNew = "";
			else
				vtxNew = ptxWeapon[ vinPos ] + vtxNew;

			vinPos--;
		}
		locExit:

		return vtxNew;

	} // ftxWeaponRemovePath

	bool tstWeapon::fboWeaponIsBanned_Switch( )
	{ 
		return vboWeaponIsBanned; 
	}

	void tstWeapon::fvoSetWeaponIsBanned_Switch( bool pboWeaponIsBanned )
	{ 
		vboWeaponIsBanned = pboWeaponIsBanned; 
	}

	bool tstWeapon::fboWeaponIsBanned_ByFlag( unsigned short pinBanBit )
	{ 
		return fboWeaponIsBanned_Switch( ) && fboButtonIsOn( vinBanBitFlag, pinBanBit ); 
	}

	bool tstWeapon::fboEntityBanned(  )
	{ 
		return fboWeaponIsBanned_ByFlag( cinBan_Bots ); 
	} // tstWeapon::fboEntityBanned

	tclWeapon vclWeapon;

	tclWeapon::tclWeapon( void )
	{
		vinNumWeapons = 0;
		for ( int vin = 0; vin < cinMaxWeapons; vin++ )
		{
			vstWeaponList[vin].vtxEntityName		= "";
			vstWeaponList[vin].vtxWeaponDesc		= "";
			vstWeaponList[vin].vtxModel			= "";
			vstWeaponList[vin].vtxModelFull		= "";
			vstWeaponList[vin].vboDefault			= false;
			vstWeaponList[vin].vinArmType			= ARM_OTHER;
			vstWeaponList[vin].vinZoomType		= ZOOM_N;
			vstWeaponList[vin].vboInitialized	= false;
			vstWeaponList[vin].vinTeam				= cinTeam_Any;
			vstWeaponList[vin].vboCanBuy			= BUY_N;
			vstWeaponList[vin].vinBuyOption_CT	= 0;
			vstWeaponList[vin].vinBuySlot_CT		= 0;
			vstWeaponList[vin].vinBuyOption_TE	= 0;
			vstWeaponList[vin].vinBuySlot_TE		= 0;
	//		vstWeaponList[vin].vboEntityBanned	= false;
	//		vstWeaponList[vin].vboMenuBanned		= false;

			vstWeaponList[vin].vinBanBitFlag		= cinBan_Off;
			vstWeaponList[vin].vboWeaponIsBanned= false;
			vstWeaponList[vin].vboAvailable		= false;

			vstWeaponList[vin].vinPrimaryAmmoType	 = -1;
			vstWeaponList[vin].vinPrimaryAmmoClip	 = -1;
			vstWeaponList[vin].vinSecondaryAmmoType = -1;
			vstWeaponList[vin].vinSecondaryAmmoClip = -1;
			vstWeaponList[vin].vinHUDSlot				 = -1;
			vstWeaponList[vin].vinSlotPos				 = -1;
			vstWeaponList[vin].vinWeaponId			 = -1;
			vstWeaponList[vin].vinFlags				 = -1;
		}

		for ( int vinUserMenu = cinMinPlayers-1; 
					 vinUserMenu < cinMaxPlayers; 
					 vinUserMenu++ )
		{
			vin_aryBuyMenu[ vinUserMenu ].vinState     = cinNotBuying;
			vin_aryBuyMenu[ vinUserMenu ].vinBuyOption = 0;
			vin_aryBuyMenu[ vinUserMenu ].vinBuySlot   = 0;
		}

#ifdef def_CS16

  //																																								Slot TE Slot CT	
  //  =======================================================================================================================================================================================
		fboAddWeapon( ctxWeapon_knife,	  cinTeam_Any, RANK_L, BUY_N, DEFAULT_Y, ARM_KNIFE, WALL_N, 0.00, ZOOM_N, 0.10, 0.25, 0, 0, 0, 0, "*n/a*",   0, ctxModel_knife, "Knife" );
		fboAddWeapon( ctxWeapon_c4,		  cinTeam_Any, RANK_L, BUY_N, DEFAULT_Y, ARM_BOMB , WALL_N, 0.00, ZOOM_N, 0.00, 0.00, 0, 0, 0, 0, "*n/a*",   0, ctxModel_c4, "Bomb - C4 Explosive" );
// index 2
		fboAddWeapon( ctxWeapon_glock18,	  cinTeam_Any, RANK_M, BUY_Y, DEFAULT_Y, ARM_SIDE , WALL_N, 0.00, ZOOM_N, 0.15, 0.25, 1, 1, 1, 1, "glock",	400, ctxModel_glock, "Pistol - Glock 18" );
		fboAddWeapon( ctxWeapon_usp,		  cinTeam_Any, RANK_M, BUY_Y, DEFAULT_Y, ARM_SIDE , WALL_N, 0.00, ZOOM_N, 0.15, 0.25, 1, 2, 1, 2, "usp",		500, ctxModel_usp, "Pistol - USP .45" );
		fboAddWeapon( ctxWeapon_deagle,	  cinTeam_Any, RANK_H, BUY_Y, DEFAULT_N, ARM_SIDE , WALL_Y, 0.00, ZOOM_N, 0.25, 0.50, 1, 4, 1, 4, "deagle", 650, ctxModel_deagle, "Pistol - Desert eagle" );
		fboAddWeapon( ctxWeapon_p228,		  cinTeam_Any, RANK_H, BUY_Y, DEFAULT_N, ARM_SIDE , WALL_N, 0.00, ZOOM_N, 0.15, 0.25, 1, 3, 1, 3, "p228",   600, ctxModel_p228, "Pistol - SIG P228" );
		fboAddWeapon( ctxWeapon_elite,	  cinTeam_TE,  RANK_H, BUY_Y, DEFAULT_N, ARM_SIDE , WALL_N, 0.00, ZOOM_N, 0.15, 0.25, 1, 5, 0, 0, "elites", 800, ctxModel_elite, "Pistol - Dual Berettas" );
		fboAddWeapon( ctxWeapon_fiveseven, cinTeam_CT,	RANK_H, BUY_Y, DEFAULT_N, ARM_SIDE , WALL_N, 0.00, ZOOM_N, 0.15, 0.25, 0, 0, 1, 5, "fn57",   750, ctxModel_fiveseven, "Pistol - FiveSeven" );
// index 8				
		fboAddWeapon( ctxWeapon_m3,		  cinTeam_Any, RANK_L, BUY_Y, DEFAULT_N, ARM_MAIN , WALL_N, 0.00, ZOOM_N, 0.15, 0.25, 2, 1, 2, 1, "m3",	  1700, ctxModel_m3, "Shotgun pump - M3 super shotgun" );
		fboAddWeapon( ctxWeapon_xm1014,	  cinTeam_Any, RANK_L, BUY_Y, DEFAULT_N, ARM_MAIN , WALL_N, 0.00, ZOOM_N, 0.15, 0.25, 2, 2, 2, 2, "xm1014",3000, ctxModel_xm1014, "Shotgun auto - Benneli xm1014" );
//index 10		
		fboAddWeapon( ctxWeapon_tmp,		  cinTeam_CT,	RANK_L, BUY_Y, DEFAULT_N, ARM_MAIN , WALL_N, 0.00, ZOOM_N, 0.25, 0.50, 0, 0, 3, 1, "tmp",	  1250, ctxModel_tmp, "Sub - Tactical Machine Pistol" );
		fboAddWeapon( ctxWeapon_mac10,	  cinTeam_TE,  RANK_L, BUY_Y, DEFAULT_N, ARM_MAIN , WALL_N, 0.00, ZOOM_N, 0.25, 0.50, 3, 1, 0, 0, "mac10", 1400, ctxModel_mac10, "Sub - MAC-10" );
		fboAddWeapon( ctxWeapon_mp5navy,	  cinTeam_Any, RANK_M, BUY_Y, DEFAULT_N, ARM_MAIN , WALL_N, 0.00, ZOOM_N, 0.25, 0.50, 3, 2, 3, 2, "mp5",   1500, ctxModel_mp5, "Sub - MP5 Navy" );
		fboAddWeapon( ctxWeapon_ump45,	  cinTeam_Any, RANK_L, BUY_Y, DEFAULT_N, ARM_MAIN , WALL_N, 0.00, ZOOM_N, 0.25, 0.50, 3, 3, 3, 3, "ump45", 1700, ctxModel_ump45, "Sub - Universal Machine Pistol" );
		fboAddWeapon( ctxWeapon_p90,		  cinTeam_Any, RANK_M, BUY_Y, DEFAULT_N, ARM_MAIN , WALL_N, 0.00, ZOOM_N, 0.25, 0.50, 3, 4, 3, 4, "p90",   2350, ctxModel_p90, "Sub - P90" );
// index 15
		fboAddWeapon( ctxWeapon_galil,	  cinTeam_TE,  RANK_H, BUY_Y, DEFAULT_N, ARM_MAIN , WALL_Y, 0.00, ZOOM_N, 1.00, 5.50, 4, 1, 0, 0, "galil", 2250, ctxModel_galil, "Rifle - Galil" );
		fboAddWeapon( ctxWeapon_famas,	  cinTeam_CT,  RANK_H, BUY_Y, DEFAULT_N, ARM_MAIN , WALL_Y, 0.00, ZOOM_N, 1.00, 5.50, 0, 0, 4, 1, "famas", 2000, ctxModel_famas, "Rifle - Famas" );
		fboAddWeapon( ctxWeapon_ak47,		  cinTeam_TE,  RANK_H, BUY_Y, DEFAULT_N, ARM_MAIN , WALL_Y, 0.00, ZOOM_N, 1.00, 5.50, 4, 2, 0, 0, "ak47",  2500, ctxModel_ak47, "Rifle - AK 47" );
		fboAddWeapon( ctxWeapon_m4a1,		  cinTeam_CT,  RANK_H, BUY_Y, DEFAULT_N, ARM_MAIN , WALL_Y, 0.00, ZOOM_N, 1.00, 5.50, 0, 0, 4, 3, "m4a1",  3100, ctxModel_m4a1, "Rifle - Colt M4A1 Carbine" );
		fboAddWeapon( ctxWeapon_sg552,	  cinTeam_TE,  RANK_H, BUY_Y, DEFAULT_N, ARM_MAIN , WALL_Y, 0.20, ZOOM_Z, 1.00, 5.50, 4, 4, 0, 0, "sg552", 3500, ctxModel_sg552, "Rifle - Commando" );
		fboAddWeapon( ctxWeapon_aug,		  cinTeam_CT,  RANK_H, BUY_Y, DEFAULT_N, ARM_MAIN , WALL_Y, 0.20, ZOOM_Z, 1.00, 5.50, 0, 0, 4, 4, "aug",   3500, ctxModel_aug, "Rifle - Steyr Aug" );
//index 21
		fboAddWeapon( ctxWeapon_scout,	  cinTeam_Any, RANK_M, BUY_Y, DEFAULT_N, ARM_MAIN , WALL_Y, 1.85, ZOOM_S, 1.00, 2.50, 4, 3, 4, 2, "scout", 2750, ctxModel_scout, "Snipe - Scout" );
		fboAddWeapon( ctxWeapon_awp,		  cinTeam_Any, RANK_H, BUY_Y, DEFAULT_N, ARM_MAIN , WALL_Y, 1.85, ZOOM_S, 1.00, 2.50, 4, 5, 4, 6, "awp",   4750, ctxModel_awp, "Snipe - Artic" );
		fboAddWeapon( ctxWeapon_g3sg1,	  cinTeam_TE,  RANK_M, BUY_Y, DEFAULT_N, ARM_MAIN , WALL_Y, 0.30, ZOOM_S, 1.00, 2.50, 4, 6, 0, 0, "g3sg1", 5000, ctxModel_g3sg1, "Snipe - H&K Sniper Rifle" );
		fboAddWeapon( ctxWeapon_sg550,	  cinTeam_CT,  RANK_M, BUY_Y, DEFAULT_N, ARM_MAIN , WALL_Y, 0.30, ZOOM_S, 1.00, 2.50, 0, 0, 4, 5, "sg550", 4200, ctxModel_sg550, "Snipe - Sig 550" );
// index 25		
		fboAddWeapon( ctxWeapon_m249,		  cinTeam_Any, RANK_M, BUY_Y, DEFAULT_N, ARM_MAIN , WALL_Y, 0.01, ZOOM_N, 5.00, 10.50, 5, 1, 5, 1, "m249", 5750, ctxModel_m249, "Machinegun - Para" );

		fboAddWeapon( ctxWeapon_flashbang,	  cinTeam_Any, 0, BUY_Y, DEFAULT_N, ARM_NADE, WALL_N, 5.00, ZOOM_N, 5.00, 8.00, 	8, 3, 8, 3, "flash",   200, ctxModel_flashbang, "Grenade - Flash" );
		fboAddWeapon( ctxWeapon_hegrenade,	  cinTeam_Any, 0, BUY_Y, DEFAULT_N, ARM_NADE, WALL_Y, 5.00, ZOOM_N, 5.00, 8.00, 	8, 4, 8, 4, "hegren",  300, ctxModel_hegrenade, "Grenade - Explosive" );
		fboAddWeapon( ctxWeapon_smokegrenade, cinTeam_Any, 0, BUY_Y, DEFAULT_N, ARM_NADE, WALL_N, 5.00, ZOOM_N, 5.00, 8.00, 	8, 5, 8, 5, "Sgren",   300, ctxModel_smokegrenade, "Grenade - Smoke" );
		fboAddWeapon( ctxWeapon_shield,		  cinTeam_CT,  0, BUY_Y, DEFAULT_N, ARM_OTHER,WALL_N, 0.00, ZOOM_N, 1.00, 5.50,  0, 0, 8, 8, "shield", 2200, ctxModel_shield, "Shield" );

#else

//fail def_CS16 not defined		

  //  =======================================================================================================================================================================================
		fboAddWeapon( ctxWeapon_knife,	  cinTeam_Any, RANK_L, BUY_N, DEFAULT_Y, ARM_KNIFE, WALL_N, 0.00, ZOOM_N, 0.10, 0.25, 0, 0, 0, 0, "*n/a*",   0, ctxModel_knife, "Knife" );
		fboAddWeapon( ctxWeapon_c4,		  cinTeam_Any, RANK_L, BUY_N, DEFAULT_Y, ARM_BOMB , WALL_N, 0.00, ZOOM_N, 0.00, 0.00, 0, 0, 0, 0, "*n/a*",   0, ctxModel_c4, "Bomb - C4 Explosive" );
// index 2
		fboAddWeapon( ctxWeapon_glock18,	  cinTeam_Any, RANK_M, BUY_Y, DEFAULT_Y, ARM_SIDE , WALL_N, 0.00, ZOOM_N, 0.15, 0.25, 1, 1, 1, 1, "glock",	400, ctxModel_glock, "Pistol - Glock 18" );
		fboAddWeapon( ctxWeapon_usp,		  cinTeam_Any, RANK_M, BUY_Y, DEFAULT_Y, ARM_SIDE , WALL_N, 0.00, ZOOM_N, 0.15, 0.25, 1, 2, 1, 2, "usp",		500, ctxModel_usp, "Pistol - USP .45" );
		fboAddWeapon( ctxWeapon_deagle,	  cinTeam_Any, RANK_H, BUY_Y, DEFAULT_N, ARM_SIDE , WALL_Y, 0.00, ZOOM_N, 0.25, 0.50, 1, 3, 1, 3, "deagle", 650, ctxModel_deagle, "Pistol - Desert eagle" );
		fboAddWeapon( ctxWeapon_p228,		  cinTeam_Any, RANK_H, BUY_Y, DEFAULT_N, ARM_SIDE , WALL_N, 0.00, ZOOM_N, 0.15, 0.25, 1, 4, 1, 4, "p228",   600, ctxModel_p228, "Pistol - SIG P228" );
		fboAddWeapon( ctxWeapon_elite,	  cinTeam_TE,  RANK_M, BUY_Y, DEFAULT_N, ARM_SIDE , WALL_N, 0.00, ZOOM_N, 0.15, 0.25, 1, 5, 0, 0, "elites",1000, ctxModel_elite, "Pistol - Dual Berettas" );
		fboAddWeapon( ctxWeapon_fiveseven, cinTeam_CT,	RANK_H, BUY_Y, DEFAULT_N, ARM_SIDE , WALL_N, 0.00, ZOOM_N, 0.15, 0.25, 0, 0, 1, 6, "fn57",   750, ctxModel_fiveseven, "Pistol - FiveSeven" );
// index 8				
		fboAddWeapon( ctxWeapon_m3,		  cinTeam_Any, RANK_L, BUY_Y, DEFAULT_N, ARM_MAIN , WALL_N, 0.00, ZOOM_N, 0.15, 0.25, 2, 1, 2, 1, "m3",	  1700, ctxModel_m3, "Shotgun pump - M3 super shotgun" );
		fboAddWeapon( ctxWeapon_xm1014,	  cinTeam_Any, RANK_L, BUY_Y, DEFAULT_N, ARM_MAIN , WALL_N, 0.00, ZOOM_N, 0.15, 0.25, 2, 2, 2, 2, "xm1014",3000, ctxModel_xm1014, "Shotgun auto - Benneli xm1014" );
//index 10		

		fboAddWeapon( ctxWeapon_mp5navy,	  cinTeam_Any, RANK_M, BUY_Y, DEFAULT_N, ARM_MAIN , WALL_N, 0.00, ZOOM_N, 0.25, 0.50, 3, 1, 3, 1, "mp5",   1500, ctxModel_mp5, "Sub - MP5 Navy" );
		fboAddWeapon( ctxWeapon_tmp,		  cinTeam_CT,	RANK_L, BUY_Y, DEFAULT_N, ARM_MAIN , WALL_N, 0.00, ZOOM_N, 0.25, 0.50, 0, 0, 3, 2, "tmp",	  1250, ctxModel_tmp, "Sub - Tactical Machine Pistol" );
		fboAddWeapon( ctxWeapon_p90,		  cinTeam_Any, RANK_M, BUY_Y, DEFAULT_N, ARM_MAIN , WALL_N, 0.00, ZOOM_N, 0.25, 0.50, 3, 3, 3, 3, "p90",   2350, ctxModel_p90, "Sub - P90" );
		fboAddWeapon( ctxWeapon_mac10,	  cinTeam_TE,  RANK_L, BUY_Y, DEFAULT_N, ARM_MAIN , WALL_N, 0.00, ZOOM_N, 0.25, 0.50, 3, 4, 0, 0, "mac10", 1400, ctxModel_mac10, "Sub - MAC-10" );
		fboAddWeapon( ctxWeapon_ump45,	  cinTeam_Any, RANK_L, BUY_Y, DEFAULT_N, ARM_MAIN , WALL_N, 0.00, ZOOM_N, 0.25, 0.50, 3, 5, 3, 5, "ump45", 1700, ctxModel_ump45, "Sub - Universal Machine Pistol" );

// index 15
		fboAddWeapon( ctxWeapon_ak47,		  cinTeam_TE,  RANK_H, BUY_Y, DEFAULT_N, ARM_MAIN , WALL_Y, 0.00, ZOOM_N, 1.00, 5.50, 4, 1, 0, 0, "ak47",  2500, ctxModel_ak47, "Rifle - AK 47" );
		fboAddWeapon( ctxWeapon_m4a1,		  cinTeam_CT,  RANK_H, BUY_Y, DEFAULT_N, ARM_MAIN , WALL_Y, 0.00, ZOOM_N, 1.00, 5.50, 0, 0, 4, 3, "m4a1",  3100, ctxModel_m4a1, "Rifle - Colt M4A1 Carbine" );
		fboAddWeapon( ctxWeapon_sg552,	  cinTeam_TE,  RANK_H, BUY_Y, DEFAULT_N, ARM_MAIN , WALL_Y, 0.20, ZOOM_Z, 1.00, 5.50, 4, 2, 0, 0, "sg552", 3500, ctxModel_sg552, "Rifle - Commando" );
		fboAddWeapon( ctxWeapon_aug,		  cinTeam_CT,  RANK_H, BUY_Y, DEFAULT_N, ARM_MAIN , WALL_Y, 0.20, ZOOM_Z, 1.00, 5.50, 0, 0, 4, 4, "aug",   3500, ctxModel_aug, "Rifle - Steyr Aug" );
//index 21
		fboAddWeapon( ctxWeapon_scout,	  cinTeam_Any, RANK_M, BUY_Y, DEFAULT_N, ARM_MAIN , WALL_Y, 1.85, ZOOM_S, 1.00, 2.50, 4, 5, 4, 5, "scout", 2750, ctxModel_scout, "Snipe - Scout" );
		fboAddWeapon( ctxWeapon_awp,		  cinTeam_Any, RANK_H, BUY_Y, DEFAULT_N, ARM_MAIN , WALL_Y, 1.85, ZOOM_S, 1.00, 2.50, 4, 6, 4, 6, "awp",   4750, ctxModel_awp, "Snipe - Artic" );
		fboAddWeapon( ctxWeapon_g3sg1,	  cinTeam_TE,  RANK_M, BUY_Y, DEFAULT_N, ARM_MAIN , WALL_Y, 0.30, ZOOM_S, 1.00, 2.50, 4, 7, 0, 0, "g3sg1", 5000, ctxModel_g3sg1, "Snipe - H&K Sniper Rifle" );
		fboAddWeapon( ctxWeapon_sg550,	  cinTeam_CT,  RANK_M, BUY_Y, DEFAULT_N, ARM_MAIN , WALL_Y, 0.30, ZOOM_S, 1.00, 2.50, 0, 0, 4, 8, "sg550", 4200, ctxModel_sg550, "Snipe - Sig 550" );
// index 25		
		fboAddWeapon( ctxWeapon_m249,		  cinTeam_Any, RANK_M, BUY_Y, DEFAULT_N, ARM_MAIN , WALL_Y, 0.01, ZOOM_N, 5.00, 10.50, 5, 1, 5, 1, "m249", 5750, ctxModel_m249, "Machinegun - Para" );

		fboAddWeapon( ctxWeapon_flashbang,	  cinTeam_Any, 0, BUY_Y, DEFAULT_N, ARM_NADE, WALL_N, 5.00, ZOOM_N, 5.00, 8.00, 	8, 3, 8, 3, "flash",   200, ctxModel_flashbang, "Grenade - Flash" );
		fboAddWeapon( ctxWeapon_hegrenade,	  cinTeam_Any, 0, BUY_Y, DEFAULT_N, ARM_NADE, WALL_Y, 5.00, ZOOM_N, 5.00, 8.00, 	8, 4, 8, 4, "hegren",  300, ctxModel_hegrenade, "Grenade - Explosive" );
		fboAddWeapon( ctxWeapon_smokegrenade, cinTeam_Any, 0, BUY_Y, DEFAULT_N, ARM_NADE, WALL_N, 5.00, ZOOM_N, 5.00, 8.00, 	8, 5, 8, 5, "Sgren",   300, ctxModel_smokegrenade, "Grenade - Smoke" );

#endif

		vinWeaponMode = cinWeaponMode_RegularWar;
		vtxWeaponModeDisplay = "";
		vinLineSpriteTexture = 0;
		
		vinGlobalBanBitFlag = cinBan_Off;

		vflDamageReduction = cflMinDamageReduction; // 0 is OFF;
		fvoSetUseRank( true );
	} // tclWeapon::tclWeapon

	void tclWeapon::fvoPrecacheSprites( )
	{
		vinLineSpriteTexture = finPrecacheModel( "sprites/lgtning.spr" );
	} // tclWeapon::fvoPrecacheSprites

	int tclWeapon::finFindWeapon( string vtxEntityName )
	{
		if ( vinNumWeapons <= 0 )
			return -1;

		if ( vinNumWeapons > cinMaxWeapons ) 
			return -1;
		
		for ( int vin = 0; vin < vinNumWeapons; vin++ )
		{
			if ( vstWeaponList[ vin ].vtxEntityName == vtxEntityName )
				return vin;
		}

		return -1;

	} // tclWeapon::finFindWeapon

	int tclWeapon::finFindWeaponByBuyCmd( string ptxBuyCommand )
	{
		if ( vinNumWeapons <= 0 )
			return -1;

		if ( vinNumWeapons > cinMaxWeapons ) 
			return -1;
		
		for ( int vin = 0; vin < vinNumWeapons; vin++ )
		{
			if ( vstWeaponList[ vin ].vtxBuyCommand == ptxBuyCommand )
				return vin;
		}

		return -1;

	} // tclWeapon::finFindWeaponByBuyCmd

	int tclWeapon::finFindWeaponByModel( string ptxModel )
	{

		#ifdef defDebug_WeaponFind
		fvoDebugBot_WeaponFind( NULL, "(tclWeapon::finFindWeaponByModel) Searching for weapon:");
		fvoDebugBot_WeaponFind( NULL, "(tclWeapon::finFindWeaponByModel) weapon full    = " + ptxModel );
		#endif

		if ( vinNumWeapons <= 0 )
			return -1;

		if ( vinNumWeapons > cinMaxWeapons ) 
		{
			// this is an error condition;
			vclDebugTrace.fvoWriteEventInfo( "ERROR (tclWeapon::finFindWeaponByModel) Index is out of range or corrupt:" );
			vclDebugTrace.fvoWriteEventInfo( "ERROR (tclWeapon::finFindWeaponByModel) vinNumWeapons = " + ftxIntToString( vinNumWeapons ) );
			vclDebugTrace.fvoWriteEventInfo( "ERROR (tclWeapon::finFindWeaponByModel) cinMaxWeapons = " + ftxIntToString( cinMaxWeapons ) );
			return -1;
		}

		// speed up search by always removing any path information that
		// may be present;
		ptxModel = ftxWeaponRemovePath( ptxModel );
		#ifdef defDebug_WeaponFind
		fvoDebugBot_WeaponFind( NULL, "(tclWeapon::finFindWeaponByModel) weapon compact = " + ptxModel );		
		#endif
		
		ptxModel = ftxConvertShieldModel( ptxModel );
		#ifdef defDebug_WeaponFind
		fvoDebugBot_WeaponFind( NULL, "(tclWeapon::finFindWeaponByModel) weapon shield convert = " + ptxModel );		
		#endif

		for ( int vin = 0; vin < vinNumWeapons; vin++ )
		{
			if ( vstWeaponList[ vin ].vtxModel == ptxModel )
			{
				#ifdef defDebug_WeaponFind
				fvoDebugBot_WeaponFind( NULL, "(tclWeapon::finFindWeaponByModel) Found weapon:");
				fvoDebugBot_WeaponFind( NULL, "(tclWeapon::finFindWeaponByModel) weapon = " + ptxModel );
				fvoDebugBot_WeaponFind( NULL, "(tclWeapon::finFindWeaponByModel) index  = " + ftxIntToString( vin ) );
				#endif
				return vin;
			}
		}
		#ifdef defDebug_WeaponFind
		fvoDebugBot_WeaponFind( NULL, "(tclWeapon::finFindWeaponByModel) Weapon was not found:");
		fvoDebugBot_WeaponFind( NULL, "(tclWeapon::finFindWeaponByModel) weapon     = " + ptxModel );
		fvoDebugBot_WeaponFind( NULL, "(tclWeapon::finFindWeaponByModel) Last index = " + ftxIntToString( vinNumWeapons ) );
		#endif
		return -1;

	} // tclWeapon::finFindWeaponByModel

	int  tclWeapon::finFindWeaponById( int pinWeaponId )
	{

		if ( vinNumWeapons <= 0 )
			return -1;

		if ( vinNumWeapons > cinMaxWeapons ) 
			return -1;
		
		for ( int vin = 0; vin < vinNumWeapons; vin++ )
		{

			if ( vstWeaponList[ vin ].vinWeaponId == pinWeaponId )
			{
				return vin;
			}
		}

		return -1;
	} // tclWeapon::finFindWeaponById

	int  tclWeapon::finFindWeaponBySlot( int pinTeam, int pinBuyOption, int pinBuySlot )
	{
		if ( vinNumWeapons <= 0 )
			return -1;

		if ( vinNumWeapons > cinMaxWeapons ) 
			return -1;
		
		if ( ( pinBuyOption == 0 ) || ( pinBuySlot == 0 ) )
			return -1;

		for ( int vin = 0; vin < vinNumWeapons; vin++ )
		{
			if ( ( vstWeaponList[ vin ].finBuyOption( pinTeam ) == pinBuyOption )
						&& 
				  ( vstWeaponList[ vin ].finBuySlot( pinTeam ) == pinBuySlot )
				)
				return vin;
		}

		return -1;
	} // tclWeapon::finFindWeaponBySlot

	bool tclWeapon::fboAddWeapon(
		string	ptxEntityName, 
		int		pinTeam,
		int		pinRank,
		bool		pboCanBuy,
		bool		pboDefault,
		int		pinArmType,
		bool		pboCanShootThroughWalls,
		float 	pflRescopeDelay,
		int		pinZoomType,
		float		pflMinTrackTime,
		float		pflMaxTrackTime,
		int		pinBuyOption_TE,	
		int		pinBuySlot_TE,
		int		pinBuyOption_CT,	
		int		pinBuySlot_CT,
		string   ptxBuyCommand,
		int		pinPrice,
		string	ptxModel,
		string	ptxWeaponDesc )
	{
		if ( finFindWeapon( ptxEntityName ) > 0 )
			return false;

		if ( vinNumWeapons < 0 )
			return false;

		if ( vinNumWeapons >= cinMaxWeapons ) 
			return false;

		vstWeaponList[vinNumWeapons].vtxEntityName	= ptxEntityName;
		vstWeaponList[vinNumWeapons].vinTeam			= pinTeam;
		vstWeaponList[vinNumWeapons].vinRank			= pinRank;
		vstWeaponList[vinNumWeapons].vboCanBuy			= pboCanBuy;
		vstWeaponList[vinNumWeapons].vboDefault		= pboDefault;
		vstWeaponList[vinNumWeapons].vinArmType		= pinArmType;
		vstWeaponList[vinNumWeapons].vboCanShootThroughWalls = pboCanShootThroughWalls;
		vstWeaponList[vinNumWeapons].vflRescopeDelay = pflRescopeDelay;
		vstWeaponList[vinNumWeapons].vinZoomType		= pinZoomType;
		vstWeaponList[vinNumWeapons].vflMinTrackTime = pflMinTrackTime;
		vstWeaponList[vinNumWeapons].vflMaxTrackTime = pflMaxTrackTime;
		vstWeaponList[vinNumWeapons].vtxWeaponDesc	= ptxWeaponDesc;
		vstWeaponList[vinNumWeapons].vtxModelFull		= ctxModel_prefix + ptxModel + ctxModel_suffix;
		vstWeaponList[vinNumWeapons].vtxModel			= ptxModel;

		vstWeaponList[vinNumWeapons].vinBanBitFlag		= cinBan_Off;
		vstWeaponList[vinNumWeapons].vboWeaponIsBanned  = false;

		vstWeaponList[vinNumWeapons].vinBuyOption_TE	= pinBuyOption_TE;
		vstWeaponList[vinNumWeapons].vinBuySlot_TE	= pinBuySlot_TE;
		vstWeaponList[vinNumWeapons].vinBuyOption_CT	= pinBuyOption_CT;
		vstWeaponList[vinNumWeapons].vinBuySlot_CT	= pinBuySlot_CT;
		vstWeaponList[vinNumWeapons].vtxBuyCommand	= ptxBuyCommand;
		vstWeaponList[vinNumWeapons].vinPrice			= pinPrice;
		vinNumWeapons++;

		return true;
	} // tclWeapon::fboAddWeapon

	string tclWeapon::ftxGetWeaponNameById( int pinWeaponId )
	{
		int vinWeaponIndex = finFindWeaponById( pinWeaponId );

		if ( vinWeaponIndex < 0 || vinWeaponIndex >= vinNumWeapons )
			return "?";

		return vstWeaponList[ vinWeaponIndex ].vtxEntityName;

	} // tclWeapon::ftxGetWeaponNameById

	string tclWeapon::ftxGetWeaponDescById( int pinWeaponId )
	{
		int vinWeaponIndex = finFindWeaponById( pinWeaponId );

		if ( vinWeaponIndex < 0 || vinWeaponIndex >= vinNumWeapons )
			return "?";

		return vstWeaponList[ vinWeaponIndex ].vtxWeaponDesc;

	} // tclWeapon::ftxGetWeaponDescById

	string tclWeapon::ftxGetWeaponDescByIndex( int pinWeaponIndex )
	{
		if ( pinWeaponIndex < 0 || pinWeaponIndex >= vinNumWeapons )
			return "?";

		return vstWeaponList[ pinWeaponIndex ].vtxWeaponDesc;

	} // tclWeapon::ftxGetWeaponDescByIndex

	bool tclWeapon::fboInitWeapon
	(  string	ptxEntityName, 
		int		pinPrimaryAmmoType, 
		int		pinPrimaryAmmoClip,
		int		pinSecondaryAmmoType, 
		int		pinSecondaryAmmoClip, 
		int		pinHUDSlot,
		int		pinSlotPos,
		int		pinWeaponId,
		int		pinFlags)
	{

//		vclDebugTrace.fvoWriteEventInfo( "" );
//		vclDebugTrace.fvoWriteEventInfo( "ptxEntityName        : " + ptxEntityName );
//		vclDebugTrace.fvoWriteEventInfo( "pinPrimaryAmmoType   : " + ftxIntToString( pinPrimaryAmmoType ) );
//		vclDebugTrace.fvoWriteEventInfo( "pinPrimaryAmmoClip   : " + ftxIntToString( pinPrimaryAmmoClip ) );
//		vclDebugTrace.fvoWriteEventInfo( "pinSecondaryAmmoType : " + ftxIntToString( pinSecondaryAmmoType ) );
//		vclDebugTrace.fvoWriteEventInfo( "pinSecondaryAmmoClip : " + ftxIntToString( pinSecondaryAmmoClip ) );
//		vclDebugTrace.fvoWriteEventInfo( "pinHUDSlot           : " + ftxIntToString( pinHUDSlot ) );
//		vclDebugTrace.fvoWriteEventInfo( "pinSlotPos           : " + ftxIntToString( pinSlotPos ) );
//		vclDebugTrace.fvoWriteEventInfo( "pinWeaponId          : " + ftxIntToString( pinWeaponId ) );
//		vclDebugTrace.fvoWriteEventInfo( "pinFlags             : " + ftxIntToString( pinFlags ) );

		int vinWeaponIndex = finFindWeapon( ptxEntityName );

//		vclDebugTrace.fvoWriteEventInfo( "vinWeaponIndex       : " + ftxIntToString( vinWeaponIndex ) );

		if ( vinWeaponIndex < 0 || vinWeaponIndex >= vinNumWeapons )
		{
			vclDebugTrace.fvoWriteEventInfo( 
				"DEBUG (tclWeapon::fboInitWeapon) Weapon index out of range: " 
				+ ftxIntToString( vinWeaponIndex ) );
			return false;
		}
		if ( vstWeaponList[ vinWeaponIndex ].vboInitialized )
		{
			return true;
		}

		vstWeaponList[ vinWeaponIndex ].vboInitialized			= true;
		vstWeaponList[ vinWeaponIndex ].vboAvailable				= true;
		vstWeaponList[ vinWeaponIndex ].vinPrimaryAmmoType		= pinPrimaryAmmoType;
		vstWeaponList[ vinWeaponIndex ].vinPrimaryAmmoClip		= pinPrimaryAmmoClip;
		vstWeaponList[ vinWeaponIndex ].vinSecondaryAmmoType	= pinSecondaryAmmoType;
		vstWeaponList[ vinWeaponIndex ].vinSecondaryAmmoClip	= pinSecondaryAmmoClip;
		vstWeaponList[ vinWeaponIndex ].vinHUDSlot				= pinHUDSlot;
		vstWeaponList[ vinWeaponIndex ].vinSlotPos				= pinSlotPos;
		vstWeaponList[ vinWeaponIndex ].vinWeaponId				= pinWeaponId;
		vstWeaponList[ vinWeaponIndex ].vinFlags					= pinFlags;


		return true;

	} // tclWeapon::fboInitWeapon

	int tclWeapon::finGetRandomArm( 
		int pinTeam, int pinArmType, int pinWeaponInHand, int& pinMoney )
	{

		// First do some checking;

		if ( pinWeaponInHand >= vinNumWeapons )
		{
			// this is an error condition;
			vclDebugTrace.fvoWriteEventInfo( "ERROR (tclWeapon::finGetRandomArm) Weapon in hand index out of range: " + ftxIntToString( pinWeaponInHand ) );
			return -1;
		}

		// make sure we don't bother looking for a better weapon than is possible;

		if ( pinWeaponInHand > -1 )
		{
			#ifdef defDebug_WeaponBuy
			fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm) Weapon in hand = " + vstWeaponList[ pinWeaponInHand ].vtxModel );
			fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm)          Price = " + ftxIntToString( vstWeaponList[ pinWeaponInHand ].vinPrice ) );
			fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm)           Rank = " + ftxIntToString( vstWeaponList[ pinWeaponInHand ].vinRank ) );
			#endif // defDebug_WeaponBuy

			if ( ( vstWeaponList[ pinWeaponInHand ].vinArmType == pinArmType ) 
				       &&
				  ( vstWeaponList[ pinWeaponInHand ].vinRank >= RANK_H )	
				)
			{				
				#ifdef defDebug_WeaponBuy
				fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm) Weapon in hand is of highest rank - weapon will be kept." );
				#endif // defDebug_WeaponBuy

				// weapon in hand is already the best money can buy;
				return -1;
			}
		}

		int vinBestRank; 

		if ( fboUseRank( ) )
		{
			vinBestRank = RANK_H; // set to "high" rank to start with;
		}
		else
		{
			vinBestRank = RANK_N; // set to "low" rank to start with;
		}
		
		int vinBestWeaponIdx = -1;

		// Loop through whole list and build a list of the highest ranking 
		// affordable weapons;

		// list of worthy weapons for random selection;
		int vinCount = 0;
		char varyWeapons[ cinMaxWeapons ]; 

		int vinPos;

		locLoop:

		#ifdef defDebug_WeaponBuy
		fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm) Searcing for rank >= " + ftxIntToString( vinBestRank ) );
		#endif // defDebug_WeaponBuy

		for ( vinPos = 0; vinPos < vinNumWeapons; vinPos++ )
		{
			if ( !vstWeaponList[ vinPos ].vboAvailable )
			{
				#ifdef defDebug_WeaponBuy
				fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm) Weapon Skipped - weapon is not available." );
				fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm) Weapon = " + vstWeaponList[ vinPos ].vtxModel );
				fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm)  Price = " + ftxIntToString( vstWeaponList[ vinPos ].vinPrice ) );
				fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm)   Rank = " + ftxIntToString( vstWeaponList[ vinPos ].vinRank ) );
				fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm)    Pos = " + ftxIntToString( vinPos ) );
				#endif // defDebug_WeaponBuy
				goto locNext;
			}

			if ( !vstWeaponList[ vinPos ].vboCanBuy )
			{
				#ifdef defDebug_WeaponBuy
				fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm) Weapon Skipped - weapon cannot be bought." );
				fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm) Weapon = " + vstWeaponList[ vinPos ].vtxModel );
				fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm)  Price = " + ftxIntToString( vstWeaponList[ vinPos ].vinPrice ) );
				fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm)   Rank = " + ftxIntToString( vstWeaponList[ vinPos ].vinRank ) );
				fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm)    Pos = " + ftxIntToString( vinPos ) );
				#endif // defDebug_WeaponBuy
				goto locNext;
			}

			if ( vstWeaponList[ vinPos ].fboEntityBanned( ) )
			{
				#ifdef defDebug_WeaponBuy
				fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm) Weapon Skipped - weapon is banned." );
				fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm) Weapon = " + vstWeaponList[ vinPos ].vtxModel );
				fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm)  Price = " + ftxIntToString( vstWeaponList[ vinPos ].vinPrice ) );
				fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm)   Rank = " + ftxIntToString( vstWeaponList[ vinPos ].vinRank ) );
				fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm)    Pos = " + ftxIntToString( vinPos ) );
				#endif // defDebug_WeaponBuy
				goto locNext;
			}

			if ( vstWeaponList[ vinPos ].vinArmType != pinArmType )
			{
				#ifdef defDebug_WeaponBuy
				fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm) Weapon Skipped - weapon is not of ArmType: " + ftxIntToString( pinArmType ) );
				fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm) Weapon = " + vstWeaponList[ vinPos ].vtxModel );
				fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm) ArmType= " + ftxIntToString( vstWeaponList[ vinPos ].vinArmType ) );
				fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm)  Price = " + ftxIntToString( vstWeaponList[ vinPos ].vinPrice ) );
				fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm)   Rank = " + ftxIntToString( vstWeaponList[ vinPos ].vinRank ) );
				fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm)    Pos = " + ftxIntToString( vinPos ) );
				#endif // defDebug_WeaponBuy
				goto locNext;
			}
			if ( vstWeaponList[ vinPos ].vinTeam != cinTeam_Any )
			{
				if ( vstWeaponList[ vinPos ].vinTeam != pinTeam )
				{
					#ifdef defDebug_WeaponBuy
					fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm) Weapon Skipped - weapon cannot be bought by members of team: " + vclPlayer.ftxIntToTeamStr( pinTeam ) );
					fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm) Weapon = " + vstWeaponList[ vinPos ].vtxModel );
					fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm)   Team = " + vclPlayer.ftxIntToTeamStr( vstWeaponList[ vinPos ].vinTeam ) );
					fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm)  Price = " + ftxIntToString( vstWeaponList[ vinPos ].vinPrice ) );
					fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm)   Rank = " + ftxIntToString( vstWeaponList[ vinPos ].vinRank ) );
					fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm)    Pos = " + ftxIntToString( vinPos ) );
					#endif // defDebug_WeaponBuy

					goto locNext;
				}
			}

			if ( pinWeaponInHand > -1 )
			{
				if ( vinPos == pinWeaponInHand )
				{
					// do not buy a weapon that is already in hand;
					#ifdef defDebug_WeaponBuy
					fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm) Weapon Skipped - weapon is same as weapon in hand." );
					fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm) Weapon = " + vstWeaponList[ vinPos ].vtxModel );
					fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm)  Price = " + ftxIntToString( vstWeaponList[ vinPos ].vinPrice ) );
					fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm)   Rank = " + ftxIntToString( vstWeaponList[ vinPos ].vinRank ) );
					fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm)    Pos = " + ftxIntToString( vinPos ) );
					#endif // defDebug_WeaponBuy
					goto locNext;
				}

				if ( ( vstWeaponList[ pinWeaponInHand ].vinArmType == pinArmType ) && ( vinBestRank != RANK_N ) )
				{
					if ( vstWeaponList[ vinPos ].vinRank <= vstWeaponList[ pinWeaponInHand ].vinRank )
					{
						// do not buy a weapon that is of the same or lower rank as what we already have;
						#ifdef defDebug_WeaponBuy
						fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm) Weapon Skipped - rank same as or lower than weapon in hand." );
						fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm) Weapon = " + vstWeaponList[ vinPos ].vtxModel );
						fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm)  Price = " + ftxIntToString( vstWeaponList[ vinPos ].vinPrice ) );
						fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm)   Rank = " + ftxIntToString( vstWeaponList[ vinPos ].vinRank ) );
						fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm)    Pos = " + ftxIntToString( vinPos ) );
						#endif // defDebug_WeaponBuy
						goto locNext;
					}
				}
			}

			if ( vstWeaponList[ vinPos ].vinRank < vinBestRank )
			{
				// try and buy the best weapon we can;
				#ifdef defDebug_WeaponBuy
				fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm) Weapon Skipped - rank too low." );
				fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm) Weapon = " + vstWeaponList[ vinPos ].vtxModel );
				fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm)  Price = " + ftxIntToString( vstWeaponList[ vinPos ].vinPrice ) );
				fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm)   Rank = " + ftxIntToString( vstWeaponList[ vinPos ].vinRank ) );
				fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm)    Pos = " + ftxIntToString( vinPos ) );
				#endif // defDebug_WeaponBuy
				goto locNext;
			}

			if ( vstWeaponList[ vinPos ].vinPrice + 1500 > pinMoney )
			{
				// extra $1000 is to leave room for ammo + armor after purchase;
				// cannot buy a weapon that costs too much money;
				#ifdef defDebug_WeaponBuy
				fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm) Weapon Skipped - too expensive." );
				fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm) Weapon = " + vstWeaponList[ vinPos ].vtxModel );
				fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm)  Price = " + ftxIntToString( vstWeaponList[ vinPos ].vinPrice ) );
				fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm)   Rank = " + ftxIntToString( vstWeaponList[ vinPos ].vinRank ) );
				fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm)    Pos = " + ftxIntToString( vinPos ) );
				#endif // defDebug_WeaponBuy

				goto locNext;
			}
			varyWeapons[ vinCount ] = vinPos;
			vinCount++;

			#ifdef defDebug_WeaponBuy
			fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm) Weapon Found = " + vstWeaponList[ vinPos ].vtxModel );
			fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm)        Price = " + ftxIntToString( vstWeaponList[ vinPos ].vinPrice ) );
			fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm)         Rank = " + ftxIntToString( vstWeaponList[ vinPos ].vinRank ) );
			fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm)        Count = " + ftxIntToString( vinCount ) );
			#endif // defDebug_WeaponBuy
			
			locNext:
			{
				// do nothing - goto next weapon pos;
			}
		}

		if ( vinCount > 0 )
		{
			vinBestWeaponIdx = varyWeapons[ rand( ) % vinCount ];
		}
		else
		{
			// No weapons could be bought at the currently specified rank;
			// Lower the specified rank and try again;
			vinBestRank--;
			vinCount = 0;
			if ( vinBestRank > RANK_N )
			{
				goto locLoop;
			}
		}

//		vclDebugTrace.fvoWriteEventInfo( "Weapon Buy failed: TEAM = " + ftxIntToString( pinTeam ) + " ARM = " + ftxIntToString( pinArmType ) + "  IN HAND = " + ftxIntToString( pinWeaponInHand ) );
		if ( vinBestWeaponIdx > -1 )
		{
//			pinMoney -= vstWeaponList[ vinBestWeaponIdx ].vinPrice;

			#ifdef defDebug_WeaponBuy
			fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm) Bought weapon " + vstWeaponList[ vinBestWeaponIdx ].vtxModel );
			fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm) Weapon Price   = " + ftxIntToString( vstWeaponList[ vinBestWeaponIdx ].vinPrice ) );
			fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm) Remaining cash = " + ftxIntToString( pinMoney ) );
			#endif // defDebug_WeaponBuy
		}
		else
		{
			#ifdef defDebug_WeaponBuy
			fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm) Did not buy a weapon. Index = " + ftxIntToString( vinBestWeaponIdx ) );
			fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm) Remaining cash = " + ftxIntToString( pinMoney ) );
			#endif // defDebug_WeaponBuy
		}

		return vinBestWeaponIdx;

	} // tclWeapon::finGetRandomArm

	int tclWeapon::finGetRandomArm_orig( 
		int pinTeam, int pinArmType, int pinWeaponInHand, int& pinMoney, bool pboUseRank )
	{
		int vinPos = rand( ) % vinNumWeapons;
		int vinCount = 0;

		int vinBestRank = RANK_N; // set to "null" rank to start off;
		int vinBestWeaponIdx = -1;

		// Loop through whole list and find the highest ranking affordable weapon;

		while ( vinCount < vinNumWeapons ) 
		{
			if ( !vstWeaponList[ vinPos ].vboAvailable )
				goto locNext;

			if ( vstWeaponList[ vinPos ].fboEntityBanned( ) )
				goto locNext;

			if ( vstWeaponList[ vinPos ].vinArmType != pinArmType )
				goto locNext;

			if ( vstWeaponList[ vinPos ].vinTeam != cinTeam_Any )
			{
				if ( vstWeaponList[ vinPos ].vinTeam != pinTeam )
					goto locNext;
			}

			if ( !vstWeaponList[ vinPos ].vboCanBuy )
				goto locNext;

			if ( pinWeaponInHand > -1 )
			{
				if ( vinPos == pinWeaponInHand )
				// do not buy a weapon that is already in hand;
					goto locNext;

				if ( vstWeaponList[ pinWeaponInHand ].vinArmType == pinArmType )
				{				
					if ( vstWeaponList[ vinPos ].vinRank <= vstWeaponList[ pinWeaponInHand ].vinRank )
					// do not buy a weapon that is of the same or lower rank as what we already have;
						goto locNext;
				}
			}

			if ( vstWeaponList[ vinPos ].vinRank <= vinBestRank )
			// try and buy the best weapon we can;
				goto locNext;

			if ( vstWeaponList[ vinPos ].vinPrice + 1500 > pinMoney ) 
			// extra $1000 is to leave room for ammo + armor after purchase;
			// cannot buy a weapon that costs too much money;
				goto locNext;

			vinBestWeaponIdx = vinPos;
			vinBestRank = vstWeaponList[ vinPos ].vinRank;

			// return vinPos;

			locNext:

			vinCount++;
			vinPos++;
			if ( vinPos >= vinNumWeapons )
				vinPos = 0;
		}

//		vclDebugTrace.fvoWriteEventInfo( "Weapon Buy failed: TEAM = " + ftxIntToString( pinTeam ) + " ARM = " + ftxIntToString( pinArmType ) + "  IN HAND = " + ftxIntToString( pinWeaponInHand ) );
		if ( vinBestWeaponIdx > -1 )
		{
			pinMoney -= vstWeaponList[ vinBestWeaponIdx ].vinPrice;

			#ifdef defDebug_WeaponBuy
			fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm) Bought weapon " + vstWeaponList[ vinBestWeaponIdx ].vtxModel );
			fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm) Weapon Price   = " + ftxIntToString( vstWeaponList[ vinBestWeaponIdx ].vinPrice ) );
			fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm) Remaining cash = " + ftxIntToString( pinMoney ) );
			#endif // defDebug_WeaponBuy
		}
		else
		{
			#ifdef defDebug_WeaponBuy
			fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm) Did not buy a weapon. Index = " + ftxIntToString( vinBestWeaponIdx ) );
			fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm) Remaining cash = " + ftxIntToString( pinMoney ) );
			#endif // defDebug_WeaponBuy
		}

		return vinBestWeaponIdx;

	} // tclWeapon::finGetRandomArm_orig

	void tclWeapon::fvoForceDropWeapon( edict_t* pst_ptrEdict, float pflDropTime )
	{
		fvoExecFakeClientCommandDELAYED( pflDropTime, pst_ptrEdict, "drop" );
	} // tclWeapon::fvoForceDropWeapon

	void fvoMA_Weapon_Event_fvoWeaponBuyAction( tclArgList& pclArgList )
	{
		int vinStep				= pclArgList.finGetArg_Int( 0 );
		int vinUserIndex		= pclArgList.finGetArg_Int( 1 );
		int vinUserId			= pclArgList.finGetArg_Int( 2 );
		int vinUserTeam		= pclArgList.finGetArg_Int( 3 );
		int vinSideArmInHand = pclArgList.finGetArg_Int( 4 );

		float vflDelay;
		
		edict_t* vst_ptrEdict = vclPlayer.fst_ptrGetPlayerByIndex( vinUserIndex );

		if ( vst_ptrEdict == NULL )
			return;

		if ( vinUserId != vclPlayer.finGetUserIdByEdict( vst_ptrEdict ) )
			return;

		int vinBotIdx = vinUserIndex - 1;
		
		if ( vinBotIdx < 0 )
		{
			// this is an error condition;
			vclDebugTrace.fvoWriteEventInfo( "ERROR (fvoMA_Weapon_Event_fvoWeaponBuyAction): Invalid Bot Index (" + ftxIntToString( vinBotIdx ) + ")" );
			return;
		}

		int vinMoney = vclBotControl.vstBotStatus[ vinBotIdx ].vinMoney;

		if ( vinStep == 1 ) 
		{
			// vclDebugTrace.fvoWriteEventInfo( "Weapon Buy - step 1" );

			string vtxWeaponModelInhand = vclGlobalGameInfo.ftxGetSring( vst_ptrEdict->v.weaponmodel );
			int vinWeaponInHand = vclWeapon.finFindWeaponByModel( vtxWeaponModelInhand );

			if ( vclWeapon.fboWeaponIsMainArm_ByIndex( vinWeaponInHand ) )
				goto locStep_3;

			if ( vclWeapon.fboWeaponIsSideArm_ByIndex( vinWeaponInHand ) )
				vinSideArmInHand = vinWeaponInHand;
			else
				vinSideArmInHand = -1; // we don't have a side arm;

			vflDelay = vclWeapon.fflForceWeaponBuy( 
				vst_ptrEdict, ARM_MAIN, vinUserTeam, vinWeaponInHand, vinMoney );

			if ( vclEventSched.fboCreateEvent( ) )
			{
				vclEventSched.fvoSetEventFunc( fvoMA_Weapon_Event_fvoWeaponBuyAction );
				vclEventSched.fboCreateArgList( 4 );
				vclEventSched.fvoSetArg_Int(    0,                2, "buy_weapon_step_2" );
				vclEventSched.fvoSetArg_Int(    1,     vinUserIndex, "user_index"        );
				vclEventSched.fvoSetArg_Int(    2,        vinUserId, "user_id"		       );
				vclEventSched.fvoSetArg_Int(    3,     vinUserTeam , "user_team"		    );
				vclEventSched.fvoSetArg_Int(    4, vinSideArmInHand, "side_arm_inhand"   );
				vclEventSched.fvoSetDelayInSecs( vflDelay + 0.01 );
				vclEventSched.fboSendEvent( );
			}

			locExitStep_1:	return;

		} // step - 1

		if ( vinStep == 2 ) 
		{
			// vclDebugTrace.fvoWriteEventInfo( "Weapon Buy - step 2" );

			if ( vinSideArmInHand == -1 )
			{
				vflDelay = vclWeapon.fflForceWeaponBuy( 
					vst_ptrEdict, ARM_SIDE, vinUserTeam, vinSideArmInHand, vinMoney );
				goto locStep_3;
			}

			if ( vclWeapon.fboWeaponIsDefaultByIndex( vinSideArmInHand, vinUserTeam ) )
			{
				if ( vinMoney > 3000 ) // we have enough cash to buy a better weapon;
				{
					vflDelay = vclWeapon.fflForceWeaponBuy( vst_ptrEdict, ARM_SIDE, 
						vinUserTeam, vinSideArmInHand, vinMoney );
				}
			}

			goto locStep_3;

		} // step - 2

		if ( vinStep == 3 ) 
		{
			// vclDebugTrace.fvoWriteEventInfo( "Weapon Buy - step 3" );

			vclWeapon.fflForceWeaponBuy( vst_ptrEdict, ARM_OTHER, vinUserTeam, -1, vinMoney );
			locExitStep_3:	return;

		} // step - 3

		vclDebugTrace.fvoWriteEventInfo( "Weapon Buy - unknown step!!!" );
		return;

		locStep_3:	
			if ( vclEventSched.fboCreateEvent( ) )
			{
				vclEventSched.fvoSetEventFunc( fvoMA_Weapon_Event_fvoWeaponBuyAction );
				vclEventSched.fboCreateArgList( 5 );
				vclEventSched.fvoSetArg_Int(    0,                3, "buy_weapon_step_3" );
				vclEventSched.fvoSetArg_Int(    1,     vinUserIndex, "user_index"        );
				vclEventSched.fvoSetArg_Int(    2,        vinUserId, "user_id"		       );
				vclEventSched.fvoSetArg_Int(    3,     vinUserTeam , "user_team"		    );
				vclEventSched.fvoSetArg_Int(    4, vinSideArmInHand, "side_arm_inhand"   );
				vclEventSched.fvoSetDelayInSecs( vflDelay + 0.01 );
				vclEventSched.fboSendEvent( );
			}
			return;

	} // fvoMA_Weapon_Event_fvoWeaponBuyAction

	void tclWeapon::fvoCheckWeapons( edict_t* pst_ptrEdict, int pinUserIndex  )
	{
		if ( pst_ptrEdict == NULL )
			return;

		int vinUserTeam = vclPlayer.finGetPlayerTeamByEdict( pst_ptrEdict );

		if ( vinUserTeam == cinTeam_Unknown )
			return;

		int vinUserId   = vclPlayer.finGetUserIdByEdict( pst_ptrEdict );

		if ( vinUserId < cinMinUserId )
			return;

		if ( vclEventSched.fboCreateEvent( ) )
		{
			vclEventSched.fvoSetEventFunc( fvoMA_Weapon_Event_fvoWeaponBuyAction );
			vclEventSched.fboCreateArgList( 5 );
			vclEventSched.fvoSetArg_Int(    0,            1, "buy_weapon_step_1" );
			vclEventSched.fvoSetArg_Int(    1, pinUserIndex, "user_index"        );
			vclEventSched.fvoSetArg_Int(    2,    vinUserId, "user_id"		      );
			vclEventSched.fvoSetArg_Int(    3,  vinUserTeam, "user_team"		   );
			vclEventSched.fvoSetArg_Int(    4,			   -1, "side_arm_inhand"   );
			vclEventSched.fvoSetDelayInSecs( fflCVarGetFloat( ctxCVar_BotBuyDelay ) );
			vclEventSched.fboSendEvent( );
		}

	} // tclWeapon::fvoCheckWeapons

	float tclWeapon::fflForceWeaponBuy( 
		edict_t* pst_ptrEdict, int pinArmType, int pinUserTeam, int pinWeaponInHand, int pinMoney )
	{
		if ( pst_ptrEdict == NULL )
			return 0;

		int vinTeam;

		if ( pinUserTeam == cinTeam_Unknown )
			vinTeam = vclPlayer.finGetPlayerTeamByEdict( pst_ptrEdict );
		else
			vinTeam = pinUserTeam;

		int vinIdx;

		float vflDelay = 0.10;
		float vflInc	= 0.01;

		string vtxWeaponModel;
		int vinWeaponInHand = pinWeaponInHand;

		if ( pinWeaponInHand == -1 )
		{
			vtxWeaponModel = vclGlobalGameInfo.ftxGetSring( pst_ptrEdict->v.weaponmodel );
			vinWeaponInHand = finFindWeaponByModel( vtxWeaponModel );
		}

		if ( pinArmType == ARM_MAIN )
			goto locBuyMainArm;

		if ( pinArmType == ARM_SIDE )
			goto locBuySideArm;

		if ( pinArmType == ARM_OTHER )
			goto locBuyEquip;

		if ( pinArmType != ARM_ALL )
			goto locExit;

		locBuyMainArm:

		if ( ( pinArmType != ARM_MAIN ) && ( pinArmType != ARM_ALL ) )
			goto locExit;
		
		vinIdx = finGetRandomArm( vinTeam, ARM_MAIN, vinWeaponInHand, pinMoney );

		if ( vinIdx < 0 )
			goto locBuySideArm;
		else
		{
			if ( ( pinMoney - vstWeaponList[ vinIdx ].vinPrice ) < 3000 ) 
			{
				#ifdef defDebug_WeaponBuy
				fvoDebugBot_WeaponBuy( pst_ptrEdict, "(tclWeapon::fflForceWeaponBuy) Too expensive" );
				fvoDebugBot_WeaponBuy( pst_ptrEdict, "(tclWeapon::fflForceWeaponBuy) Money Avail: " + ftxIntToString( pinMoney ) );
				fvoDebugBot_WeaponBuy( pst_ptrEdict, "(tclWeapon::fflForceWeaponBuy) Weapon Idx : " + ftxIntToString( vinIdx ) );
				fvoDebugBot_WeaponBuy( pst_ptrEdict, "(tclWeapon::fflForceWeaponBuy) Weapon     : " + vstWeaponList[ vinIdx ].vtxEntityName );
				fvoDebugBot_WeaponBuy( pst_ptrEdict, "(tclWeapon::fflForceWeaponBuy) Buy command: " + vstWeaponList[ vinIdx ].vtxBuyCommand );
				#endif // defDebug_WeaponBuy

				goto locBuySideArm;
			}
			pinMoney -= vstWeaponList[ vinIdx ].vinPrice;
		}

		// buy available main arm
		#ifdef def_CS16
		fvoExecFakeClientCommandDELAYED( vflDelay, pst_ptrEdict, vstWeaponList[ vinIdx ].vtxBuyCommand );
		#endif // def_CS16

		#ifdef def_CS15
		fvoExecFakeClientCommandDELAYED( vflDelay, pst_ptrEdict, "buy" );
		vflDelay += vflInc;
		fvoExecFakeClientCommandDELAYED( vflDelay, pst_ptrEdict, "menuselect", ftxIntToString( vstWeaponList[ vinIdx ].finBuyOption( vinTeam ) ) );
		vflDelay += vflInc;
		fvoExecFakeClientCommandDELAYED( vflDelay, pst_ptrEdict, "menuselect", ftxIntToString( vstWeaponList[ vinIdx ].finBuySlot( vinTeam ) ) );
		#endif // def_CS15

		#ifdef defDebug_WeaponBuy
		fvoDebugBot_WeaponBuy( pst_ptrEdict, "(tclWeapon::fflForceWeaponBuy) Bot Name   : " + vclPlayer.ftxGetPlayerNameByEdict( pst_ptrEdict ) );
		fvoDebugBot_WeaponBuy( pst_ptrEdict, "(tclWeapon::fflForceWeaponBuy) Weapon Idx : " + ftxIntToString( vinIdx ) );
		fvoDebugBot_WeaponBuy( pst_ptrEdict, "(tclWeapon::fflForceWeaponBuy) Weapon     : " + vstWeaponList[ vinIdx ].vtxEntityName );
		fvoDebugBot_WeaponBuy( pst_ptrEdict, "(tclWeapon::fflForceWeaponBuy) Buy command: " + vstWeaponList[ vinIdx ].vtxBuyCommand );
		fvoDebugBot_WeaponBuy( pst_ptrEdict, "(tclWeapon::fflForceWeaponBuy) Money Avail: " + ftxIntToString( pinMoney ) );
		// fvoExecFakeClientCommand( pst_ptrEdict, "say", vstWeaponList[ vinIdx ].vtxBuyCommand );
		#endif // defDebug_WeaponBuy

		vflDelay += vflInc;
		// buy ammo for main arm
		
		#ifdef def_CS16
		fvoExecFakeClientCommandDELAYED( vflDelay, pst_ptrEdict, "primammo" ); 
		#endif // def_CS16

		#ifdef def_CS15
		fvoExecFakeClientCommandDELAYED( vflDelay, pst_ptrEdict, "buy" );
		vflDelay += vflInc;
		fvoExecFakeClientCommandDELAYED( vflDelay, pst_ptrEdict, "menuselect", "6" ); 
		#endif // def_CS15

		vflDelay += vflInc;

		locBuySideArm:

		if ( ( pinArmType != ARM_SIDE ) && ( pinArmType != ARM_ALL ) )
			goto locExit;

		vinIdx = finGetRandomArm( vinTeam, ARM_SIDE, vinWeaponInHand, pinMoney );

		if ( vinIdx < 0 )
			goto locBuyEquip;
		else
		{
			if ( ( pinMoney - vstWeaponList[ vinIdx ].vinPrice ) < 3000 ) 
			{
				#ifdef defDebug_WeaponBuy
				fvoDebugBot_WeaponBuy( pst_ptrEdict, "(tclWeapon::fflForceWeaponBuy) Too expensive" );
				fvoDebugBot_WeaponBuy( pst_ptrEdict, "(tclWeapon::fflForceWeaponBuy) Money Avail: " + ftxIntToString( pinMoney ) );
				fvoDebugBot_WeaponBuy( pst_ptrEdict, "(tclWeapon::fflForceWeaponBuy) Weapon Idx : " + ftxIntToString( vinIdx ) );
				fvoDebugBot_WeaponBuy( pst_ptrEdict, "(tclWeapon::fflForceWeaponBuy) Weapon     : " + vstWeaponList[ vinIdx ].vtxEntityName );
				fvoDebugBot_WeaponBuy( pst_ptrEdict, "(tclWeapon::fflForceWeaponBuy) Buy command: " + vstWeaponList[ vinIdx ].vtxBuyCommand );
				#endif // defDebug_WeaponBuy
				goto locBuyEquip;
			}
			pinMoney -= vstWeaponList[ vinIdx ].vinPrice;
		}

		// buy available side arm
		#ifdef def_CS16
		fvoExecFakeClientCommandDELAYED( vflDelay, pst_ptrEdict, vstWeaponList[ vinIdx ].vtxBuyCommand );
		#endif // def_CS16

		#ifdef def_CS15
		fvoExecFakeClientCommandDELAYED( vflDelay, pst_ptrEdict, "buy" );
		vflDelay += vflInc;
		fvoExecFakeClientCommandDELAYED( vflDelay, pst_ptrEdict, "menuselect", ftxIntToString( vstWeaponList[ vinIdx ].finBuyOption( vinTeam ) ) );
		vflDelay += vflInc;
		fvoExecFakeClientCommandDELAYED( vflDelay, pst_ptrEdict, "menuselect", ftxIntToString( vstWeaponList[ vinIdx ].finBuySlot( vinTeam ) ) );
		#endif // def_CS15

		#ifdef defDebug_WeaponBuy
		fvoDebugBot_WeaponBuy( pst_ptrEdict, "(tclWeapon::fflForceWeaponBuy) Bot Name   : " + vclPlayer.ftxGetPlayerNameByEdict( pst_ptrEdict ) );
		fvoDebugBot_WeaponBuy( pst_ptrEdict, "(tclWeapon::fflForceWeaponBuy) Weapon Idx : " + ftxIntToString( vinIdx ) );
		fvoDebugBot_WeaponBuy( pst_ptrEdict, "(tclWeapon::fflForceWeaponBuy) Weapon     : " + vstWeaponList[ vinIdx ].vtxEntityName );
		fvoDebugBot_WeaponBuy( pst_ptrEdict, "(tclWeapon::fflForceWeaponBuy) Buy command: " + vstWeaponList[ vinIdx ].vtxBuyCommand );
		fvoDebugBot_WeaponBuy( pst_ptrEdict, "(tclWeapon::fflForceWeaponBuy) Money Avail: " + ftxIntToString( pinMoney ) );
		// fvoExecFakeClientCommand( pst_ptrEdict, "say", vstWeaponList[ vinIdx ].vtxBuyCommand );
		#endif // defDebug_WeaponBuy

		vflDelay += vflInc;
		// buy ammo for side arm
		#ifdef def_CS16
		fvoExecFakeClientCommandDELAYED( vflDelay, pst_ptrEdict, "secammo" ); 
		#endif // def_CS16
		
		#ifdef def_CS15
		fvoExecFakeClientCommandDELAYED( vflDelay, pst_ptrEdict, "buy" );
		vflDelay += vflInc;
		fvoExecFakeClientCommandDELAYED( vflDelay, pst_ptrEdict, "menuselect", "7" ); 
		#endif // def_CS15

		vflDelay += vflInc;

		locBuyEquip:

		if ( ( pinArmType != ARM_OTHER ) && ( pinArmType != ARM_ALL ) )
			goto locExit;

		if ( pinMoney > 4000 )
		{
			// buy vest + helmet
			#ifdef def_CS16
			fvoExecFakeClientCommandDELAYED( vflDelay, pst_ptrEdict, "vesthelm" ); 
			#endif // def_CS16
			
			#ifdef def_CS15
			fvoExecFakeClientCommandDELAYED( vflDelay, pst_ptrEdict, "buy" );
			vflDelay += vflInc;
			fvoExecFakeClientCommandDELAYED( vflDelay, pst_ptrEdict, "menuselect", "8" );
			vflDelay += vflInc;
			fvoExecFakeClientCommandDELAYED( vflDelay, pst_ptrEdict, "menuselect", "2" );
			#endif // def_CS15

			vflDelay += vflInc;

			#ifdef defDebug_WeaponBuy
			fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm) Bought vest + helmet." );
			#endif // defDebug_WeaponBuy

		}
		else
		if ( pinMoney > 3000 )
		{
			// buy vest only
			#ifdef def_CS16
			fvoExecFakeClientCommandDELAYED( vflDelay, pst_ptrEdict, "vest" ); 
			#endif // def_CS16

			#ifdef def_CS15
			fvoExecFakeClientCommandDELAYED( vflDelay, pst_ptrEdict, "buy" );
			vflDelay += vflInc;
			fvoExecFakeClientCommandDELAYED( vflDelay, pst_ptrEdict, "menuselect", "8" );
			vflDelay += vflInc;
			fvoExecFakeClientCommandDELAYED( vflDelay, pst_ptrEdict, "menuselect", "1" );
			#endif // def_CS15

			vflDelay += vflInc;

			#ifdef defDebug_WeaponBuy
			fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm) Bought vest only." );
			#endif // defDebug_WeaponBuy
		}

		if ( pinUserTeam != cinTeam_CT )
			goto locBuyHENade;

		if ( !fboCVarGetBool( ctxCVar_BotsBuyDefuseKit ) )
		{
			// vclDebugTrace.fvoWriteEventInfo( "BUY DEFUSE IS OFF!!!!" );
			goto locBuyHENade;
		}

		// buy defuse kit only if there is enough money;
		if ( pinMoney > 600 )
		{
			#ifdef def_CS16
			fvoExecFakeClientCommandDELAYED( vflDelay, pst_ptrEdict, "defuser" );
			#endif // def_CS16

			#ifdef def_CS15
			fvoExecFakeClientCommandDELAYED( vflDelay, pst_ptrEdict, "buy" );
			vflDelay += vflInc;
			fvoExecFakeClientCommandDELAYED( vflDelay, pst_ptrEdict, "menuselect", "8" );
			vflDelay += vflInc;
			fvoExecFakeClientCommandDELAYED( vflDelay, pst_ptrEdict, "menuselect", "7" );
			#endif // def_CS15

			vflDelay += vflInc;

			#ifdef defDebug_WeaponBuy
			fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm) Bought defuse kit." );
			#endif // defDebug_WeaponBuy

		}

		locBuyHENade:

		if ( !fboCVarGetBool( ctxCVar_BotsBuyHENade ) 
					||
				fboWeaponIsBanned_EntityByName( ctxWeapon_hegrenade ) 
			)
		{
			// vclDebugTrace.fvoWriteEventInfo( "BUY HE IS OFF!!!!" );
			goto locBuyFlashNade;
		}

		// buy HE nade only if there is enough money;
		if ( pinMoney > 6000 )
		{
			#ifdef def_CS16
			fvoExecFakeClientCommandDELAYED( vflDelay, pst_ptrEdict, "hegren" );
			#endif // def_CS16
			
			#ifdef def_CS15
			fvoExecFakeClientCommandDELAYED( vflDelay, pst_ptrEdict, "buy" );
			vflDelay += vflInc;
			fvoExecFakeClientCommandDELAYED( vflDelay, pst_ptrEdict, "menuselect", "8" );
			vflDelay += vflInc;
			fvoExecFakeClientCommandDELAYED( vflDelay, pst_ptrEdict, "menuselect", "4" );
			#endif // def_CS15

			vflDelay += vflInc;
	
			#ifdef defDebug_WeaponBuy
			fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm) Bought HE nade." );
			#endif // defDebug_WeaponBuy

		}

		locBuyFlashNade:

		if ( !fboCVarGetBool( ctxCVar_BotsBuyFlashNade ) 
					||
				fboWeaponIsBanned_EntityByName( ctxWeapon_flashbang ) 
			)
		{
			// vclDebugTrace.fvoWriteEventInfo( "BUY HE IS OFF!!!!" );
			goto locBuySmokeNade;
		}

		// buy HE nade only if there is enough money;
		if ( pinMoney > 7000 )
		{
			// buy two flash nades 
			#ifdef def_CS16
			fvoExecFakeClientCommandDELAYED( vflDelay, pst_ptrEdict, "flash" );
			#endif // def_CS16
			
			#ifdef def_CS15
			fvoExecFakeClientCommandDELAYED( vflDelay, pst_ptrEdict, "buy" );
			vflDelay += vflInc;
			fvoExecFakeClientCommandDELAYED( vflDelay, pst_ptrEdict, "menuselect", "8" );
			vflDelay += vflInc;
			fvoExecFakeClientCommandDELAYED( vflDelay, pst_ptrEdict, "menuselect", "3" );
			#endif // def_CS15

			vflDelay += vflInc;
			#ifdef defDebug_WeaponBuy
			fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm) Bought Flash nade (1)." );
			#endif // defDebug_WeaponBuy

			if ( pinMoney > 8000 )
			{
				#ifdef def_CS16
				fvoExecFakeClientCommandDELAYED( vflDelay, pst_ptrEdict, "flash" );
				#endif // def_CS16

				#ifdef def_CS15
				fvoExecFakeClientCommandDELAYED( vflDelay, pst_ptrEdict, "buy" );
				vflDelay += vflInc;
				fvoExecFakeClientCommandDELAYED( vflDelay, pst_ptrEdict, "menuselect", "8" );
				vflDelay += vflInc;
				fvoExecFakeClientCommandDELAYED( vflDelay, pst_ptrEdict, "menuselect", "3" );
				#endif // def_CS15

				vflDelay += vflInc;
				#ifdef defDebug_WeaponBuy
				fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm) Bought Flash nade (2)." );
				#endif // defDebug_WeaponBuy
			}
		}

		locBuySmokeNade:

		if ( !fboCVarGetBool( ctxCVar_BotsBuySmokeNade ) 					
					||
				fboWeaponIsBanned_EntityByName( ctxWeapon_smokegrenade ) 
			)
		{
			// vclDebugTrace.fvoWriteEventInfo( "BUY HE IS OFF!!!!" );
			goto locExit;
		}
		
		// buy smoke nade only if there is enough money;
		if ( pinMoney > 10000 )
		{
			#ifdef def_CS16
			fvoExecFakeClientCommandDELAYED( vflDelay, pst_ptrEdict, "Sgren" );
			#endif // def_CS16

			#ifdef def_CS15
			fvoExecFakeClientCommandDELAYED( vflDelay, pst_ptrEdict, "buy" );
			vflDelay += vflInc;
			fvoExecFakeClientCommandDELAYED( vflDelay, pst_ptrEdict, "menuselect", "8" );
			vflDelay += vflInc;
			fvoExecFakeClientCommandDELAYED( vflDelay, pst_ptrEdict, "menuselect", "5" );
			#endif // def_CS15

			vflDelay += vflInc;
			#ifdef defDebug_WeaponBuy
			fvoDebugBot_WeaponBuy( NULL, "(tclWeapon::finGetRandomArm) Bought Smoke nade." );
			#endif // defDebug_WeaponBuy
		}

		locExit:
			return vflDelay;

	} // tclWeapon::fflForceWeaponBuy

	void tclWeapon::fvoSetGlobalWeaponBanFlag( unsigned short pinBanState )
	{
		vinGlobalBanBitFlag = pinBanState;

		if ( vinNumWeapons <= 0 )
		{
			// this is an error condition;
			vclDebugTrace.fvoWriteEventInfo( "ERROR (tclWeapon::fvoSetGlobalWeaponBanFlag) vinNumWeapons is below the valid range: " + ftxIntToString( vinNumWeapons ) );
			return;
		}

		if ( vinNumWeapons > cinMaxWeapons ) 
		{
			// this is an error condition;
			vclDebugTrace.fvoWriteEventInfo( "ERROR (tclWeapon::fvoSetGlobalWeaponBanFlag) vinNumWeapons is above the valid range: " + ftxIntToString( vinNumWeapons ) );
			return;
		}

		// ensure weapon ban flag is initialized for all weapons using the global ban flag;

		for ( int vin = 0; vin < vinNumWeapons; vin++ )
		{
			vstWeaponList[ vin ].vinBanBitFlag = vinGlobalBanBitFlag;
		}

	} // tclWeapon::fvoSetGlobalWeaponBanFlag

	bool tclWeapon::fboWeaponBanFlagIsOn( unsigned short pinBanBit )
	{
		return fboButtonIsOn( vinGlobalBanBitFlag, pinBanBit );
	} // tclWeapon::fboWeaponBanFlagIsOn

	void tclWeapon::fvoSetWeaponBan_UsingGlobalFlag( )
	{
		fvoSetGlobalWeaponBanFlag( vinGlobalBanBitFlag );
	} // tclWeapon::fvoSetWeaponBan_UsingGlobalFlag

	void tclWeapon::fvoSetGlobalWeaponBanFlagBit_On( unsigned short pinBanBit )
	{
		fvoSetButtonOn( vinGlobalBanBitFlag, pinBanBit );
		fvoSetWeaponBan_UsingGlobalFlag( );
	} // tclWeapon::fvoSetGlobalWeaponBanFlagBit_On

	void tclWeapon::fvoSetGlobalWeaponBanFlagBit_Off( unsigned short pinBanBit )
	{
		fvoSetButtonOff( vinGlobalBanBitFlag, pinBanBit );
		fvoSetWeaponBan_UsingGlobalFlag( );		
	} // tclWeapon::fvoSetGlobalWeaponBanFlagBit_Off

	void tclWeapon::fvoSetAllWeaponBan( bool pboState )
	{
		if ( vinNumWeapons <= 0 )
		{
			// this is an error condition;
			vclDebugTrace.fvoWriteEventInfo( "ERROR (tclWeapon::fvoSetAllWeaponBan) vinNumWeapons is below the valid range: " + ftxIntToString( vinNumWeapons ) );
			return;
		}

		if ( vinNumWeapons > cinMaxWeapons ) 
		{
			// this is an error condition;
			vclDebugTrace.fvoWriteEventInfo( "ERROR (tclWeapon::fvoSetAllWeaponBan) vinNumWeapons is above the valid range: " + ftxIntToString( vinNumWeapons ) );
			return;
		}

		for ( int vin = 0; vin < vinNumWeapons; vin++ )
		{
			vstWeaponList[ vin ].fvoSetWeaponIsBanned_Switch( pboState );
		}

	} // tclWeapon::fvoSetAllWeaponBan

	void tclWeapon::fvoSetWeaponBanSwitch( string ptxEntityName, bool pboBanState )
	{
		int vin = finFindWeapon( ptxEntityName );
		if ( vin == -1 )
			return;

		vstWeaponList[ vin ].fvoSetWeaponIsBanned_Switch( pboBanState );

	} // tclWeapon::fvoSetWeaponBanSwitch

	void tclWeapon::fvoSetWeaponBanFlag( string ptxEntityName, unsigned short pinBanFlag )
	{
		int vin = finFindWeapon( ptxEntityName );
		if ( vin == -1 )
			return;

		vstWeaponList[ vin ].vinBanBitFlag = pinBanFlag;

	} // tclWeapon::fvoSetWeaponBanFlag

	void tclWeapon::fvoSetWeaponBanFlagBit_On( string ptxEntityName, unsigned short pinBanBit )
	{
		int vin = finFindWeapon( ptxEntityName );
		if ( vin == -1 )
			return;

		fvoSetButtonOn( vstWeaponList[ vin ].vinBanBitFlag, pinBanBit );

	} // tclWeapon::fvoSetWeaponBanFlagBit_On

	void tclWeapon::fvoSetWeaponBanFlagBit_Off( string ptxEntityName, unsigned short pinBanBit )
	{
		int vin = finFindWeapon( ptxEntityName );
		if ( vin == -1 )
			return;

		fvoSetButtonOff( vstWeaponList[ vin ].vinBanBitFlag, pinBanBit );

	} // tclWeapon::fvoSetWeaponBanFlagBit_Off

	void tclWeapon::fvoBanWeaponByName( string ptxEntityName )
	{
		fvoSetWeaponBanSwitch( ptxEntityName, true );

	} // tclWeapon::fvoBanWeaponByName

	void tclWeapon::fvoUnbanWeaponByName( string ptxEntityName )
	{
		fvoSetWeaponBanSwitch( ptxEntityName, false );
	} // tclWeapon::fvoUnbanWeaponByName

	void tclWeapon::fvoBanAllWeapons( void )
	{
		fvoSetAllWeaponBan( true );

	} // tclWeapon::fvoBanAllWeapons

	void tclWeapon::fvoUnbanAllWeapons( void )
	{
		fvoSetAllWeaponBan( false );
		vinWeaponMode = cinWeaponMode_RegularWar;
		vtxWeaponModeDisplay = "Regular war mode in effect.";

	} // tclWeapon::fvoUnbanAllWeapons

	bool tclWeapon::fboWeaponIndexIsValid( int pinWeaponIdx )
	{
		if ( vinNumWeapons <= 0 || vinNumWeapons > cinMaxWeapons ) 
			return false;

		if ( pinWeaponIdx < 0 || pinWeaponIdx >= vinNumWeapons ) 
			return false;

		return true;

	} // tclWeapon::fboWeaponIndexIsValid

	tstWeapon* tclWeapon::fst_ptrGetWeaponPtr( int pinWeaponIdx )
	{
		if ( !fboWeaponIndexIsValid( pinWeaponIdx ) )
			return NULL;
		
		return  &vstWeaponList[ pinWeaponIdx ];

	} // tclWeapon::fst_ptrGetWeaponPtr

	bool tclWeapon::fboWeaponIsBanned_SwitchByName( string ptxEntityName )
	{
		int vin = finFindWeapon( ptxEntityName );
		if ( vin == -1 )
			return false;

		return vstWeaponList[ vin ].fboWeaponIsBanned_Switch( );

	} // tclWeapon::fboWeaponIsBanned_SwitchByName

	bool tclWeapon::fboWeaponIsBanned_EntityByName( string ptxEntityName )
	{
		int vin = finFindWeapon( ptxEntityName );
		if ( vin == -1 )
			return false;

		return vstWeaponList[ vin ].fboEntityBanned( );

	} // tclWeapon::fboWeaponIsBanned_EntityByName

	bool tclWeapon::fboWeaponIsBanned_SwitchById( int pinWeaponId )
	{
		int vin = finFindWeaponById( pinWeaponId );
		if ( vin == -1 )
			return false;

		return vstWeaponList[ vin ].fboWeaponIsBanned_Switch( );

	} // tclWeapon::fboWeaponIsBanned_SwitchById

	bool tclWeapon::fboWeaponIsBanned_EntityById( int pinWeaponId )
	{
		int vin = finFindWeaponById( pinWeaponId );
		if ( vin == -1 )
			return false;

		return vstWeaponList[vin].fboEntityBanned( );

	} // tclWeapon::fboWeaponIsBanned_EntityById

	bool tclWeapon::fboWeaponIsBanned_SwitchByIndex( int pinWeaponIdx )
	{
		if ( !fboWeaponIndexIsValid( pinWeaponIdx ) )
			return false;

		return vstWeaponList[ pinWeaponIdx ].fboWeaponIsBanned_Switch( );

	} // tclWeapon::fboWeaponIsBanned_SwitchByIndex

	bool tclWeapon::fboWeaponIsBanned_EntityByIndex( int pinWeaponIdx )
	{
		if ( !fboWeaponIndexIsValid( pinWeaponIdx ) )
			return false;

		return vstWeaponList[ pinWeaponIdx ].fboEntityBanned( );

	} // tclWeapon::fboWeaponIsBanned_EntityByIndex

	bool tclWeapon::fboWeaponIsBanned_SwitchByNameReturnIndex( string ptxEntityName, int& pinIdx )
	{
		pinIdx = finFindWeapon( ptxEntityName );
		if ( pinIdx == -1 )
			return false;

		return vstWeaponList[ pinIdx ].fboWeaponIsBanned_Switch( );
	} // tclWeapon::fboWeaponIsBanned_SwitchByNameReturnIndex

	bool tclWeapon::fboWeaponIsBanned_SwitchBySlotReturnIndex( int pinTeam, int pinBuyOption, int pinBuySlot, int& pinIdx )
	{
		pinIdx = finFindWeaponBySlot( pinTeam, pinBuyOption, pinBuySlot );
		if ( pinIdx == -1 )
			return false;

		return vstWeaponList[ pinIdx ].fboWeaponIsBanned_Switch( );
	} // tclWeapon::fboWeaponIsBanned_SwitchBySlotReturnIndex

	bool tclWeapon::fboDefaultWeaponIsBanned_SwitchByTeam( int pinTeam )
	{
		if ( pinTeam == cinTeam_TE )
			return fboWeaponIsBanned_SwitchByName( ctxModel_glock );

		if ( pinTeam == cinTeam_CT )
			return fboWeaponIsBanned_SwitchByName( ctxModel_usp );

		return false;

	} // tclWeapon::fboDefaultWeaponIsBanned_SwitchByTeam

	bool tclWeapon::fboDefaultWeaponIsBanned_EntityByTeam( int pinTeam )
	{
		if ( pinTeam == cinTeam_TE )
			return fboWeaponIsBanned_EntityByName( ctxModel_glock );

		if ( pinTeam == cinTeam_CT )
			return fboWeaponIsBanned_EntityByName( ctxModel_usp );

		return false;

	} // tclWeapon::fboDefaultWeaponIsBanned_EntityByTeam

	bool tclWeapon::fboWeaponIsBanned_HumanCheckByIndex( 
		edict_t* pst_ptrEdict, int pinIdx )
	{
		if ( !fboWeaponIndexIsValid( pinIdx ) )
			return false;

		if ( !vclPlayer.fboPlayerIsHumanByEdict( pst_ptrEdict ) )
			return false;

		if ( vstWeaponList[ pinIdx ].fboWeaponIsBanned_ByFlag( cinBan_Humans ) )
			return true;

		if ( vstWeaponList[ pinIdx ].fboWeaponIsBanned_ByFlag( cinBan_Clan ) 
					&& 
			  vclSecurity.fboUserIsClanByEdict( pst_ptrEdict ) )
		{
			return true;
		}

		if ( vstWeaponList[ pinIdx ].fboWeaponIsBanned_ByFlag( cinBan_World ) 
					&& 
			  !vclSecurity.fboUserIsClanByEdict( pst_ptrEdict ) )
		{
			return true;
		}

		if ( vstWeaponList[ pinIdx ].fboWeaponIsBanned_ByFlag( cinBan_ClanTeam ) 
					&& 
			  vclPlayer.finGetPlayerTeamByEdict( pst_ptrEdict ) == vclPlayer.finGetClanTeam( ) )
		{
			return true;
		}

		if ( vstWeaponList[ pinIdx ].fboWeaponIsBanned_ByFlag( cinBan_WorldTeam ) 
					&& 
			  vclPlayer.finGetPlayerTeamByEdict( pst_ptrEdict ) != vclPlayer.finGetClanTeam( ) )
		{
			return true;
		}

		return false;

	} // tclWeapon::fboWeaponIsBanned_HumanCheckByIndex

	bool tclWeapon::fboWeaponIsBanned_HumanCheckBySlot( 
		edict_t* pst_ptrEdict, int pinBuyOption, int pinBuySlot, int& pinIdx )
	{
		int vinTeam = vclPlayer.finGetPlayerTeamByEdict( pst_ptrEdict );
		pinIdx = finFindWeaponBySlot( vinTeam, pinBuyOption, pinBuySlot );
		return fboWeaponIsBanned_HumanCheckByIndex( pst_ptrEdict, pinIdx );
	} // tclWeapon::fboWeaponIsBanned_HumanCheckBySlot

	bool tclWeapon::fboWeaponIsBanned_HumanCheckByName( edict_t* pst_ptrEdict, string ptxEntityName, int& pinIdx )
	{
		pinIdx = finFindWeapon( ptxEntityName );
		if ( fboWeaponIndexIsValid( pinIdx ) )
			return fboWeaponIsBanned_HumanCheckByIndex( pst_ptrEdict, pinIdx );

		return false;
		
	} // tclWeapon::fboWeaponIsBanned_HumanCheckByName

	bool tclWeapon::fboWeaponIsBanned_HumanCheckByBuyCmd( edict_t* pst_ptrEdict, string ptxBuyCmd, int& pinIdx )
	{
		pinIdx = finFindWeaponByBuyCmd( ptxBuyCmd );
		if ( fboWeaponIndexIsValid( pinIdx ) )
			return fboWeaponIsBanned_HumanCheckByIndex( pst_ptrEdict, pinIdx );

		return false;
		
	} // tclWeapon::fboWeaponIsBanned_HumanCheckByBuyCmd

	bool tclWeapon::fboWeaponIsBanned_HumanCheckById( edict_t* pst_ptrEdict, int pinWeaponId, int& pinIdx )
	{
		pinIdx = finFindWeaponById( pinWeaponId );
		return fboWeaponIsBanned_HumanCheckByIndex( pst_ptrEdict, pinIdx );
	} // tclWeapon::fboWeaponIsBanned_HumanCheckById

	bool tclWeapon::fboWeaponIsDefaultByIndex( int pinWeaponIndex )
	{
		if ( !fboWeaponIndexIsValid( pinWeaponIndex ) )
			return false;

		return vstWeaponList[ pinWeaponIndex ].vboDefault;

	} // tclWeapon::fboWeaponIsDefaultByIndex

	bool tclWeapon::fboWeaponIsDefaultByIndex( int pinWeaponIndex, int pinTeam )
	{
		if ( !fboWeaponIndexIsValid( pinWeaponIndex ) )
			return false;

		if ( vstWeaponList[ pinWeaponIndex ].vinTeam == cinTeam_Any )
		{
			return vstWeaponList[ pinWeaponIndex ].vboDefault;
		}

		return 
			( vstWeaponList[ pinWeaponIndex ].vboDefault 
				 && 
			( vstWeaponList[ pinWeaponIndex ].vboDefault == pinTeam ) );

	} // tclWeapon::fboWeaponIsDefaultByIndex

	bool tclWeapon::fboWeaponIsSideArm_ByIndex( int pinWeaponIndex )
	{
		if ( !fboWeaponIndexIsValid( pinWeaponIndex ) )
			return false;

		return vstWeaponList[ pinWeaponIndex ].fboIsSideArm( );

	} // tclWeapon::fboWeaponIsSideArm_ByIndex

	bool tclWeapon::fboWeaponIsSideArm_ById( int pinWeaponId )
	{
		return fboWeaponIsSideArm_ByIndex( finFindWeaponById( pinWeaponId ) );
	} // tclWeapon::fboWeaponIsSideArm_ById

	bool tclWeapon::fboWeaponIsMainArm_ByIndex( int pinWeaponIndex )
	{
		if ( !fboWeaponIndexIsValid( pinWeaponIndex ) )
			return false;

		return vstWeaponList[ pinWeaponIndex ].fboIsMainArm( );

	} // tclWeapon::fboWeaponIsMainArm_ByIndex

	bool tclWeapon::fboWeaponIsMainArm_ById( int pinWeaponId )
	{
		return fboWeaponIsMainArm_ByIndex( finFindWeaponById( pinWeaponId ) );
	} // tclWeapon::fboWeaponIsMainArm_ById

	void tclWeapon::fvoBanAllGuns( void )
	{
		fvoBanAllPistols( );
		fvoBanAllSubs( );
		fvoBanAllShotguns( );
		fvoBanAllRifles( );
		fvoBanAllSnipe( );
		fvoBanPARA( );
	} // tclWeapon::fvoBanAllGuns

	void tclWeapon::fvoUnbanAllGuns( void )
	{
		fvoUnbanAllPistols( );
		fvoUnbanAllSubs( );
		fvoUnbanAllShotguns( );
		fvoUnbanAllRifles( );
		fvoUnbanAllSnipe( );
		fvoUnbanPARA( );
	} // tclWeapon::fvoUnbanAllGuns

	void tclWeapon::fvoBanAllPistols(void)
	{
		fvoBanWeaponByName( ctxWeapon_elite );
		fvoBanWeaponByName( ctxWeapon_glock18 );
		fvoBanWeaponByName( ctxWeapon_fiveseven );
		fvoBanWeaponByName( ctxWeapon_usp );
		fvoBanWeaponByName( ctxWeapon_p228 );
		fvoBanWeaponByName( ctxWeapon_deagle );

	} // tclWeapon::fvoBanAllPistols

	void tclWeapon::fvoUnbanAllPistols(void)
	{
		fvoUnbanWeaponByName( ctxWeapon_elite );
		fvoUnbanWeaponByName( ctxWeapon_glock18 );
		fvoUnbanWeaponByName( ctxWeapon_fiveseven );
		fvoUnbanWeaponByName( ctxWeapon_usp );
		fvoUnbanWeaponByName( ctxWeapon_p228 );
		fvoUnbanWeaponByName( ctxWeapon_deagle );

	} // tclWeapon::fvoUnbanAllPistols

	void tclWeapon::fvoBanAllSubs( void )
	{
		fvoBanWeaponByName( ctxWeapon_mac10 );
		fvoBanWeaponByName( ctxWeapon_tmp );
		fvoBanWeaponByName( ctxWeapon_ump45 );
		fvoBanWeaponByName( ctxWeapon_mp5navy );
		fvoBanWeaponByName( ctxWeapon_p90 );
	
	} // tclWeapon::fvoBanAllSubs

	void tclWeapon::fvoUnbanAllSubs( void )
	{
		fvoUnbanWeaponByName( ctxWeapon_mac10 );
		fvoUnbanWeaponByName( ctxWeapon_tmp );
		fvoUnbanWeaponByName( ctxWeapon_ump45 );
		fvoUnbanWeaponByName( ctxWeapon_mp5navy );
		fvoUnbanWeaponByName( ctxWeapon_p90 );
	
	} // tclWeapon::fvoUnbanAllSubs

	void tclWeapon::fvoBanAllShotguns(void)
	{
		fvoBanWeaponByName( ctxWeapon_m3 );
		fvoBanWeaponByName( ctxWeapon_xm1014 );

	} // tclWeapon::fvoBanAllShotguns

	void tclWeapon::fvoUnbanAllShotguns( void )
	{
		fvoUnbanWeaponByName( ctxWeapon_m3 );
		fvoUnbanWeaponByName( ctxWeapon_xm1014 );

	} // tclWeapon::fvoUnbanAllShotguns

	void tclWeapon::fvoBanAllRifles( void )
	{
		fvoBanWeaponByName( ctxWeapon_famas );
		fvoBanWeaponByName( ctxWeapon_galil );
		fvoBanWeaponByName( ctxWeapon_ak47 );
		fvoBanWeaponByName( ctxWeapon_m4a1 );
		fvoBanWeaponByName( ctxWeapon_sg552 );
		fvoBanWeaponByName( ctxWeapon_aug );
		
	} // tclWeapon::fvoBanAllRifles

	void tclWeapon::fvoUnbanAllRifles( void )
	{
		fvoUnbanWeaponByName( ctxWeapon_famas );
		fvoUnbanWeaponByName( ctxWeapon_galil );
		fvoUnbanWeaponByName( ctxWeapon_ak47 );
		fvoUnbanWeaponByName( ctxWeapon_m4a1 );
		fvoUnbanWeaponByName( ctxWeapon_sg552 );
		fvoUnbanWeaponByName( ctxWeapon_aug );
		
	} // tclWeapon::fvoUnbanAllRifles

	void tclWeapon::fvoBanAllSnipe(void)
	{
		fvoBanWeaponByName( ctxWeapon_scout );
		fvoBanWeaponByName( ctxWeapon_g3sg1 );
		fvoBanWeaponByName( ctxWeapon_sg550 );
		fvoBanWeaponByName( ctxWeapon_awp );

	} // tclWeapon::fvoBanAllSnipe

	void tclWeapon::fvoUnbanAllSnipe(void)
	{
		fvoUnbanWeaponByName( ctxWeapon_scout );
		fvoUnbanWeaponByName( ctxWeapon_g3sg1 );
		fvoUnbanWeaponByName( ctxWeapon_sg550 );
		fvoUnbanWeaponByName( ctxWeapon_awp );

	} // tclWeapon::fvoUnbanAllSnipe

	void tclWeapon::fvoBanAllNades( void )
	{
		fvoBanWeaponByName( ctxWeapon_hegrenade );
		fvoBanWeaponByName( ctxWeapon_flashbang );
		fvoBanWeaponByName( ctxWeapon_smokegrenade );

	} // tclWeapon::fvoBanAllNades

	void tclWeapon::fvoUnbanAllNades( void )
	{
		fvoUnbanWeaponByName( ctxWeapon_hegrenade );
		fvoUnbanWeaponByName( ctxWeapon_flashbang );
		fvoUnbanWeaponByName( ctxWeapon_smokegrenade );

	} // tclWeapon::fvoUnbanAllNades

	void tclWeapon::fvoBanPARA( void )
	{
		fvoBanWeaponByName( ctxWeapon_m249 );

	} // tclWeapon::fvoBanPARA

	void tclWeapon::fvoUnbanPARA(void)
	{
		fvoUnbanWeaponByName (ctxWeapon_m249);

	} // tclWeapon::fvoUnbanPARA

// ===============================================================
// Set War Mode Functions
// ===============================================================

	void tclWeapon::fvoSetWeaponMode_RegularWar( void )
	{
		fvoSetUseRank( true );
		fvoUnbanAllWeapons( );

	} // tclWeapon::fvoSetWeaponMode_RegularWar

	void tclWeapon::fvoSetWeaponMode_LightArmsWar( void )
	{
		fvoSetUseRank( false );
		fvoUnbanAllWeapons( );		
		fvoBanAllRifles( );
		fvoBanAllSnipe( );
		fvoBanPARA( );
		fvoBanWeaponByName( ctxWeapon_deagle );
		fvoBanWeaponByName( ctxWeapon_mp5navy );
		fvoBanWeaponByName( ctxWeapon_p90 );
		fvoUnbanWeaponByName( ctxWeapon_scout );

		vinWeaponMode = cinWeaponMode_LightArmsWar;
		vtxWeaponModeDisplay = 
			"Buy limited to: Scout, MAC-10, TMP, UMP and all pistols except deagle.";

	} // tclWeapon::fvoSetWeaponMode_LightArmsWar

	void tclWeapon::fvoSetWeaponMode_SmallArmsWar( void )
	{
		fvoSetUseRank( false );
		fvoUnbanAllWeapons( );
		fvoBanAllRifles( );
		fvoBanWeaponByName( ctxWeapon_awp );

		vinWeaponMode = cinWeaponMode_SmallArmsWar;
		vtxWeaponModeDisplay = 
			"Buy limited to: All weapons except AWP and heavy rifles.";

	} // tclWeapon::fvoSetWeaponMode_SmallArmsWar

	void tclWeapon::fvoSetWeaponMode_HeavyArmsWar( void )
	{
		fvoSetUseRank( false );
		fvoUnbanAllWeapons( );
//		fvoBanAllPistols( );
		fvoBanAllShotguns( );
		fvoBanAllSubs( );		
		fvoBanAllSnipe( );
		fvoUnbanWeaponByName( ctxWeapon_awp );
		fvoUnbanWeaponByName( ctxWeapon_deagle );

		vinWeaponMode = cinWeaponMode_HeavyArmsWar;
		vtxWeaponModeDisplay = 
			"Buy limited to: AWP, Para machine gun, AK-47, Colt M4A1 and all pistols.";

	} // tclWeapon::fvoSetWeaponMode_HeavyArmsWar

	void tclWeapon::fvoSetWeaponMode_AK47ColtWar( void )
	{
		fvoSetUseRank( false );
		fvoUnbanAllWeapons( );
		fvoBanAllGuns( );
		fvoUnbanAllPistols( );
		fvoUnbanWeaponByName( ctxWeapon_ak47 );
		fvoUnbanWeaponByName( ctxWeapon_m4a1 );
		vinWeaponMode = cinWeaponMode_AK47ColtWar;
		vtxWeaponModeDisplay = 
			"Buy limited to: AK-47, Colt M4A1 and all pistols.";

	} // tclWeapon::fvoSetWeaponMode_AK47ColtWar

	void tclWeapon::fvoSetWeaponMode_SG552AugWar( void )
	{
		fvoSetUseRank( false );
		fvoUnbanAllWeapons( );
		fvoBanAllGuns( );
		fvoUnbanAllPistols( );
		fvoUnbanWeaponByName( ctxWeapon_sg552 );
		fvoUnbanWeaponByName( ctxWeapon_aug );
		vinWeaponMode = cinWeaponMode_SG552AugWar;
		vtxWeaponModeDisplay = 
			"Buy limited to: SG-552 Commando, Steyr Aug and all pistols.";

	} // tclWeapon::fvoSetWeaponMode_SG552AugWar

	void tclWeapon::fvoSetWeaponMode_KnifeWar( void )
	{
		fvoSetUseRank( false );
		fvoUnbanAllWeapons( );
		fvoBanAllGuns( );
		fvoUnbanWeaponByName( ctxWeapon_knife );
		vinWeaponMode = cinWeaponMode_KnifeWar;
		vtxWeaponModeDisplay =  "Buy limited to: Knife only";

	} // tclWeapon::fvoSetWeaponMode_KnifeWar

	void tclWeapon::fvoSetWeaponMode_NadeWar( void )
	{
		fvoSetUseRank( false );
		fvoBanAllWeapons( );
		fvoUnbanWeaponByName( ctxWeapon_hegrenade );
		fvoUnbanWeaponByName( ctxWeapon_flashbang );
		fvoUnbanWeaponByName( ctxWeapon_smokegrenade );
		vinWeaponMode = cinWeaponMode_NadeWar;
		vtxWeaponModeDisplay =  "Buy limited to: Nades only";

	} // tclWeapon::fvoSetWeaponMode_NadeWar

	void tclWeapon::fvoSetWeaponMode_LightPistolWar( void )
	{
		fvoSetUseRank( false );
		fvoUnbanAllWeapons( );
		fvoBanAllGuns( );
		fvoUnbanAllPistols( );
		fvoBanWeaponByName( ctxWeapon_deagle );
		vinWeaponMode = cinWeaponMode_LightPistolWar;
		vclWeapon.vtxWeaponModeDisplay = "Buy limited to: Light pistols only - No deagle.";

	} // tclWeapon::fvoSetWeaponMode_LightPistolWar 

	void tclWeapon::fvoSetWeaponMode_PistolWar( void )
	{
		fvoSetUseRank( false );
		fvoUnbanAllWeapons( );
		fvoBanAllGuns( );
		fvoUnbanAllPistols( );
		vinWeaponMode = cinWeaponMode_PistolWar;
		vclWeapon.vtxWeaponModeDisplay = "Buy limited to: All pistols only.";

	} // tclWeapon::fvoSetWeaponMode_PistolWar 

	void tclWeapon::fvoSetWeaponMode_DeagleWar( void )
	{
		fvoSetUseRank( false );
		fvoUnbanAllWeapons( );
		fvoBanAllGuns( );
		fvoUnbanWeaponByName( ctxWeapon_deagle );
		vinWeaponMode = cinWeaponMode_DeagleWar;
		vclWeapon.vtxWeaponModeDisplay = "Buy limited to: Desert Eagle (deagle) pistol only.";

	} // tclWeapon::fvoSetWeaponMode_DeagleWar 

	void tclWeapon::fvoSetWeaponMode_GlockUSPWar( void )
	{
		fvoSetUseRank( false );
		fvoUnbanAllWeapons( );
		fvoBanAllGuns( );
		fvoUnbanWeaponByName( ctxWeapon_glock18 );
		fvoUnbanWeaponByName( ctxWeapon_usp );
		vinWeaponMode = cinWeaponMode_GlockUSPWar;
		vclWeapon.vtxWeaponModeDisplay = "Buy limited to: Glock and USP pistols only.";

	} // tclWeapon::fvoSetWeaponMode_GlockUSPWar 

	void tclWeapon::fvoSetWeaponMode_GlockWar( void )
	{
		fvoSetUseRank( false );
		fvoUnbanAllWeapons( );
		fvoBanAllGuns( );
		fvoUnbanWeaponByName( ctxWeapon_glock18 );
		vinWeaponMode = cinWeaponMode_GlockWar;
		vclWeapon.vtxWeaponModeDisplay = "Buy limited to: Glock pistol only.";

	} // tclWeapon::fvoSetWeaponMode_GlockWar 

	void tclWeapon::fvoSetWeaponMode_USPWar( void )
	{
		fvoSetUseRank( false );
		fvoUnbanAllWeapons( );
		fvoBanAllGuns( );
		fvoUnbanWeaponByName( ctxWeapon_usp );
		vinWeaponMode = cinWeaponMode_USPWar;
		vclWeapon.vtxWeaponModeDisplay = "Buy limited to: USP pistol only.";

	} // tclWeapon::fvoSetWeaponMode_USPWar 

	void tclWeapon::fvoSetWeaponMode_Dual57War( void )
	{
		fvoSetUseRank( false );
		fvoUnbanAllWeapons( );
		fvoBanAllGuns( );
		fvoUnbanWeaponByName( ctxWeapon_elite );
		fvoUnbanWeaponByName( ctxWeapon_fiveseven );
		vinWeaponMode = cinWeaponMode_Dual57War;
		vclWeapon.vtxWeaponModeDisplay = "Buy limited to: Dual Berettas + Five Seven pistols only.";

	} // tclWeapon::fvoSetWeaponMode_Dual57War 

	void tclWeapon::fvoSetWeaponMode_P228War( void )
	{
		fvoSetUseRank( false );
		fvoUnbanAllWeapons( );
		fvoBanAllGuns( );
		fvoUnbanWeaponByName( ctxWeapon_p228 );
		vinWeaponMode = cinWeaponMode_P228War;
		vclWeapon.vtxWeaponModeDisplay = "Buy limited to: P228 pistol only.";

	} // tclWeapon::fvoSetWeaponMode_P228War 

	void tclWeapon::fvoSetWeaponMode_LightSubWar( void )
	{
		fvoSetUseRank( false );
		fvoUnbanAllWeapons( );
		fvoBanAllGuns( );
		fvoUnbanAllPistols( );
		fvoUnbanAllSubs( );
		fvoBanWeaponByName( ctxWeapon_mp5navy );
		fvoBanWeaponByName( ctxWeapon_p90 );
		fvoBanWeaponByName( ctxWeapon_deagle );
		vinWeaponMode = cinWeaponMode_LightSubWar;
		vtxWeaponModeDisplay = "Buy limited to: Submachine guns only - No MP5 or P90.";

	} // tclWeapon::fvoSetWeaponMode_LightSubWar 

	void tclWeapon::fvoSetWeaponMode_UziWar( void )
	{
		fvoSetUseRank( false );
		fvoUnbanAllWeapons( );
		fvoBanAllGuns( );
		fvoUnbanWeaponByName( ctxWeapon_glock18 );
		fvoUnbanWeaponByName( ctxWeapon_usp );
		fvoUnbanWeaponByName( ctxWeapon_mac10 );
		fvoUnbanWeaponByName( ctxWeapon_tmp );
		vinWeaponMode = cinWeaponMode_UziWar;
		vtxWeaponModeDisplay = 
			"Buy limited to: MAC-10 and TMP submachine guns + Glock and USP Pistols.";

	} // tclWeapon::fvoSetWeaponMode_UziWar

	void tclWeapon::fvoSetWeaponMode_UMPWar( void )
	{
		fvoSetUseRank( false );
		fvoUnbanAllWeapons( );
		fvoBanAllGuns( );
		fvoUnbanWeaponByName( ctxWeapon_glock18 );
		fvoUnbanWeaponByName( ctxWeapon_usp );
		fvoUnbanWeaponByName( ctxWeapon_ump45 );
		vinWeaponMode = cinWeaponMode_UMPWar;
		vtxWeaponModeDisplay = 
			"Buy limited to: Universal Machine Pistol + Glock and USP Pistols.";

	} // tclWeapon::fvoSetWeaponMode_UMPWar

	void tclWeapon::fvoSetWeaponMode_P90War( void )
	{
		fvoSetUseRank( false );
		fvoUnbanAllWeapons( );
		fvoBanAllGuns( );
		fvoUnbanWeaponByName( ctxWeapon_glock18 );
		fvoUnbanWeaponByName( ctxWeapon_usp );
		fvoUnbanWeaponByName( ctxWeapon_p90 );
		vinWeaponMode = cinWeaponMode_P90War;
		vtxWeaponModeDisplay = 
			"Buy limited to: P90 submachine gun only + Glock and USP Pistols.";

	} // tclWeapon::fvoSetWeaponMode_P90War

	void tclWeapon::fvoSetWeaponMode_MP5War( void )
	{
		fvoSetUseRank( false );
		fvoUnbanAllWeapons( );
		fvoBanAllGuns( );
		fvoUnbanWeaponByName( ctxWeapon_glock18 );
		fvoUnbanWeaponByName( ctxWeapon_usp );
		fvoUnbanWeaponByName( ctxWeapon_mp5navy );
		vinWeaponMode = cinWeaponMode_MP5War;
		vtxWeaponModeDisplay = 
			"Buy limited to: MP5 Navy submachine gun only + Glock and USP Pistols.";

	} // tclWeapon::fvoSetWeaponMode_mp5War

	void tclWeapon::fvoSetWeaponMode_SubWar( void )
	{
		fvoSetUseRank( false );
		fvoUnbanAllWeapons( );
		fvoBanAllGuns( );
		fvoUnbanAllPistols( );
		fvoUnbanAllSubs( );
		vinWeaponMode = cinWeaponMode_SubWar;
		vtxWeaponModeDisplay = "Buy limited to: All submachine guns and pistols only.";

	} // tclWeapon::fvoSetWeaponMode_SubWar

	void tclWeapon::fvoSetWeaponMode_PumpWar( void )
	{
		fvoSetUseRank( false );
		fvoUnbanAllWeapons( );
		fvoBanAllGuns( );
		fvoUnbanAllPistols( );
		fvoBanWeaponByName( ctxWeapon_deagle );
		fvoUnbanWeaponByName( ctxWeapon_m3 );
		vinWeaponMode = cinWeaponMode_PumpWar;
		vtxWeaponModeDisplay = 
			"Buy limited to: Pump shotgun and pistols only - No auto shotgun or deagle.";

	} // tclWeapon::fvoSetWeaponMode_PumpWar

	void tclWeapon::fvoSetWeaponMode_ShotgunWar( void )
	{
		fvoSetUseRank( false );
		fvoUnbanAllWeapons( );
		fvoBanAllGuns( );
		fvoUnbanAllPistols( );
		fvoBanWeaponByName( ctxWeapon_deagle );
		fvoUnbanAllShotguns( );
		vinWeaponMode = cinWeaponMode_ShotgunWar;
		vtxWeaponModeDisplay = 
			"Buy limited to: All shotguns and pistols only -  No deagle.";

	} // tclWeapon::fvoSetWeaponMode_ShotgunWar

	void tclWeapon::fvoSetWeaponMode_AutoShotgunWar( void )
	{
		fvoSetUseRank( false );
		fvoUnbanAllWeapons( );
		fvoBanAllGuns( );
		fvoUnbanAllPistols( );
		fvoBanWeaponByName( ctxWeapon_deagle );
		fvoUnbanWeaponByName( ctxWeapon_xm1014 );
		vinWeaponMode = cinWeaponMode_AutoShotgunWar;
		vtxWeaponModeDisplay = 
			"Buy limited to: auto shotgun and pistols only -  No deagle.";

	} // tclWeapon::fvoSetWeaponMode_AutoShotgunWar

	void tclWeapon::fvoSetWeaponMode_ScoutWar( void )
	{
		fvoSetUseRank( false );
		fvoUnbanAllWeapons( );
		fvoBanAllGuns( );
		fvoUnbanAllPistols( );
		fvoUnbanWeaponByName( ctxWeapon_scout );
		vinWeaponMode = cinWeaponMode_ScoutWar;
		vtxWeaponModeDisplay = 
			"Buy limited to: Scout sniper rifle and all pistols only.";

	} // tclWeapon::fvoSetWeaponMode_ScoutWar

	void tclWeapon::fvoSetWeaponMode_SnipeWar( void )
	{
		fvoSetUseRank( false );
		fvoUnbanAllWeapons( );
		fvoBanAllGuns( );
		fvoUnbanAllPistols( );
		fvoUnbanAllSnipe( );
		vinWeaponMode = cinWeaponMode_SnipeWar;
		vtxWeaponModeDisplay = 
			"Buy limited to: All sniper rifles and all pistols only.";

	} // tclWeapon::fvoSetWeaponMode_SnipeWar

	void tclWeapon::fvoSetWeaponMode_LightSnipeWar( void )
	{
		fvoSetUseRank( false );
		fvoUnbanAllWeapons( );
		fvoBanAllGuns( );
		fvoUnbanAllPistols( );
		fvoUnbanAllSnipe( );
		fvoBanWeaponByName( ctxWeapon_awp );
		vinWeaponMode = cinWeaponMode_LightSnipeWar;
		vtxWeaponModeDisplay = 
			"Buy limited to: Sniper rifles and all pistols only - No AWP rifle.";

	} // tclWeapon::fvoSetWeaponMode_LightSnipeWar

	void tclWeapon::fvoSetWeaponMode_HK550SnipeWar( void )
	{
		fvoSetUseRank( false );
		fvoUnbanAllWeapons( );
		fvoBanAllGuns( );
		fvoUnbanAllPistols( );
		fvoUnbanWeaponByName( ctxWeapon_g3sg1 );
		fvoUnbanWeaponByName( ctxWeapon_sg550 );
		vinWeaponMode = cinWeaponMode_HK550SnipeWar;
		vtxWeaponModeDisplay = 
			"Buy limited to: H&K and Sig 550 sniper rifles, and all pistols.";

	} // tclWeapon::fvoSetWeaponMode_HK550SnipeWar

	void tclWeapon::fvoSetWeaponMode_AWPWar( void )
	{
		fvoSetUseRank( false );
		fvoUnbanAllWeapons( );
		fvoBanAllGuns( );
		fvoUnbanWeaponByName( ctxWeapon_glock18 );
		fvoUnbanWeaponByName( ctxWeapon_usp );
		fvoUnbanWeaponByName( ctxWeapon_awp );
		vinWeaponMode = cinWeaponMode_AWPWar;
		vtxWeaponModeDisplay = 
			"Buy limited to: AWP rifle + Glock and USP Pistols.";

	} // tclWeapon::fvoSetWeaponMode_AWPWar

	void tclWeapon::fvoSetWeaponMode_PARAWar( void )
	{
		fvoSetUseRank( false );
		fvoUnbanAllWeapons( );
		fvoBanAllGuns( );
		fvoUnbanAllPistols( );
		fvoUnbanPARA(  );
		vinWeaponMode = cinWeaponMode_PARAWar;
		vtxWeaponModeDisplay = 
			"Buy limited to: PARA Machine gun and all pistols only.";

	} // tclWeapon::fvoSetWeaponMode_PARAWar

	void tclWeapon::fvoSetWeaponMode_FamasGalilWar( void )
	{
		fvoSetUseRank( false );
		fvoUnbanAllWeapons( );
		fvoBanAllGuns( );
		fvoUnbanAllPistols( );
		fvoUnbanWeaponByName( ctxWeapon_galil );
		fvoUnbanWeaponByName( ctxWeapon_famas );
		vinWeaponMode = cinWeaponMode_FamasGalilWar;
		vtxWeaponModeDisplay = 
			"Buy limited to: Famas and Galil assault rifles and all pistols.";

	} // tclWeapon::fvoSetWeaponMode_FamasGalilWar

	bool tclWeapon::fboStopWeaponSelect( edict_t* pst_ptrEdict, string ptxCmd, string ptxMenuItem )
	{
		// before moving forward check if the command is a weapon select command
		// where the weapon is banned;
		int vinWeaponIdx;
		string vtxMsg;

		if ( vclWeapon.fboWeaponIsBanned_HumanCheckByName( pst_ptrEdict, ptxCmd, vinWeaponIdx )
					&& 
			  fboCVarGetBool( ctxCVar_WeapomSelectBan )
		   )
		{
			// weapon is banned;
			vtxMsg  = ctxMsgPrefix + "Weapon is restricted: ";
			vtxMsg += vclWeapon.ftxGetWeaponDescByIndex( vinWeaponIdx );
			fvoClientPrintChat( pst_ptrEdict, vtxMsg );
			// prevent command from getting to the game engine;
			return true;
		}	

		// before moving forward check if the command is a weapon buy command
		// where the weapon is banned;
		if ( vclWeapon.fboWeaponIsBanned_HumanCheckByBuyCmd( pst_ptrEdict, ptxCmd, vinWeaponIdx ) )
		{
			// weapon is banned;
			vtxMsg  = ctxMsgPrefix + "Weapon is restricted: ";
			vtxMsg += vclWeapon.ftxGetWeaponDescByIndex( vinWeaponIdx );
			fvoClientPrintChat( pst_ptrEdict, vtxMsg );
			// prevent command from getting to the game engine;
			return true;
		}	

		// move forward assuming the command is a weaponbuy command, or a "buy", or a "menuselect"

		vinWeaponIdx = finFindWeaponByBuyCmd( ptxCmd );
//		vclDebugTrace.fvoWriteEventInfo( "DEBUG (tclWeapon::fboStopWeaponSelect) ptxCmd      : " + ptxCmd );
//		vclDebugTrace.fvoWriteEventInfo( "DEBUG (tclWeapon::fboStopWeaponSelect) vinWeaponIdx: " + ftxIntToString( vinWeaponIdx ) );

		// if the returned vinWeaponIdx is valid, then the command was a weapon buy command;
		if ( fboWeaponIndexIsValid( vinWeaponIdx ) )
		{
//			vclDebugTrace.fvoWriteEventInfo( "DEBUG (tclWeapon::fboStopWeaponSelect) weapon is valid." );
			if ( vclWeapon.fboWeaponIsBanned_EntityByIndex( vinWeaponIdx ) )
			{
//				vclDebugTrace.fvoWriteEventInfo( "DEBUG (tclWeapon::fboStopWeaponSelect) weapon is banned." );
				// weapon is entity banned, allow it to be spawned within a timeout period;
				vclWeapon.vstWeaponList[ vinWeaponIdx ].vclTimer_EntityBan.fvoStart( 0.25 );
			}
			return false;
		}

		int vinUserIdx = vclPlayer.finGetPlayerIndexByEdict( pst_ptrEdict );
		if ( ( vinUserIdx < cinMinPlayerIndex )
					|| 
			  ( vinUserIdx > cinMaxPlayerIndex ) )
		{
			// This is an error condition - user index out of range.
			vclDebugTrace.fvoWriteEventInfo( "ERROR (tclWeapon::fboStopWeaponSelect) User index out of range: " + ftxIntToString( vinUserIdx ) );
			return false;
		}

		vinUserIdx--; // reduce to a zero based index;

		if ( ptxCmd == "buy" )
		{ // user selected "buy", next state will be a menuselect of the
		  // weapon option group;
			vin_aryBuyMenu[ vinUserIdx ].vinState = cinBuyOption;
			return false;
		}

		if ( ptxCmd != "menuselect" )
		{
			vin_aryBuyMenu[ vinUserIdx ].vinState = cinNotBuying;
			vin_aryBuyMenu[ vinUserIdx ].vinBuyOption = 0;
			vin_aryBuyMenu[ vinUserIdx ].vinBuySlot = 0;
			return false;
		}

		if ( vin_aryBuyMenu[ vinUserIdx ].vinState == cinNotBuying )
			return false;

		if ( vin_aryBuyMenu[ vinUserIdx ].vinState == cinBuyOption )
		{ 
			vin_aryBuyMenu[ vinUserIdx ].vinState     = cinBuySlot;
			vin_aryBuyMenu[ vinUserIdx ].vinBuyOption = finStringToInt( ptxMenuItem );
			return false;
		}

		if ( vin_aryBuyMenu[ vinUserIdx ].vinState != cinBuySlot )
		{
			vin_aryBuyMenu[ vinUserIdx ].vinState = cinNotBuying;
			vin_aryBuyMenu[ vinUserIdx ].vinBuyOption = 0;
			vin_aryBuyMenu[ vinUserIdx ].vinBuySlot = 0;
			return false;
		}

		vin_aryBuyMenu[ vinUserIdx ].vinState	 = cinNotBuying;
		vin_aryBuyMenu[ vinUserIdx ].vinBuySlot = finStringToInt( ptxMenuItem );

		// before passing the command to the engine, check for a weapon buy ban;
		int vinBuyOption = vin_aryBuyMenu[ vinUserIdx ].vinBuyOption; 
		int vinBuySlot   = vin_aryBuyMenu[ vinUserIdx ].vinBuySlot;
		vin_aryBuyMenu[ vinUserIdx ].vinBuyOption = 0;
		vin_aryBuyMenu[ vinUserIdx ].vinBuySlot = 0;

		if ( vclWeapon.fboWeaponIsBanned_HumanCheckBySlot( pst_ptrEdict, vinBuyOption, vinBuySlot, vinWeaponIdx ) )
		{
			// weapon is banned;
			vtxMsg  = ctxMsgPrefix + "Weapon is restricted: ";
			vtxMsg += vclWeapon.ftxGetWeaponDescByIndex( vinWeaponIdx );
			fvoClientPrintChat( pst_ptrEdict, vtxMsg );
			// prevent command from getting to the game engine;
			return true;
		}

		if ( vclWeapon.fboWeaponIsBanned_EntityByIndex( vinWeaponIdx ) )
		{
			// weapon is entity banned, allow it to be spawned within a timeout period;
			vclWeapon.vstWeaponList[ vinWeaponIdx ].vclTimer_EntityBan.fvoStart( 0.25 );
		}		

		return false;

	} // tclWeapon::fboStopWeaponSelect

	void tclWeapon::fvoSetDamageReduction( float pflDamageReduction )
	{
		if ( pflDamageReduction < cflMinDamageReduction )
			vflDamageReduction = cflMinDamageReduction;
		else
		if ( pflDamageReduction > cflMaxDamageReduction )
			vflDamageReduction = cflMaxDamageReduction;
		else
			vflDamageReduction = pflDamageReduction;

	} // tclWeapon::fvoSetDamageReduction

/*
		if ( vclWeapon.fflGetDamageReduction( ) != cflMinDamageReduction )
		{
			if ( vclPlayer.fboPlayerIsHumanByEdict( vclDamageMsg.vst_ptrEdict ) )
			{
				//!! vclPlayer.fboEmitBloodFromPlayerByEdict( pst_ptrEdict );

				TraceResult vstTR;
				string vtxClassName;
				int vinMaxBonus = 100;
				if ( vclWeapon.fflGetDamageReduction( ) >= cflMaxDamageReduction )
				{
					// GOD Mode is ON - skip all checks and add maximum health;
					vinMaxBonus = 1000;
					goto locAdjustHealth;
				}

				// find out what hit the player;
				
				TRACE_LINE( 
					vclDamageMsg.vst_ptrEdict->v.origin, 
					vclDamageMsg.vstOrigin, 
					dont_ignore_monsters, 
					vclDamageMsg.vst_ptrEdict, 
					&vstTR );

				if ( vstTR.pHit == NULL )
					goto locExitDamageReduction;

				vtxClassName = vclGlobalGameInfo.ftxGetSring( vstTR.pHit->v.classname );

				if ( vtxClassName != "player" ) 
				{
					// damage was not from another player;
					//	vclDebugTrace.fvoWriteEventInfo( "Damage was not from another player!" );
					goto locExitDamageReduction;
				}

				if ( !vclPlayer.fboPlayerIsBotByEdict( vstTR.pHit ) )
				{
					// damage was not from a bot;
					// vclDebugTrace.fvoWriteEventInfo( "Damage was not from a bot!" );
					goto locExitDamageReduction;
				}

				locAdjustHealth:
				{
					// damage came from a bot - reduce it accordingly;
					vclDamageMsg.vst_ptrEdict->v.max_health = 
						vinMaxBonus * vclWeapon.fflGetDamageReduction( );

					vclDamageMsg.vst_ptrEdict->v.health = 
						fflMaxOf( vclDamageMsg.vst_ptrEdict->v.health, 
									 vinMaxBonus * vclWeapon.fflGetDamageReduction( ) );
				}
			}
*/

	void tclWeapon::fvoApplyDamageReduction( edict_t* pst_ptrEdict_Source, TraceResult* pst_ptrTR )
	{

		if ( fflGetDamageReduction( ) == cflMinDamageReduction )
		{
			// damage protection is "off";
			return;
		}

		if ( pst_ptrTR->pHit == NULL )
			return;

		if ( pst_ptrTR->flFraction == 1.0 )
		{
			// damage already prevented;
			return;
		}

		if ( pst_ptrEdict_Source == NULL )
		{
			return;
		}

		if ( !vclPlayer.fboPlayerIsBotByEdict( pst_ptrEdict_Source ) )
		{
			// damage must be from a bot;
			return;
		}
		
		// if we get here then player is a bot;

		if ( vclGlobalGameInfo.ftxGetSring( pst_ptrTR->pHit->v.classname ) != "player" )
		// damage must be to a player;
			return;

		// if we get here then a "player" entity is being traced;

		if ( !vclPlayer.fboPlayerIsHumanByEdict( pst_ptrTR->pHit ) )
		// damage must be to a human player;
			return;

		// if Random( 0 .. 99999 ) <= ( 0 .. 99999 ) then
		if ( vflDamageReduction * 99999 >= ( rand( ) % 100000 ) )
		{
			// prevent damage;
			pst_ptrTR->flFraction = 1.0; 
		}
	} // tclWeapon::fvoApplyDamageReduction

	int tclWeapon::finGetWeaponBanPenalty( )
	{
		string vtxPenalty = ftxToLower( ftxCVarGetString( ctxCVar_WeaponBanPenalty ) );

		if ( vtxPenalty == "off" )
			return cinWeaponBanPenalty_off;
		else
		if ( vtxPenalty == "health_reduced" )
			return cinWeaponBanPenalty_health_reduced;
		else
		if ( vtxPenalty == "health_dropped" )
			return cinWeaponBanPenalty_health_dropped;
		else
		if ( vtxPenalty == "timebomb" )
			return cinWeaponBanPenalty_timebomb;
		else
		if ( vtxPenalty == "slap_soft" )
			return cinWeaponBanPenalty_slap_soft;
		else
		if ( vtxPenalty == "slap_hard" )
			return cinWeaponBanPenalty_slap_hard;
		else
		if ( vtxPenalty == "slap_bitch" )
			return cinWeaponBanPenalty_slap_bitch;
		else
		if ( vtxPenalty == "death" )
			return cinWeaponBanPenalty_explode;
		else
		if ( vtxPenalty == "random" )
			return cinWeaponBanPenalty_random;
		else
			return cinWeaponBanPenalty_off;

	} // tclWeapon::finGetWeaponBanPenalty

	int tclWeapon::finGetWeaponBanPenalty_Amount( )
	{
		int vinPenalty = finGetWeaponBanPenalty( );
	
		if ( vinPenalty == cinWeaponBanPenalty_off )
			return finCVarGetInt_Bounded( 
						ctxCVar_WeaponBanPenalty_Amount, 0, 0 );
		else
		if ( vinPenalty == cinWeaponBanPenalty_health_reduced )
			return finCVarGetInt_Bounded( 
						ctxCVar_WeaponBanPenalty_Amount, 1, 99 );
		else
		if ( vinPenalty == cinWeaponBanPenalty_health_dropped )
			return finCVarGetInt_Bounded( 
						ctxCVar_WeaponBanPenalty_Amount, 1, 99 );
		else
		if ( vinPenalty == cinWeaponBanPenalty_timebomb )
			return finCVarGetInt_Bounded( 
						ctxCVar_WeaponBanPenalty_Amount, 1, 180 );
		else
		if ( vinPenalty == cinWeaponBanPenalty_slap_soft )
			return finCVarGetInt_Bounded( 
						ctxCVar_WeaponBanPenalty_Amount, 1, 1000 );
		else
		if ( vinPenalty == cinWeaponBanPenalty_slap_hard )
			return finCVarGetInt_Bounded( 
						ctxCVar_WeaponBanPenalty_Amount, 1, 1000 );
		else
		if ( vinPenalty == cinWeaponBanPenalty_slap_bitch )
			return finCVarGetInt_Bounded( 
						ctxCVar_WeaponBanPenalty_Amount, 1, 1000 );
		else
		if ( vinPenalty == cinWeaponBanPenalty_explode )
			return finCVarGetInt_Bounded( 
						ctxCVar_WeaponBanPenalty_Amount, 0, 0 );
		else
			return 0;

	} // tclWeapon::finGetWeaponBanPenalty_Amount

	void tclWeapon::fvoGetWeaponBanPenaltyAndAmount( int& pinPenalty, int& pinAmount )
	{
		pinPenalty = finGetWeaponBanPenalty( );
		if ( ( pinPenalty == cinWeaponBanPenalty_off )
					|| 
			  ( pinPenalty == cinWeaponBanPenalty_random ) )
		{ 
			pinAmount = 0;
			return;
		}

		pinAmount = finGetWeaponBanPenalty_Amount( );

	}; // tclWeapon::fvoGetWeaponBanPenaltyAndAmount

	void tclWeapon::fvoGetRandomWeaponBanPenaltyAndAmount( int& pinPenalty, int& pinAmount )
	{
		pinPenalty = finRandom( cinWeaponBanPenalty_min, cinWeaponBanPenalty_max );

		if ( pinPenalty == cinWeaponBanPenalty_health_reduced )
			pinAmount = finRandom( 1, 99 );
		else
		if ( pinPenalty == cinWeaponBanPenalty_health_dropped )
			pinAmount = finRandom( 1, 99 );		
		else
		if ( pinPenalty == cinWeaponBanPenalty_timebomb )
			pinAmount = finRandom( 1, 180 );		
		else
		if ( pinPenalty == cinWeaponBanPenalty_slap_soft )
			pinAmount = finRandom( 1, 100 );	
		else
		if ( pinPenalty == cinWeaponBanPenalty_slap_hard )
			pinAmount = finRandom( 1, 100 );	
		else
		if ( pinPenalty == cinWeaponBanPenalty_slap_bitch )
			pinAmount = finRandom( 1, 100 );	
		else
		if ( pinPenalty == cinWeaponBanPenalty_explode )
			pinAmount = 0;
		else
			pinAmount = 0;

	}; // tclWeapon::fvoGetRandomWeaponBanPenaltyAndAmount

	void tclWeapon::fvoExecWeaponBanPenalty( edict_t* pst_ptrEdict )
	{
		
		int vinPenalty;
		int vinPenaltyAmount;

		fvoGetWeaponBanPenaltyAndAmount( vinPenalty, vinPenaltyAmount );

		if ( vinPenalty == cinWeaponBanPenalty_off )
			return;

		if ( vinPenalty == cinWeaponBanPenalty_random )
		{
			fvoGetRandomWeaponBanPenaltyAndAmount( vinPenalty, vinPenaltyAmount );
		}

		int vinUserId;

		if ( vinPenalty == cinWeaponBanPenalty_health_dropped )
		{
			if ( pst_ptrEdict->v.health > vinPenaltyAmount )
			{
				pst_ptrEdict->v.health = vinPenaltyAmount;
				fvoClientPrintChat( pst_ptrEdict, "You have lost health for picking up a banned weapon." );
			}
		}
		else
		if ( vinPenalty == cinWeaponBanPenalty_health_reduced )
		{
			pst_ptrEdict->v.health = finBoundValue( int( pst_ptrEdict->v.health ) - vinPenaltyAmount, 0, 100 );
			fvoClientPrintChat( pst_ptrEdict, "You have lost health for picking up a banned weapon." );
			if ( pst_ptrEdict->v.health <= 0 )
			{	
				fvoKillPlayer( pst_ptrEdict, "" );
			}
		}
		else
		if ( vinPenalty == cinWeaponBanPenalty_timebomb )
		{
			vinUserId = vclPlayer.finGetUserIdByEdict( pst_ptrEdict );
			vclTimeBomb.fboPlantTimeBombOnUser( 
				vinUserId, vinPenaltyAmount, 
				"You have picked up a banned weapon - the penalty is death by timed explosion!" );
		}
		else
		if ( vinPenalty == cinWeaponBanPenalty_slap_soft )
		{
			vinUserId = vclPlayer.finGetUserIdByEdict( pst_ptrEdict );
			vclPlayer.fboSlapPlayerByUserId( 
				vinUserId, false, cinEffect_AdminSlap, vinPenaltyAmount, 
				"You have picked up a banned weapon - fool!" );
		}
		else
		if ( vinPenalty == cinWeaponBanPenalty_slap_hard )
		{
			vinUserId = vclPlayer.finGetUserIdByEdict( pst_ptrEdict );
			vclPlayer.fboSlapPlayerByUserId( 
				vinUserId, true, cinEffect_AdminSlap, vinPenaltyAmount, 
				"You have picked up a banned weapon - fool!" );
		}
		else
		if ( vinPenalty == cinWeaponBanPenalty_slap_bitch )
		{
			vinUserId = vclPlayer.finGetUserIdByEdict( pst_ptrEdict );
			vclPlayer.fboSlapPlayerByUserId( 
				vinUserId, true, cinEffect_BitchSlap, vinPenaltyAmount, 
				"You have picked up a banned weapon - bitch!" );
		}
		else
		if ( vinPenalty == cinWeaponBanPenalty_explode )
		{
			vinUserId = vclPlayer.finGetUserIdByEdict( pst_ptrEdict );
			vclPlayer.fboKillPlayerByUserId( 
				vinUserId, "You have picked up a banned weapon - the penalty is death by explosion!" );
		}

	} // tclWeapon::fvoExecWeaponBanPenalty

// =====================================================
// Weapon List Message
// =====================================================

	tclWeaponListMsg vclWeaponListMsg;

	tclWeaponListMsg::tclWeaponListMsg ( void )
	{
		// Message contents
		vtxWeaponName				= "";
		vinPrimaryAmmoType		= 0;
		vinPrimaryAmmoClip		= 0;
		vinSecondaryAmmoType		= 0;
		vinSecondaryAmmoClip		= 0;
		vinHUDSlot					= 0;
		vinSlotPos					= 0;
		vinWeaponId					= 0;
		vinFlags						= 0;
	}; // tclWeaponListMsg

	void fvoWeaponListMsg_End( void* pclMessage )
	{
		//.begin - capture all values that make up the damage message;
			vclWeaponListMsg.vinMsgType    = static_cast<tclMessage*>(pclMessage)->vinMsgType;
			vclWeaponListMsg.vinMsgDest    = static_cast<tclMessage*>(pclMessage)->vinMsgDest;
			vclWeaponListMsg.vfl_ptrOrigin = static_cast<tclMessage*>(pclMessage)->vfl_ptrOrigin;
			vclWeaponListMsg.vst_ptrEdict  = static_cast<tclMessage*>(pclMessage)->vst_ptrEdict;

			vclWeaponListMsg.vtxWeaponName        = static_cast<tclMessage*>(pclMessage)->vst_aryValueList[  0 ].vtxString;
			vclWeaponListMsg.vinPrimaryAmmoType   = static_cast<tclMessage*>(pclMessage)->vst_aryValueList[  1 ].vinInt;
			vclWeaponListMsg.vinPrimaryAmmoClip   = static_cast<tclMessage*>(pclMessage)->vst_aryValueList[  2 ].vinInt;
			vclWeaponListMsg.vinSecondaryAmmoType = static_cast<tclMessage*>(pclMessage)->vst_aryValueList[  3 ].vinInt;
			vclWeaponListMsg.vinSecondaryAmmoClip = static_cast<tclMessage*>(pclMessage)->vst_aryValueList[  4 ].vinInt;
			vclWeaponListMsg.vinHUDSlot			  = static_cast<tclMessage*>(pclMessage)->vst_aryValueList[  5 ].vinInt;
			vclWeaponListMsg.vinSlotPos           = static_cast<tclMessage*>(pclMessage)->vst_aryValueList[  6 ].vinInt;
			vclWeaponListMsg.vinWeaponId          = static_cast<tclMessage*>(pclMessage)->vst_aryValueList[  7 ].vinInt;
			vclWeaponListMsg.vinFlags             = static_cast<tclMessage*>(pclMessage)->vst_aryValueList[  7 ].vinInt;
		//.end;

		bool vboResult = 
			vclWeapon.fboInitWeapon
				(  vclWeaponListMsg.vtxWeaponName, 
					vclWeaponListMsg.vinPrimaryAmmoType, 
					vclWeaponListMsg.vinPrimaryAmmoClip,
					vclWeaponListMsg.vinSecondaryAmmoType, 
					vclWeaponListMsg.vinSecondaryAmmoClip, 
					vclWeaponListMsg.vinHUDSlot,
					vclWeaponListMsg.vinSlotPos,
					vclWeaponListMsg.vinWeaponId,
					vclWeaponListMsg.vinFlags);

		if ( vboResult == false )
		{
			string vtxMsg = "ERROR: Weapon entity not found in weapons list: " + vclWeaponListMsg.vtxWeaponName;
			fvoServerPrint( vtxMsg + "\n");
			vclDebugTrace.fvoWriteEventInfo(	vtxMsg );
		}

	} // fvoWeaponListMsg_End

// =====================================================
// Weapon Pickup Message
// =====================================================
	
	tclWeaponPickupMsg vclWeaponPickupMsg;

	tclWeaponPickupMsg::tclWeaponPickupMsg ( void )
	{
		vinWeaponId = -1;
	}; // tclWeaponPickupMsg::tclWeaponPickupMsg

	void fvoWeaponPickupMsg_End( void* pclMessage )
	{
		//.begin - capture all values that make up the damage message;
			vclWeaponPickupMsg.vinMsgType    = static_cast<tclMessage*>(pclMessage)->vinMsgType;
			vclWeaponPickupMsg.vinMsgDest    = static_cast<tclMessage*>(pclMessage)->vinMsgDest;
			vclWeaponPickupMsg.vfl_ptrOrigin = static_cast<tclMessage*>(pclMessage)->vfl_ptrOrigin;
			vclWeaponPickupMsg.vst_ptrEdict  = static_cast<tclMessage*>(pclMessage)->vst_ptrEdict;
			vclWeaponPickupMsg.vinWeaponId   = static_cast<tclMessage*>(pclMessage)->vst_aryValueList[0].vinInt;   
		//.end;
		
// vclDebugTrace.fvoWriteEventInfo( "Weapon Pickup: (" + ftxIntToString( vclWeaponPickupMsg.vinWeaponId ) + ")" );

		int vinWeaponIdx = vclWeapon.finFindWeaponById( vclWeaponPickupMsg.vinWeaponId );

		if ( vinWeaponIdx <= 0 )
			return;
		
		if ( vclWeapon.fboWeaponIsBanned_HumanCheckByIndex( vclWeaponPickupMsg.vst_ptrEdict, vinWeaponIdx ) )
		{
			if ( !vclWeapon.fboWeaponIsDefaultByIndex( vinWeaponIdx ) )
			{
				vclWeapon.fvoExecWeaponBanPenalty( vclWeaponPickupMsg.vst_ptrEdict );
			}
		}

	} // fvoWeaponPickupMsg_End

	// ========================================================
	// tclDamageMsg
	// ========================================================

/*
	void tclWeapon::fvoWaypointDrawBeam( 
		edict_t* pst_ptrEdict, 
		Vector pstStart, Vector pstEnd, 
		int pinWidth,
      int pinNoise, 
		int pinRed, int pinGreen, int pinBlue, int pinBrightness, 
		int pinSpeed )
	{
		// MESSAGE_BEGIN(MSG_ONE, SVC_TEMPENTITY, NULL, pEntity);
		
		// fvoMessage_Begin( MSG_BROADCAST, SVC_TEMPENTITY, NULL, pst_ptrEdict );	
		fvoMessage_Begin( MSG_ONE, SVC_TEMPENTITY, NULL, pst_ptrEdict );
		fvoMessage_WriteByte( TE_BEAMPOINTS );
		fvoMessage_WriteCoord( pstStart.x );
		fvoMessage_WriteCoord( pstStart.y );
		fvoMessage_WriteCoord( pstStart.z );
		fvoMessage_WriteCoord( pstEnd.x );
		fvoMessage_WriteCoord( pstEnd.y );
		fvoMessage_WriteCoord( pstEnd.z );
		fvoMessage_WriteShort( vinLineSpriteTexture );
		fvoMessage_WriteByte(  1 );	  // framestart
		fvoMessage_WriteByte( 10 );	  // framerate
		fvoMessage_WriteByte( 10 );     // life in 0.1's
		fvoMessage_WriteByte( pinWidth );  // width
		fvoMessage_WriteByte( pinNoise );  // noise

		fvoMessage_WriteByte( pinRed );    // r, g, b
		fvoMessage_WriteByte( pinGreen );  // r, g, b
		fvoMessage_WriteByte( pinBlue );   // r, g, b

		fvoMessage_WriteByte( pinBrightness );   // brightness
		fvoMessage_WriteByte( pinSpeed );    // speed
		fvoMessage_End( );
	} // tclWeapon::fvoWaypointDrawBeam

*/

	tclDamageMsg vclDamageMsg;

	tclDamageMsg::tclDamageMsg( void )
	{			
		vinByte		= 0;    
		vinDamage	= 0;  
		vinLong		= 0;    
		vstOrigin.x = 0.0;
		vstOrigin.y = 0.0;
		vstOrigin.z = 0.0;
	} // tclDamageMsg::tclDamageMsg

	void fvoDamageMsg_End( void* pclMessage )
	{
		//.begin - capture all values that make up the damage message;
			vclDamageMsg.vinMsgType    = static_cast<tclMessage*>(pclMessage)->vinMsgType;
			vclDamageMsg.vinMsgDest    = static_cast<tclMessage*>(pclMessage)->vinMsgDest;
			vclDamageMsg.vfl_ptrOrigin = static_cast<tclMessage*>(pclMessage)->vfl_ptrOrigin;
			vclDamageMsg.vst_ptrEdict  = static_cast<tclMessage*>(pclMessage)->vst_ptrEdict;
			vclDamageMsg.vinByte       = static_cast<tclMessage*>(pclMessage)->vst_aryValueList[0].vinInt;;    
			vclDamageMsg.vinDamage     = static_cast<tclMessage*>(pclMessage)->vst_aryValueList[1].vinInt;
			vclDamageMsg.vinLong       = static_cast<tclMessage*>(pclMessage)->vst_aryValueList[2].vinInt;    
			vclDamageMsg.vstOrigin.x   = static_cast<tclMessage*>(pclMessage)->vst_aryValueList[3].vflFloat;
			vclDamageMsg.vstOrigin.y   = static_cast<tclMessage*>(pclMessage)->vst_aryValueList[4].vflFloat;
			vclDamageMsg.vstOrigin.z   = static_cast<tclMessage*>(pclMessage)->vst_aryValueList[5].vflFloat;
		//.end;
		
		if ( vclDamageMsg.vinDamage <= 0 )
			return;

		int vinHealth = vclPlayer.finGetPlayerHealthByEdict( vclDamageMsg.vst_ptrEdict );

		if ( vinHealth <= 0 )
		{
			// player is dying so we must stop any sounds in progrss by playing the
			// "death" sound;

			//!!.should find sound by index, not string; need to define standard sound indexes
			//!!.inside the object class;
			string vtxSoundFile = vclSoundCmdList_System.ftxGetSoundFile( ctxDeathSoundCmd );
			if ( vtxSoundFile.empty( ) )
			// if death sound is disabled or unavailable, try the null sound instead;
				vtxSoundFile = vclSoundCmdList_System.ftxGetSoundFile( ctxNullSoundCmd );
			vclPlayer.fboEmitSoundFromPlayerByEdict( vclDamageMsg.vst_ptrEdict, vtxSoundFile, /* pboAliveOnly */ false );
			return;	
		}

		bool vboIsBot = false;
		bool vboBioIsKnown = false; 

		if ( vclBot.fboBotHitEffectIsOn( ) )
		{
			vboIsBot = vclPlayer.fboPlayerIsBotByEdict( vclDamageMsg.vst_ptrEdict );
   		vboBioIsKnown = true;

			if ( vboIsBot )
			{
				if ( vclBot.fboBotHitSparksIsOn( ) )
				{
					vclPlayer.fboEmitSparksFromPlayerByEdict( vclDamageMsg.vst_ptrEdict, vclDamageMsg.vstOrigin );
				}
				
				if ( vclBot.fboBotHitSoundsIsOn( ) )
				{
					if ( rand( ) % 100 > 70 ) 
					{
						//!!. add text speach when bot is fired on;
						//!!. for now I am commenting out the test code for it;
						// if ( random( 2 ) == 0 )
							vclPlayer.fboPlayDamageSound( vclDamageMsg.vst_ptrEdict );
						// else
						//	fvoExecFakeClientCommand( vclDamageMsg.vst_ptrEdict, "say", "fuck you asshole!" );
					}
				}
			}
		} // bot hit effects

		if ( ( rand( ) % 100 ) < finCVarGetInt_Bounded( ctxCVar_TKBotsShootBack, 0, 100 ) )  // > 60 was default
		{
			if ( !vboBioIsKnown )
			{
				vboIsBot = vclPlayer.fboPlayerIsBotByEdict( vclDamageMsg.vst_ptrEdict );
//				vboBioIsKnown = true;
			}

			if ( vboIsBot )
			{

/*
				TraceResult vstTR;
				// find out what hit the player;
				
				TRACE_LINE( 
					vclDamageMsg.vst_ptrEdict->v.origin, 
					vclDamageMsg.vstOrigin, 
					dont_ignore_monsters, 
					vclDamageMsg.vst_ptrEdict, 
					&vstTR );

				if ( vstTR.pHit != NULL )
*/
				if ( vclDamageMsg.vst_ptrEdict->v.dmg_inflictor != NULL )
				{
					// string vtxClassName = vclGlobalGameInfo.ftxGetSring( vstTR.pHit->v.classname );
					string vtxClassName = vclGlobalGameInfo.ftxGetSring( vclDamageMsg.vst_ptrEdict->v.dmg_inflictor->v.classname );
					
					if ( ( vtxClassName == "player" )
								&& 
						  // vclPlayer.fboPlayerIsHumanByEdict( vstTR.pHit )
							vclPlayer.fboPlayerIsHumanByEdict( vclDamageMsg.vst_ptrEdict->v.dmg_inflictor )
								&& 
						  ( vclPlayer.finGetPlayerTeamByEdict( vclDamageMsg.vst_ptrEdict ) 
								 == 
							  // vclPlayer.finGetPlayerTeamByEdict( vstTR.pHit ) 
							 vclPlayer.finGetPlayerTeamByEdict( vclDamageMsg.vst_ptrEdict->v.dmg_inflictor ) 
						  )
						) 
					{
						int vinBotIdx = finGetIndexOfEdict( vclDamageMsg.vst_ptrEdict ); 

						if ( vinBotIdx < cinMinPlayers || vinBotIdx > vclGlobalGameInfo.finGetMaxPlayers( ) )
						{
							// This is an error condition;
							vclDebugTrace.fvoWriteEventInfo( "ERROR (MA_Weapon::fvoDamageMsg_End): Invalid Edict Index (" + ftxIntToString( vinBotIdx ) + ")" );
							return;
						}
						
						vinBotIdx--;

						if ( vinBotIdx > -1 )
						{
							if ( !vclBotControl.vstBotStatus[ vinBotIdx ].fboIsTargeting( ) )
							{
								if ( rand( ) % 100 < finCVarGetInt_Bounded( ctxCVar_TKBotsInsult, 0, 100 ) )
								{
									int vinText = rand( ) % 3;
									if ( vinText == 0 )
										fvoExecFakeClientCommand( vclDamageMsg.vst_ptrEdict, "say", "die you dork" );
									else
									if ( vinText == 1 )
										fvoExecFakeClientCommand( vclDamageMsg.vst_ptrEdict, "say", "eat this you fool!" );
									else
									if ( vinText == 2 )
										fvoExecFakeClientCommand( vclDamageMsg.vst_ptrEdict, "say", "hey leave me alone " + vclPlayer.ftxGetPlayerNameByEdict( vclDamageMsg.vst_ptrEdict->v.dmg_inflictor ) );
								}

								// vclBotControl.vstBotStatus[ vinBotIdx ].
								//	fvoSetNewTarget( vclDamageMsg.vst_ptrEdict, vstTR.pHit ); 
								
								vclBotControl.vstBotStatus[ vinBotIdx ].
									fvoSetNewTarget( vclDamageMsg.vst_ptrEdict, vclDamageMsg.vst_ptrEdict->v.dmg_inflictor ); 
								vclBotControl.vstBotStatus[ vinBotIdx ].vclLastTargetTimer.fvoStart( fflRandomFloat( 5, 15 ) );
							}
						}
					} 
				} // if ( vstTR.pHit != NULL )
			}
		}

/*
		if ( vclWeapon.fflGetDamageReduction( ) != cflMinDamageReduction )
		{
			if ( vclPlayer.fboPlayerIsHumanByEdict( vclDamageMsg.vst_ptrEdict ) )
			{
				//!! vclPlayer.fboEmitBloodFromPlayerByEdict( pst_ptrEdict );

				TraceResult vstTR;
				string vtxClassName;
				int vinMaxBonus = 100;
				if ( vclWeapon.fflGetDamageReduction( ) >= cflMaxDamageReduction )
				{
					// GOD Mode is ON - skip all checks and add maximum health;
					vinMaxBonus = 1000;
					goto locAdjustHealth;
				}

				// find out what hit the player;
				
				TRACE_LINE( 
					vclDamageMsg.vst_ptrEdict->v.origin, 
					vclDamageMsg.vstOrigin, 
					dont_ignore_monsters, 
					vclDamageMsg.vst_ptrEdict, 
					&vstTR );

				if ( vstTR.pHit == NULL )
					goto locExitDamageReduction;

				vtxClassName = vclGlobalGameInfo.ftxGetSring( vstTR.pHit->v.classname );

				if ( vtxClassName != "player" ) 
				{
					// damage was not from another player;
					//	vclDebugTrace.fvoWriteEventInfo( "Damage was not from another player!" );
					goto locExitDamageReduction;
				}

				if ( !vclPlayer.fboPlayerIsBotByEdict( vstTR.pHit ) )
				{
					// damage was not from a bot;
					// vclDebugTrace.fvoWriteEventInfo( "Damage was not from a bot!" );
					goto locExitDamageReduction;
				}

				locAdjustHealth:
				{
					// damage came from a bot - reduce it accordingly;
					vclDamageMsg.vst_ptrEdict->v.max_health = 
						vinMaxBonus * vclWeapon.fflGetDamageReduction( );

					vclDamageMsg.vst_ptrEdict->v.health = 
						fflMaxOf( vclDamageMsg.vst_ptrEdict->v.health, 
									 vinMaxBonus * vclWeapon.fflGetDamageReduction( ) );
				}
			}

			locExitDamageReduction:

		} // Damage Reduction
*/

	} // fvoDamageMsg_End
	
	void fvoDamageMsg_Sent( void *pclMessage )
	{
		return;
/*!! this function has a problem where if th sprite loads the
  !! server wont let people connect.

		if ( vclDamageMsg.vinDamage <= 0 )
			return;

		if ( vclDamageMsg.vst_ptrEdict == NULL )
			return;

		Vector vstEnd;
		
		bool vboResult = vclPlayer.fboGetPlayerOriginByEdict( vclDamageMsg.vst_ptrEdict, vstEnd ); 

	   if ( vboResult == false )
			return;

		if ( vstEnd == vclDamageMsg.vstOrigin )
			return;
*/
//		fvoWaypointDrawBeam( vclDamageMsg.vst_ptrEdict, start, end, 30, 0, 0, 0, 255, 250, 5 );
//vclDamageMsg.vst_ptrEdict

//		fvoWaypointDrawBeam( 
//		/* pst_ptrEdict */ NULL, 
//		/* pstStart     */ vclDamageMsg.vstOrigin, 
//		/* pstEnd       */ vstEnd, 
//		/* pinWidth     */ 30,
//		/* pinNoise     */ 0, 
//		/* pinRed       */ 240,  
//		/* pinGreen     */ 240,  
//		/* pinBlue      */ 240, 
//		/* pinBrightness*/ 250, 
//		/* pinSpeed     */ 5);

	} // fvoDamageMsg_End


	void fvoMsgDeath_End( void* pclMessage )
	{
/*
		//.begin - capture all values that make up the damage message;
			vclWeaponPickupMsg.vinMsgType    = static_cast<tclMessage*>(pclMessage)->vinMsgType;
			vclWeaponPickupMsg.vinMsgDest    = static_cast<tclMessage*>(pclMessage)->vinMsgDest;
			vclWeaponPickupMsg.vfl_ptrOrigin = static_cast<tclMessage*>(pclMessage)->vfl_ptrOrigin;
			vclWeaponPickupMsg.vst_ptrEdict  = static_cast<tclMessage*>(pclMessage)->vst_ptrEdict;
*/

		int vinKillerIdx = vclWeaponPickupMsg.vinWeaponId = static_cast<tclMessage*>(pclMessage)->vst_aryValueList[0].vinInt;   
		int vinVictimIdx = vclWeaponPickupMsg.vinWeaponId = static_cast<tclMessage*>(pclMessage)->vst_aryValueList[1].vinInt;   

		if ( vinKillerIdx == vinVictimIdx )
		{
			return;
		}

		edict_t* vst_Killer = vclPlayer.fst_ptrGetPlayerByIndex( vinKillerIdx );

		if ( vst_Killer == NULL )
		{
			return;
		}

		if ( vclPlayer.fboPlayerIsBotByEdict( vst_Killer ) )
		{
			return;
		}

		edict_t* vst_Victim = vclPlayer.fst_ptrGetPlayerByIndex( vinVictimIdx );

		if ( vst_Victim == NULL )
		{
			return;
		}

		if ( vclPlayer.finGetPlayerTeamByEdict( vst_Killer ) 
					!=  
			  vclPlayer.finGetPlayerTeamByEdict( vst_Victim ) 
			)
		{
			return;
		}

		string vtxKillerName = vclPlayer.ftxGetPlayerNameByEdict( vst_Killer );

		vclHUD.fvoSayWithDelay( "blue", vtxKillerName + " is a team killer!", 1.0 );

		bool vboVictimIsBot = vclPlayer.fboPlayerIsBotByEdict( vst_Victim );

		if ( fboCVarGetBool( ctxCVar_TKBotPunish ) && vboVictimIsBot )
		{
			vclPlayer.fboKillPlayerByEdict( vst_Killer, "" );
		}
		else
		if ( fboCVarGetBool( ctxCVar_TKHumanPunish ) && !vboVictimIsBot )
		{
			vclPlayer.fboKillPlayerByEdict( vst_Killer, "" );
		}

		int vinSlot = vclPlayerSlot.finFindSlotByEdict( vst_Killer );

		if ( !vclPlayerSlot.fboSlotIndexIsValid( vinSlot ) )
		{
			return;
		}

		if ( vboVictimIsBot && fboCVarGetBool( ctxCVar_TKBotBan ) )
		{
			vclPlayerSlot.vcl_aryPlayer[ vinSlot ].vinTKBotCount++; 
		}
		else
		if ( !vboVictimIsBot && fboCVarGetBool( ctxCVar_TKHumanBan ) )
		{
			vclPlayerSlot.vcl_aryPlayer[ vinSlot ].vinTKHumanCount++; 
		}

		if ( finCVarGetInt( ctxCVar_TKBan ) > 0 && vclPlayerSlot.vcl_aryPlayer[ vinSlot ].finTKCount( ) >= finCVarGetInt( ctxCVar_TKBan ) )
		{
			vclPlayerSlot.vcl_aryPlayer[ vinSlot ].vinTKBotCount = 0;
			vclPlayerSlot.vcl_aryPlayer[ vinSlot ].vinTKHumanCount = 0;
			vclPlayer.fboBanPlayerByEdict( vst_Killer, 60, ctxMsgPrefix + "You were banned for excessive team killing." );
			vclHUD.fvoSayWithDelay( "status", ctxMsgPrefix + vtxKillerName + " was banned for team killing by the server", 4.0 );
		}
		else
		if ( finCVarGetInt( ctxCVar_TKBan ) > 0 
					&& 
			  vclPlayerSlot.vcl_aryPlayer[ vinSlot ].finTKCount( ) == ( finCVarGetInt(ctxCVar_TKBan) - 1) )
		{
			vclHUD.fvoSayWithDelay( "blue", vtxKillerName + ", one more TK and you'll be banned", 4.0 );
		}

	} // fvoMsgDeath_End
