//.b 	
//	Copyright 2001 [MEAN].BOT
//	
//	File: MA_time.cpp
//	
//	[MEAN] 
//
//.e	

#include "MA_EngDLLCmd.h"
#include "MA_time.h"

//.begin -----------------------
// Class tclCPUClock Methods

	tclCPUClock::tclCPUClock( )
	{
		vinClock_Cur = 0;
		vinClock_Prev = 0;
		vinClock_RunningTotal = 0;
		vinRollOver_RunningTotal = 0;
	} // tclCPUClock::tclCPUClock

	tinClock_dbl tclCPUClock::finGetClockInTicks( )
	{
		// On error clock returns -1;
		#ifdef __linux__
			vinClock_RunningTotal = defDouble( fflGetEngineTime( ) ) * cinTicksInSec; 
		#else
			vinClock_Cur = clock( );
			if ( vinClock_Cur < 0 )
			{
				// this is an error condition; 
				goto locExit;
			}
			
			if ( vinClock_Prev == vinClock_Cur )
				goto locExit;

			if ( vinClock_Prev > vinClock_Cur )
			{
				// the clock has rolled over;
				vinRollOver_RunningTotal += cinTicksInRollOver;
			}

			vinClock_Prev = vinClock_Cur;
			vinClock_RunningTotal = vinRollOver_RunningTotal + vinClock_Cur;
		#endif

			locExit:
			return vinClock_RunningTotal;

	} // tclCPUClock::finGetClockInTicks

// Class tclCPUClock Methods
//.end --------------------------------------------

#ifdef __linux__
//	#define defGetTime fflGetEngineTime
	#define defGetTime vclCPUClock.fflGetClockInSecs
#else
	#define defGetTime vclCPUClock.fflGetClockInSecs
#endif

	tclCPUClock vclCPUClock;

	tclTimer::tclTimer( void )
	{
		fvoStop( );
	}; // tclTimer::tclSimpleTimer

	void tclTimer::fvoStart( defTimerType pflSeconds )
	{
		// vflTime_Start	= fflGetEngineTime( );
		vflTime_Start	= defGetTime( ); 
		vflTime_Stop	= vflTime_Start + pflSeconds;

	} // tclTimer::fvoStart

	void  tclTimer::fvoStartAddTime( defTimerType pflSeconds )
	{
		fvoStart( fflTimeLeft( ) + pflSeconds );
	} // tclTimer::fvoStartAddTime
	
	void tclTimer::fvoStop( void )
	{
		vflTime_Start	= 0.0;
		vflTime_Stop	= 0.0;

	} // tclTimer::fvoStop
	
	defTimerType tclTimer::fflTimeLeft( void )
	{
		// float vflTime_Left = vflTime_Stop - fflGetEngineTime( );
		defTimerType vflTime_Left = vflTime_Stop - defGetTime( );
		if ( vflTime_Left < 0 )
			vflTime_Left = 0.0;
		
		return vflTime_Left;
	} // tclTimer::fflTimeLeft
	
	defTimerType tclTimer::fflTimeElapsed( void )
	{
		// float vflTime_Elap = fflGetEngineTime( ) - vflTime_Start;
		defTimerType vflTime_Elap = defGetTime( ) - vflTime_Start;
		
		if ( vflTime_Elap < 0 )
			vflTime_Elap = 0.0;
		
		return vflTime_Elap;
	} // tclTimer::fflTimeElapsed

	defTimerType tclTimer::fflTimerSetting( void )
	{
		defTimerType vflTime_Setting = vflTime_Stop - vflTime_Start;
		if ( vflTime_Setting < 0 )
			vflTime_Setting = 0.0;
		
		return vflTime_Setting;
	} // tclTimer::fflTimerSetting

	bool tclTimer::fboTimedOut( void )
	{
		return fflTimeLeft( ) <= 0.0; 
	} // tclTimer::fboTimedOut
