//.b 	
//	Copyright 2001 [MEAN].BOT
//	
//	File: MI_Map.cpp
//	
//	[MEAN] Game Map class definitions.
//
//.e	

#include "MB_Includes.h"	
#include "MA_GlobalVars.h"
#include "MI_Util.h"
#include "MI_Map.h"
#include "MA_EngDLLCmd.h"
#include "MG_Lib.h"
#include "MA_Player.h"
#include "MA_Bot.h"

//#include <iostream.h>
//#include <fstream.h>

	tclMap::tclMap( )
	{
		vst_ptrMapCycle_Cur		= NULL;
		vst_ptrMapCycle_Start	= NULL;

	} // tclMap::tclMap

	tclMap::~tclMap( )
	{
//!! check into why this was removed!
//		fvoDestroyMapList( );

	} // tclMap::~tclMap

	void tclMap::fvoDestroyMapList( void )
	{
		string vtxMsg;
		vclMapLoadTrace.fvoWriteEventInfo( "** SERVER SHUTDOWN - " + ctxVersion + " **");	
		vtxMsg = "Start of remove: ";
		vclDebugTrace.fvoWriteEventInfo( true, vtxMsg );
		
		if ( vst_ptrMapCycle_Start	== NULL )
		// nothing to destroy
			return;

		tstMapCycle* vst_ptrMapCycle_Next;
		vst_ptrMapCycle_Cur = vst_ptrMapCycle_Start;
		do
		{
			vst_ptrMapCycle_Next = vst_ptrMapCycle_Cur->vst_ptrNext;

			vtxMsg = "About to remove: " + vst_ptrMapCycle_Cur->vtxMapName;
			vclDebugTrace.fvoWriteEventInfo( true, vtxMsg );
			delete vst_ptrMapCycle_Cur;
			vst_ptrMapCycle_Cur = vst_ptrMapCycle_Next;
		}
		while ( ( vst_ptrMapCycle_Cur != vst_ptrMapCycle_Start ) 
						&& 
			     ( vst_ptrMapCycle_Cur != NULL ) );
		
		vst_ptrMapCycle_Start = NULL;
		vst_ptrMapCycle_Cur	 = NULL;

		vtxMsg = "End of remove. ";
		vclDebugTrace.fvoWriteEventInfo( true, vtxMsg );

	} // tclMap::fvoDestroyMapList

	float tclMap::fflGetTimeLimitInMin( void )
	{
		return fflCVarGetFloat( "mp_timelimit" );
	} // tclMap::fflGetTimeLimitInMin

	void tclMap::fvoSetTimeLimitInMin( float pflMinutes )
	{
		if ( pflMinutes > ( cflMaxElapsedTimeInSec / 60 ) )
		// do not exceed maximum time limit
			pflMinutes = cflMaxElapsedTimeInSec / 60;

		// reset elapsed time; set to 1 second as a safety
		// feature; setting it to zero may cause unforeseen problems;
		vclGlobalGameInfo.fvoSetElapsedTimeInSec( 1 );

		// set the map time limit
		fvoCVarSetFloat( "mp_timelimit", pflMinutes );

	} // tclMap::fvoSetTimeLimitInMin

	float tclMap::fflGetMapTimeLimitInSec( void )
	{
		return fflGetTimeLimitInMin( ) * 60;

	} // tclMap::fflGetMapTimeLimitInSec

	float tclMap::fflGetMapTimeElapsedInSec( void )
	{
//!! - did not work at all:
//!! float vflTimeElapsedInSec = fflGetEngineTime( ) - vclInterfaceL1.vflTimeOf_MapStart;
		float vflTimeElapsedInSec = vclGlobalGameInfo.fflGetElapsedTimeInSec( );
		if ( vflTimeElapsedInSec <= 0.0 )
			vflTimeElapsedInSec = 0.0;
		return vflTimeElapsedInSec;

	} // tclMap::fflGetMapTimeElapsedInSec

	float tclMap::fflGetMapTimeLeftInSec( void )
	{
	// return map timelimit in seconds.
		float vflTimeLimit = fflGetMapTimeLimitInSec( );

		if ( vflTimeLimit == 0.0 )
			return cinNoMapTimeOut;

		// Calculate time remaining;
		float vflTimeLeftInSec = vflTimeLimit - fflGetMapTimeElapsedInSec( );

		if ( vflTimeLeftInSec < 0.0 )
			return 0.0;

		return vflTimeLeftInSec;

	} // tclMap::fflGetMapTimeLeftInSec

	string tclMap::ftxGetTimeLeftAsString( void ) 
	{
		string vtxTimeLeft;

		int vinTimeLeft = ( int ) fflGetMapTimeLeftInSec( );

		if ( vinTimeLeft == cinNoMapTimeOut )
			return ctxNoMapTimeOut;

	// Calculate minutes and seconds remaining.
		int vinHrsLeft = (int)(vinTimeLeft) / 3600;
		int vinMinLeft = (int)(vinTimeLeft) / 60;
		int vinSecLeft = (int)(vinTimeLeft) % 60;
	// Convert time remaining into a string.
		char vch_aryBuf [255];
		if ( sprintf( vch_aryBuf, "%02d:%02d:%02d", vinHrsLeft, vinMinLeft, vinSecLeft ) <= 0 )
			vtxTimeLeft = "<unavailable>";
		else
			vtxTimeLeft = vch_aryBuf;

		return vtxTimeLeft;
	
	} // tclMap::ftxGetTimeLeftAsString      

	string tclMap::ftxGetMapName (void)
	{
		string vtxMapName = vclGlobalGameInfo.ftxGetMapName ();
		return vtxMapName;

	} // tclMap::ftxGetMapName

	int tclMap::finGetMapId (void)
	{
		if ( vst_ptrMapCycle_Cur == NULL )
			return -1;

		return vst_ptrMapCycle_Cur->vinMapId;

	} // tclMap::finGetMapId

	string tclMap::ftxGetMapCycleFileName( void )
	{
		string vtxMapCycleFileName = 
			ctxGameSubFolder + def_PathBarStr + ftxCVarGetString( "mapcyclefile" );
		return vtxMapCycleFileName;
	} // tclMap::ftxGetMapCycleFileName

	bool tclMap::fboMapCycleFileIsOk( void )
	{
		string vftxMapCycleFileName = ftxGetMapCycleFileName( );

		return fboFileExists( vftxMapCycleFileName ) 
			       && 
			    fboFileCanBeRead( vftxMapCycleFileName );

	} // tclMap::fboMapCycleFileIsOk

	void tclMap::fvoLoadMapCycle( void )
	{
		string vtxMsg;
		string vtxMapCycleFileName = ftxGetMapCycleFileName( );

		vtxMsg  = ctxMsgPrefix + "Loading mapcycle from file:\n  " + vtxMapCycleFileName;		
		fvoServerPrint( vtxMsg + "\n" );
		vclDebugTrace.fvoWriteEventInfo( true, vtxMsg);

		if ( !fboMapCycleFileIsOk( ) )
		{
			vtxMsg  = "...error - cannot read from mapcycle file: " + vtxMapCycleFileName + "\n";
			vtxMsg += ctxMsgPrefix + "Load was aborted due to an error."; 
			fvoServerPrint( vtxMsg + "\n" );
			vclDebugTrace.fvoWriteEventInfo( true, vtxMsg);
			return;
		} 

		FILE* vna_ptrMapCycleFile;
		char vch_aryMapName[ 80 ];

		if ( vst_ptrMapCycle_Start != NULL )
			fvoDestroyMapList( );
		
		vna_ptrMapCycleFile = fopen( vtxMapCycleFileName.c_str( ), "r");

		if ( vna_ptrMapCycleFile == NULL )
		{
			vtxMsg  = "...error - cannot open mapcycle file: " + vtxMapCycleFileName + "\n";
			vtxMsg += ctxMsgPrefix + "Load was aborted due to an error."; 
			fvoServerPrint( vtxMsg + "\n" );
			vclDebugTrace.fvoWriteEventInfo( true, vtxMsg);
			return;
		}

		vst_ptrMapCycle_Start = NULL;
		vst_ptrMapCycle_Cur = NULL;
		tstMapCycle* vst_ptrMapCycle_New;
		tstMapCycle* vst_ptrMapCycle_Prev = NULL;

		int vinLength;
		int vinMapCount = 0;

		while	( fgets( vch_aryMapName, 80, vna_ptrMapCycleFile ) != NULL ) 
		{
			vtxMapCycleFileName = vch_aryMapName;
			vtxMapCycleFileName = ftxTrim( vtxMapCycleFileName );
			fvoToLower( vtxMapCycleFileName );

			if ( vtxMapCycleFileName.empty( ) )
				continue;

			if ( !fboIsMapValid( vtxMapCycleFileName ) )
			{
				vtxMsg  = "...WARNING map not valid: " + vtxMapCycleFileName;
				fvoServerPrint( vtxMsg + "\n" );
				vclDebugTrace.fvoWriteEventInfo( true, vtxMsg);
				continue;
			}

			if ( fboIsMapInCycle( vtxMapCycleFileName ) )
			{
				vtxMsg  = "...WARNING duplicate map loaded: " + vtxMapCycleFileName;
				fvoServerPrint( vtxMsg + "\n" );
				vclDebugTrace.fvoWriteEventInfo( true, vtxMsg);
			}

			vst_ptrMapCycle_New = new tstMapCycle;

			if ( vst_ptrMapCycle_Start == NULL )
				vst_ptrMapCycle_Start = vst_ptrMapCycle_New;
			else
			if ( vst_ptrMapCycle_Prev != NULL )
				vst_ptrMapCycle_Prev->vst_ptrNext = vst_ptrMapCycle_New;
	
			vst_ptrMapCycle_New->vtxMapName  = vtxMapCycleFileName;
			vst_ptrMapCycle_New->vinMapId    = ++vinMapCount;
			vst_ptrMapCycle_New->vst_ptrNext = vst_ptrMapCycle_Start;
			vst_ptrMapCycle_Prev					= vst_ptrMapCycle_New;
//.begin for debugging only
//			vtxMsg  = "...map name loaded: " + vtxMapCycleFileName;
//			fvoServerPrint( vtxMsg + "\n" );
//			vclDebugTrace.fvoWriteEventInfo( true, vtxMsg);
//.end
		}

		fclose( vna_ptrMapCycleFile );

		vtxMsg  = ctxMsgPrefix + "Mapcycle load completed.";		
		fvoServerPrint( vtxMsg + "\n" );
		vclDebugTrace.fvoWriteEventInfo( true, vtxMsg);

	} // tclMap::fvoLoadMapCycle

	tstMapCycle* tclMap::fst_ptrGetNextMap( void )
	{
		if ( vst_ptrMapCycle_Start == NULL )
			return NULL;

		if ( vst_ptrMapCycle_Cur == NULL )
			return vst_ptrMapCycle_Start;

		if ( vst_ptrMapCycle_Cur->vst_ptrNext == NULL )
			return NULL;

		return vst_ptrMapCycle_Cur->vst_ptrNext;

	} // tclMap::fst_ptrGetNextMap

	string tclMap::ftxGetNextMapName( void )
	{

		tstMapCycle* vst_ptrNextMap = fst_ptrGetNextMap( );

		if ( vst_ptrNextMap == NULL )
			return "";

		return vst_ptrNextMap->vtxMapName;

	} // tclMap::ftxGetNextMapName

	void tclMap::fvoMoveToNextMap( string ptxMapName )
	{
		if ( vst_ptrMapCycle_Start == NULL )
			return;
	
		if ( vst_ptrMapCycle_Cur == NULL )
		{
			vst_ptrMapCycle_Cur = vst_ptrMapCycle_Start;
			return;
		}
	
		vst_ptrMapCycle_Cur = vst_ptrMapCycle_Cur->vst_ptrNext;

	} // tclMap::fvoMoveToNextMap

	bool tclMap::fboIsMapInCycle( string ptxMapName )
	{
		if ( vst_ptrMapCycle_Start	== NULL )
		// no maps in cycle
			return false;

		tstMapCycle* vst_ptrMap_Cur = vst_ptrMapCycle_Start;
		
		fvoToLower( ptxMapName );

		do
		{
			if ( vst_ptrMap_Cur->vtxMapName == ptxMapName )
				return true;

			vst_ptrMap_Cur = vst_ptrMap_Cur->vst_ptrNext;
		}
		while ( ( vst_ptrMap_Cur != vst_ptrMapCycle_Start ) 
						&& 
			     ( vst_ptrMap_Cur != NULL ) );
		
		return false;

	} // tclMap::fboIsMapInCycle

	tstMapCycle* tclMap::fst_ptrIsMapInCycle( string ptxMapName )
	{
		if ( vst_ptrMapCycle_Start	== NULL )
		// no maps in cycle
			return NULL;

		tstMapCycle* vst_ptrMap_Cur = vst_ptrMapCycle_Start;
		
		fvoToLower( ptxMapName );

		do
		{
			if ( vst_ptrMap_Cur->vtxMapName == ptxMapName )
				return vst_ptrMap_Cur;

			vst_ptrMap_Cur = vst_ptrMap_Cur->vst_ptrNext;
		}
		while ( ( vst_ptrMap_Cur != vst_ptrMapCycle_Start ) 
						&& 
			     ( vst_ptrMap_Cur != NULL ) );
		
		return NULL;

	} // tclMap::fst_ptrIsMapInCycle

	bool tclMap::fboPositionMapPointer( string ptxMapName )
	{
		tstMapCycle* vst_ptrMap = fst_ptrIsMapInCycle( ptxMapName );

		if ( vst_ptrMap == NULL  )
			return false;
		// set current map pointer to loaded map;
		vst_ptrMapCycle_Cur = vst_ptrMap;
		return true;

	} // tclMap::fboPositionMapPointer

	string tclMap::ftxGetMapNameByMapId( int pinMapId )
	{
		if ( vst_ptrMapCycle_Start	== NULL )
		// no maps in cycle
			return "";

		tstMapCycle* vst_ptrMap_Cur = vst_ptrMapCycle_Start;
		
		do
		{
			if ( vst_ptrMap_Cur->vinMapId == pinMapId )
				return vst_ptrMap_Cur->vtxMapName;

			vst_ptrMap_Cur = vst_ptrMap_Cur->vst_ptrNext;
		}
		while ( ( vst_ptrMap_Cur != vst_ptrMapCycle_Start ) 
						&& 
			     ( vst_ptrMap_Cur != NULL ) );
		
		return "";

	} // tclMap::ftxGetMapNameByMapId

	void tclMap::fvoListMaps( edict_t* pst_ptrEdict )
	{
		string vtxMsg = ctxMsgPrefix + "Map Cycle:";
		fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n\n" );

		if ( vst_ptrMapCycle_Start	== NULL )
		{  // no maps in cycle
			vtxMsg = "  < no maps found >";
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n\n" );
		}
		else
		{
			tstMapCycle* vst_ptrMap_Cur = vst_ptrMapCycle_Start;
	
			do
			{
				vtxMsg  = ftxIntToStringF( vst_ptrMap_Cur->vinMapId, 4, '<', ' ' );
				vtxMsg += ": " + vst_ptrMap_Cur->vtxMapName;
/*
				if ( vst_ptrMap_Cur == vst_ptrMapCycle_Start )
					vtxMsg += " <-( first map )";

				if ( vst_ptrMap_Cur->vst_ptrNext == vst_ptrMapCycle_Start )	
					vtxMsg += " <-( last map )";
*/
				if ( vst_ptrMap_Cur == fst_ptrGetNextMap( ) )	
					vtxMsg += " <-( next map )";

				fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
				vst_ptrMap_Cur = vst_ptrMap_Cur->vst_ptrNext;
			}
			
			while ( ( vst_ptrMap_Cur != vst_ptrMapCycle_Start ) 
							&& 
					  ( vst_ptrMap_Cur != NULL ) );
		}

		vtxMsg = "\n" + ctxMsgPrefix + "End list. Press <pgup>/<pgdn> to view.";
		fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );

	} // tclMap::fvoListMaps

// Define global instance of Map Class object.
	tclMap vclMap;

	tclScenario::tclScenario( )
	{

	} // tclScenario::tclScenario

	tclScenario::~tclScenario( )
	{
		
	} // tclScenario::tclScenario

	void tclScenario::fvoRunScenario( )
	{
		string vtxFilePathName = ctxGameSubFolder + def_PathBarStr + ctxMEANFolder + def_PathBarStr + ctxScenarioFolder + def_PathBarStr + vclMap.ftxGetMapName( ) + ".cfg";
		string vtxNotFoundMessage = "Map " + vclMap.ftxGetMapName( ) + " does not have a scenario file.";
		fvoRunConfigFile( vtxFilePathName, vtxNotFoundMessage, 0.125 );

	} // tclScenario::fvoRunScenario

	tclScenario vclScenario;
